
function[] = apl1(xxx)

%- set xxx case prefix as needed
%xxx = '737';


fname1 = [ xxx , '_1.plt' ] ;
fname2 = [ xxx , '_2.plt' ] ;
fname3 = [ xxx , '_3.plt' ] ;

nl = dlmread(fname1,'',[0 0 0 0]);

nstrings = 3 + 2*nl;
fstring = textread(fname1,'%q',nstrings);

ptitle    = fstring(2,1);
linecolor = char(fstring(3,1));

ix1 = 3+1;
ix2 = 3+nl;
iy1 = 3+nl+1;
iy2 = 3+nl+nl;
xname(1:nl) = fstring(ix1:ix2,1);
yname(1:nl) = fstring(iy1:iy2,1);


dline = dlmread(fname2,'',[0 0 0 2]);
ni = dline(1);
nj = dline(2);
ny = dline(3);

xline = zeros(ni,nj);
yline = zeros(ny,ni,nj);

row2 = 0;
for i=1:ni,
  row1 = row2+1;
  row2 = row1+nj-1;
  block = dlmread(fname2,'',[row1 0 row2 ny]);
  for j=1:nj;
    xline(i,j) = block(j,1);
    yline(1:ny,i,j) = block(j,2:ny+1);
  end
end


%- set plot axis limits

Mmin = 0.55;
Mmax = 0.80;

PFEImin = 0;
PFEImax = 6;

%
Mmin = 0.700001;
Mmax = 0.80;

PFEImin = 4;
PFEImax = 9;
%


ARmin = 5;
ARmax = 25;

Wmin = 0;
Wmax = 2e5;

tocmin = 0.08;
tocmax = 0.16;

CLmin = 0.6;
CLmax = 0.9;



%       write(lu1,1000) '"PFEI    [MJ/kg-km]"'
%       write(lu1,1000) '"2W_f     2W_{fmax}     W_0 [lb]"'
%       write(lu1,1000) '"AR        L/D"'
%       write(lu1,1000) '"CL       CLperp"'
%       write(lu1,1000) '"t/c"'
%
%       write(lu1,1000) '"alt.  [kft]"'
%       write(lu1,1000) '"FPR"'
%       write(lu1,1000) '"BPR"'
%       write(lu1,1000) '"d_{fan}  [in]"'
%       write(lu1,1000) '"W_{eng}  [lb]"'
%
%       write(lu1,1000) '"F_{to}  [lb]"'
%       write(lu1,1000) '"l_{unstick}   l_{clear}   [ft]"'
%       write(lu1,1000) '"sin(gamma)  "'
%       write(lu1,1000) '"V_{to}  [kt]"'
%       write(lu1,1000) '"u_{fan}   u_{core}    [m/s]"'
%
%      write(lu2,2100) 
%     &  Mach,
%     &  PFEI*0.001,       ! 1
%     &  2.0*Wfuel*lb_N,   ! 2
%     &  2.0*Wfmax*lb_N,   ! 3
%     &  W*lb_N,           ! 4
%     &  AR,               ! 5
%     &  LoD,              ! 6
%     &  hbox,             ! 7
%     &  CL,               ! 8
%     &  CLperp,           ! 9
%     &  altkm*ft_m,       !10
%     &  pif,              !11
%     &  BPR,              !12
%     &  dfan*in_m,        !13
%     &  Weng*lb_N,        !14
%     &  Fto*lb_N,         !15
%     &  lVto*ft_m,        !16
%     &  lto*ft_m,         !17
%     &  sing,             !18
%     &  Vto*nmi_m*3600.0, !19
%     &  u6to,             !20
%     &  u8to              !21

subplot(231);
iplot = 1;
line = 1;
for i=1:ni,
  x(1,:) = xline(i,:);
  y(1,:) = yline(line,i,:);
  lc = linecolor(i);
  plot(x,y,lc);
  hold on
end
grid on;
axis([Mmin Mmax PFEImin PFEImax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
title(ptitle);
hold off

% subplot(232)  is the geometry plot, farther below

subplot(233);
iplot = 3;
line1 = 5;
line2 = 6;
for i=1:ni,
  x(1,:) = xline(i,:);

  y(1,:) = yline(line1,i,:);
  lc = [ linecolor(i) , '-' ];
  plot(x,y,lc);
  hold on

  y(1,:) = yline(line2,i,:);
  lc = [ linecolor(i) , '--' ];
  plot(x,y,lc);
end
grid on;
axis([Mmin Mmax ARmin ARmax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
hold off

subplot(234);
iplot = 2;
line1 = 2;
line2 = 3;
line3 = 4;
for i=1:ni,
  x(1,:) = xline(i,:);

  y(1,:) = yline(line1,i,:);
  lc = [ linecolor(i) , '-' ];
  plot(x,y,lc);
  hold on

  y(1,:) = yline(line2,i,:);
  lc = [ linecolor(i) , ':' ];
  plot(x,y,lc,'MarkerSize',2);

  y(1,:) = yline(line3,i,:);
  lc = linecolor(i);
  plot(x,y,lc);
end
grid on;
axis([Mmin Mmax Wmin Wmax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
hold off



subplot(235);
iplot = 5;
line = 7;
for i=1:ni,
  x(1,:) = xline(i,:);
  y(1,:) = yline(line,i,:);
  lc = linecolor(i);
  plot(x,y,lc);
  hold on
end
grid on;
axis([Mmin Mmax tocmin tocmax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
hold off

subplot(236);
iplot = 4;
line1 = 8;
line2 = 9;
for i=1:ni,
  x(1,:) = xline(i,:);

  y(1,:) = yline(line1,i,:);
  lc = [ linecolor(i) , '-' ];
  plot(x,y,lc);
  hold on

  y(1,:) = yline(line2,i,:);
  lc = [ linecolor(i) , '--' ];
  plot(x,y,lc);
end
grid on;
axis([Mmin Mmax CLmin CLmax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
hold off

row = 0;
dline = dlmread(fname3,'',[row 0 row 5]);
nixy = dline(1);
njxy = dline(2);
nw   = dline(3);
nh   = dline(4);
nf   = dline(5);
ne   = dline(6);

%           3           7           6           4           7

xw = zeros(nw,nixy,njxy);
yw = zeros(nw,nixy,njxy);
xh = zeros(nh,nixy,njxy);
yh = zeros(nh,nixy,njxy);
xf = zeros(nf,nixy,njxy);
yf = zeros(nf,nixy,njxy);
xe = zeros(ne,nixy,njxy);
ye = zeros(ne,nixy,njxy);


row2 = row;
for i=1:nixy,
for j=1:njxy,
  row1 = row2+1;
  row2 = row1+nw-1;
  block = dlmread(fname3,'',[row1 0 row2 1]);
  xw(1:nw,i,j) = block(1:nw,1);
  yw(1:nw,i,j) = block(1:nw,2);

  row1 = row2+1;
  row2 = row1+nh-1;
  block = dlmread(fname3,'',[row1 0 row2 1]);
  xh(1:nh,i,j) = block(1:nh,1);
  yh(1:nh,i,j) = block(1:nh,2);

  row1 = row2+1;
  row2 = row1+nf-1;
  block = dlmread(fname3,'',[row1 0 row2 1]);
  xf(1:nf,i,j) = block(1:nf,1);
  yf(1:nf,i,j) = block(1:nf,2);

  row1 = row2+1;
  row2 = row1+ne-1;
  block = dlmread(fname3,'',[row1 0 row2 1]);
  xe(1:ne,i,j) = block(1:ne,1);
  ye(1:ne,i,j) = block(1:ne,2);
end
end


subplot(232);
for i=1:nixy,
  for j=1:njxy,
    axis equal
    lc = linecolor(i);
    plot(yw(:,i,j),-xw(:,i,j),lc, ...
         yh(:,i,j),-xh(:,i,j),lc, ...
         yf(:,i,j),-xf(:,i,j),lc, ...
         ye(:,i,j),-xe(:,i,j),lc );
    hold on;
  end
end
grid on;
xlabel('ft');
ylabel('ft');
hold off;



