
function[] = apl2(xxx)

fname1 = [ xxx , '_1.plt' ] ;
fname2 = [ xxx , '_2.plt' ] ;
fname3 = [ xxx , '_3.plt' ] ;

nl = dlmread(fname1,'',[0 0 0 0]);

nstrings = 3 + 2*nl;
fstring = textread(fname1,'%q',nstrings);

ptitle    = fstring(2,1);
linecolor = char(fstring(3,1));

ix1 = 3+1;
ix2 = 3+nl;
iy1 = 3+nl+1;
iy2 = 3+nl+nl;
xname(1:nl) = fstring(ix1:ix2,1);
yname(1:nl) = fstring(iy1:iy2,1);


dline = dlmread(fname2,'',[0 0 0 2]);
ni = dline(1);
nj = dline(2);
ny = dline(3);

xline = zeros(ni,nj);
yline = zeros(ny,ni,nj);

row2 = 0;
for i=1:ni,
  row1 = row2+1;
  row2 = row1+nj-1;
  block = dlmread(fname2,'',[row1 0 row2 ny]);
  for j=1:nj;
    xline(i,j) = block(j,1);
    yline(1:ny,i,j) = block(j,2:ny+1);
  end
end


%- set plot axis limits

Mmin = 0.65001;
Mmax = 0.80;

PFEImin = 4;
PFEImax = 8;

FPRmin = 1.2;
FPRmax = 2.0;

BPRmin = 5;
BPRmax = 20;

dfanmin = 40;
dfanmax = 70;

Wengmin = 0.5e4;
Wengmax = 2e4;

altmin = 30;
altmax = 45;


%       write(lu1,1000) '"E_{sp}  [lb JP4/pax-nmi]"'
%       write(lu1,1000) '"2W_f     2W_{fmax}     W_0 [lb]"'
%       write(lu1,1000) '"AR        L/D"'
%       write(lu1,1000) '"CL       CLperp"'
%       write(lu1,1000) '"t/c"'
%
%       write(lu1,1000) '"alt.  [kft]"'
%       write(lu1,1000) '"FPR"'
%       write(lu1,1000) '"BPR"'
%       write(lu1,1000) '"d_{fan}  [in]"'
%       write(lu1,1000) '"W_{eng}  [lb]"'
%
%       write(lu1,1000) '"F_{to}  [lb]"'
%       write(lu1,1000) '"l_{unstick}   l_{clear}   [ft]"'
%       write(lu1,1000) '"sin(gamma)  "'
%       write(lu1,1000) '"V_{to}  [kt]"'
%       write(lu1,1000) '"u_{fan}   u_{core}    [m/s]"'
%
%      write(lu2,2100) 
%     &  Mach,
%     &  Espec*lb_N/nmi_m, ! 1
%     &  2.0*Wfuel*lb_N,   ! 2
%     &  2.0*Wfmax*lb_N,   ! 3
%     &  W*lb_N,           ! 4
%     &  AR,               ! 5
%     &  LoD,              ! 6
%     &  hbox,             ! 7
%     &  CL,               ! 8
%     &  CLperp,           ! 9
%     &  altkm*ft_m,       !10
%     &  pif,              !11
%     &  BPR,              !12
%     &  dfan*in_m,        !13
%     &  Weng*lb_N,        !14
%     &  Fto*lb_N,         !15
%     &  lVto*ft_m,        !16
%     &  lto*ft_m,         !17
%     &  sing,             !18
%     &  Vto*nmi_m*3600.0, !19
%     &  u6to,             !20
%     &  u8to              !21



subplot(231);
iplot = 1;
line = 1;
for i=1:ni,
  x(1,:) = xline(i,:);
  y(1,:) = yline(line,i,:);
  lc = linecolor(i);
  plot(x,y,lc);
  hold on
end
grid on;
axis([Mmin Mmax PFEImin PFEImax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
title(ptitle);
hold off

subplot(232);
iplot = 7;
line = 11;
for i=1:ni,
  x(1,:) = xline(i,:);
  y(1,:) = yline(line,i,:);
  lc = linecolor(i);
  plot(x,y,lc);
  hold on
end
grid on;
axis([Mmin Mmax FPRmin FPRmax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
hold off

subplot(233);
iplot = 8;
line = 12;
for i=1:ni,
  x(1,:) = xline(i,:);
  y(1,:) = yline(line,i,:);
  lc = linecolor(i);
  plot(x,y,lc);
  hold on
end
grid on;
axis([Mmin Mmax BPRmin BPRmax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
hold off

subplot(234);
iplot = 9;
line = 13;
for i=1:ni,
  x(1,:) = xline(i,:);
  y(1,:) = yline(line,i,:);
  lc = linecolor(i);
  plot(x,y,lc);
  hold on
end
grid on;
axis([Mmin Mmax dfanmin dfanmax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
hold off


subplot(235);
iplot = 10;
line = 14;
for i=1:ni,
  x(1,:) = xline(i,:);
  y(1,:) = yline(line,i,:);
  lc = linecolor(i);
  plot(x,y,lc);
  hold on
end
grid on;
axis([Mmin Mmax Wengmin Wengmax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
hold off


subplot(236);
iplot = 6;
line = 10;
for i=1:ni,
  x(1,:) = xline(i,:);
  y(1,:) = yline(line,i,:);
  lc = linecolor(i);
  plot(x,y,lc);
  hold on
end
grid on;
axis([Mmin Mmax altmin altmax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
hold off

