
function[] = apl4(xxx)

fname1 = [ xxx , '_1.plt' ] ;
fname2 = [ xxx , '_2.plt' ] ;
fname3 = [ xxx , '_3.plt' ] ;

nl = dlmread(fname1,'',[0 0 0 0]);

nstrings = 3 + 2*nl;
fstring = textread(fname1,'%q',nstrings);

ptitle    = fstring(2,1);
linecolor = char(fstring(3,1));

ix1 = 3+1;
ix2 = 3+nl;
iy1 = 3+nl+1;
iy2 = 3+nl+nl;
xname(1:nl) = fstring(ix1:ix2,1);
yname(1:nl) = fstring(iy1:iy2,1);


dline = dlmread(fname2,'',[0 0 0 2]);
ni = dline(1);
nj = dline(2);
ny = dline(3);

xline = zeros(ni,nj);
yline = zeros(ny,ni,nj);

row2 = 0;
for i=1:ni,
  row1 = row2+1;
  row2 = row1+nj-1;
  block = dlmread(fname2,'',[row1 0 row2 ny]);
  for j=1:nj;
    xline(i,j) = block(j,1);
    yline(1:ny,i,j) = block(j,2:ny+1);
  end
end


% set plot axis limits

Mmin = 0.65;
Mmax = 0.80001;

PFEImin = 4;
PFEImax = 8;

BPRcmin = 0.0;
BPRcmax = 0.25;

umin = 200;
umax = 600;

FTOmin = 2e4;
FTOmax = 6e4;

T4min = 1200;
T4max = 2000;

dBmin = 50;
dBmax = 100;


%    iplot:
%     1  write(lu1,1000) '"E_{sp}  [lb JP4/pax-nmi]"'
%     2  write(lu1,1000) '"2W_f      2W_{fmax}      W_0 [lb]"'
%     3  write(lu1,1000) '"AR             L/D"'
%     4  write(lu1,1000) '"CL           CLperp"'
%     5  write(lu1,1000) '"t/c"'
%     6  write(lu1,1000) '"alt.  [kft]"'
%     7  write(lu1,1000) '"FPR"'
%     8  write(lu1,1000) '"BPR"'
%     9  write(lu1,1000) '"d_{fan}  [in]"'
%    10  write(lu1,1000) '"W_{eng}  [lb]"'
%    11  write(lu1,1000) '"F_{to}  [lb]"'
%    12  write(lu1,1000) '"l_{unstick}     l_{clear}   [ft]"'
%    13  write(lu1,1000) '"sin(gamma)  "'
%    14  write(lu1,1000) '"V_{to}  [kt]"'
%    15  write(lu1,1000) '"u_{fan}      u_{core}    [m/s]"'
%    16   write(lu1,1000) '"dB_{FO}      dB_{CB}      dB_{SL}"'
%    17   write(lu1,1000) '"T_{4 CR}         T_{4 TO}  [K]"'
%    18   write(lu1,1000) '"BPR_{cool}"'
%
%    iline:
%     &  Mach,
%     &  Espec*lb_N/nmi_m, ! 1
%     &  2.0*Wfuel*lb_N,   ! 2
%     &  2.0*Wfmax*lb_N,   ! 3
%     &  W*lb_N,           ! 4
%     &  AR,               ! 5
%     &  LoD,              ! 6
%     &  hbox,             ! 7
%     &  CL,               ! 8
%     &  CLperp,           ! 9
%     &  altkm*ft_m,       !10
%     &  pif,              !11
%     &  BPR,              !12
%     &  dfan*in_m,        !13
%     &  Weng*lb_N,        !14
%     &  Fto*lb_N,         !15
%     &  lVto*ft_m,        !16
%     &  lto*ft_m,         !17
%     &  sing,             !18
%     &  Vto*nmi_m*3600.0, !19
%     &  u6to,             !20
%     &  u8to              !21
%     &  parg(igdBSL),             !22
%     &  parg(igdBCB),             !23
%     &  parg(igdBFO),             !24
%     &  pare(ieBPRc,iptakeoff),   !25
%     &  pare(ieTt4,iptakeoff),    !26
%     &  pare(ieTt4,ipcruise1)     !27

subplot(231);
iplot = 1;
line = 1;
for i=1:ni,
  x(1,:) = xline(i,:);
  y(1,:) = yline(line,i,:);
  lc = linecolor(i);
  plot(x,y,lc);
  hold on
end
grid on;
axis([Mmin Mmax PFEImin PFEImax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
title(ptitle);
hold off

subplot(232);
iplot = 18;
line = 25;
for i=1:ni,
  x(1,:) = xline(i,:);
  y(1,:) = yline(line,i,:);
  lc = linecolor(i);
  plot(x,y,lc);
  hold on
end
grid on;
axis([Mmin Mmax BPRcmin BPRcmax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
hold off

subplot(233);
iplot = 15;
line1 = 20;
line2 = 21;
for i=1:ni,
  x(1,:) = xline(i,:);

  y(1,:) = yline(line1,i,:);
  lc = [ linecolor(i) , '-' ];
  plot(x,y,lc);
  hold on

  y(1,:) = yline(line2,i,:);
  lc = [ linecolor(i) , '--' ];
  plot(x,y,lc);
end
grid on;
axis([Mmin Mmax umin umax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
hold off


subplot(234);
iplot = 11;
line = 15;
for i=1:ni,
  x(1,:) = xline(i,:);
  y(1,:) = yline(line,i,:);
  lc = linecolor(i);
  plot(x,y,lc);
  hold on
end
grid on;
axis([Mmin Mmax FTOmin FTOmax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
hold off


subplot(235);
iplot = 17;
line1 = 26;
line2 = 27;
for i=1:ni,
  x(1,:) = xline(i,:);

  y(1,:) = yline(line1,i,:);
  lc = [ linecolor(i) , '-' ];
  plot(x,y,lc);
  hold on

  y(1,:) = yline(line2,i,:);
  lc = [ linecolor(i) , '--' ];
  plot(x,y,lc);
end
grid on;
axis([Mmin Mmax T4min T4max]);
xlabel(xname(iplot));
ylabel(yname(iplot));
hold off


subplot(236);
iplot = 16;
line1 = 22;
line2 = 23;
line2 = 24;
for i=1:ni,
  x(1,:) = xline(i,:);

  y(1,:) = yline(line1,i,:);
  lc = [ linecolor(i) , '-' ];
  plot(x,y,lc);
  hold on

  y(1,:) = yline(line2,i,:);
  lc = [ linecolor(i) , '--' ];
  plot(x,y,lc);

  y(1,:) = yline(line2,i,:);
  lc = [ linecolor(i) , ':' ];
  plot(x,y,lc);
end
grid on;
axis([Mmin Mmax dBmin dBmax]);
xlabel(xname(iplot));
ylabel(yname(iplot));
hold off

