C------------------------------------------------------------------------
C     Defines spanwise-variable names, and their pointers for 
C     referencing the various spanwise-spline arrays QB, QBT, TB, etc.
C
C     The KBREAK=1 flag indicates that the variable will cause
C     a zero-length interval to be inserted anywhere that variable 
C     has a doubled t-value in its definition in the xxx.asw file.
C     This should be selected only for the geometric variables
C     x,y,z,twist, plus any variable which might have a discontinuity
C     in it, such as the flap variables dCLdF1.. , and the added-mass
C     variables Dmgcc, Dmg, etc.
C
C     The dCLdF1,dCLdF2... indices must be sequential
C     The dCMdF1,dCMdF2... indices must be sequential
C     The dCDdF1,dCDdF2... indices must be sequential
C------------------------------------------------------------------------
C
C---- total number of beam parameters defined below
C-    NOTE! If changing JBTOT, must also...
C-      ... set JBX in DIMEN.INC
C-      ... set JDIM in iosubs.f  (two places)
      PARAMETER(JBTOT = 102)
C
C---- last parameter which pertains to fuselage beams
C-    (parameters JBFUSE+1..JBTOT pertain only to lifting-surface beams)
      PARAMETER(JBFUSE = 35)
C
      CHARACTER*11 VARS(0:JBTOT)
      INTEGER KBREAK(0:JBTOT)
      DATA
     &  VARS( 0) /'      s    '/ , JSA   /  0 / , KBREAK( 0) / 0 / ,
     &  VARS( 1) /'      x    '/ , JXA   /  1 / , KBREAK( 1) / 1 / ,
     &  VARS( 2) /'      y    '/ , JYA   /  2 / , KBREAK( 2) / 1 / ,
     &  VARS( 3) /'      z    '/ , JZA   /  3 / , KBREAK( 3) / 1 / ,
     &  VARS( 4) /'    twist  '/ , JTW   /  4 / , KBREAK( 4) / 1 / ,
     &  VARS( 5) /'     EIcc  '/ , JECC  /  5 / , KBREAK( 5) / 1 / ,
     &  VARS( 6) /'     EInn  '/ , JENN  /  6 / , KBREAK( 6) / 1 / ,
     &  VARS( 7) /'     EIcn  '/ , JECN  /  7 / , KBREAK( 7) / 1 / ,
     &  VARS( 8) /'     EIcs  '/ , JECS  /  8 / , KBREAK( 8) / 0 / ,
     &  VARS( 9) /'     EIsn  '/ , JESN  /  9 / , KBREAK( 9) / 0 / ,
     &  VARS(10) /'      GJ   '/ , JGJ   / 10 / , KBREAK(10) / 1 / ,
     &  VARS(11) /'      EA   '/ , JEA   / 11 / , KBREAK(11) / 0 / ,
     &  VARS(12) /'      GKc  '/ , JGKC  / 12 / , KBREAK(12) / 0 / ,
     &  VARS(13) /'      GKn  '/ , JGKN  / 13 / , KBREAK(13) / 0 / ,
     &  VARS(14) /'     mgcc  '/ , JMCC1 / 14 / , KBREAK(14) / 0 / ,
     &  VARS(15) /'     mgnn  '/ , JMNN1 / 15 / , KBREAK(15) / 0 / ,
     &  VARS(16) /'      mg   '/ , JMG1  / 16 / , KBREAK(16) / 1 / ,
     &  VARS(17) /'     Ccg   '/ , JCCG1 / 17 / , KBREAK(17) / 0 / ,
     &  VARS(18) /'     Ncg   '/ , JNCG1 / 18 / , KBREAK(18) / 0 / ,
     &  VARS(19) /'    Dmgcc  '/ , JMCC2 / 19 / , KBREAK(19) / 1 / ,
     &  VARS(20) /'    Dmgnn  '/ , JMNN2 / 20 / , KBREAK(20) / 1 / ,
     &  VARS(21) /'     Dmg   '/ , JMG2  / 21 / , KBREAK(21) / 1 / ,
     &  VARS(22) /'    DCcg   '/ , JCCG2 / 22 / , KBREAK(22) / 1 / ,
     &  VARS(23) /'    DNcg   '/ , JNCG2 / 23 / , KBREAK(23) / 1 / ,
     &  VARS(24) /'     Cea   '/ , JCEA  / 24 / , KBREAK(24) / 0 / ,
     &  VARS(25) /'     Nea   '/ , JNEA  / 25 / , KBREAK(25) / 0 / ,
     &  VARS(26) /'     Cta   '/ , JCTA  / 26 / , KBREAK(26) / 0 / ,
     &  VARS(27) /'     Nta   '/ , JNTA  / 27 / , KBREAK(27) / 0 / ,
     &  VARS(28) /'    tdeps  '/ , JTDE  / 28 / , KBREAK(28) / 0 / ,
     &  VARS(29) /'    tdgam  '/ , JTDG  / 29 / , KBREAK(29) / 0 / ,
     &  VARS(30) /'   Cshell  '/ , JCSH  / 30 / , KBREAK(30) / 1 / ,
     &  VARS(31) /'   Nshell  '/ , JNSH  / 31 / , KBREAK(31) / 1 / ,
     &  VARS(32) /'  Atshell  '/ , JASH  / 32 / , KBREAK(32) / 1 / ,
     &  VARS(33) /'   radius  '/ , JRAD  / 33 / , KBREAK(33) / 0 / ,
     &  VARS(34) /'     Cdf   '/ , JCDF  / 34 / , KBREAK(34) / 0 / ,
     &  VARS(35) /'     Cdp   '/ , JCDP  / 35 / , KBREAK(35) / 0 / ,
     &  VARS(36) /'    chord  '/ , JCH   / 36 / , KBREAK(36) / 1 / ,
     &  VARS(37) /'     Xax   '/ , JXAX  / 37 / , KBREAK(37) / 1 / ,
     &  VARS(38) /'    alpha  '/ , JAL   / 38 / , KBREAK(38) / 1 / ,
     &  VARS(39) /'      Cm   '/ , JCM   / 39 / , KBREAK(39) / 1 / ,
     &  VARS(40) /'    CLmax  '/ , JCMX  / 40 / , KBREAK(40) / 0 / ,
     &  VARS(41) /'    CLmin  '/ , JCMN  / 41 / , KBREAK(41) / 0 / ,
     &  VARS(42) /'    dCLda  '/ , JDCL  / 42 / , KBREAK(42) / 0 / ,
     &  VARS(43) /'   dCLdF1  '/ , JCLF1 / 43 / , KBREAK(43) / 1 / ,
     &  VARS(44) /'   dCLdF2  '/ , JCLF2 / 44 / , KBREAK(44) / 1 / ,
     &  VARS(45) /'   dCLdF3  '/ , JCLF3 / 45 / , KBREAK(45) / 1 / ,
     &  VARS(46) /'   dCLdF4  '/ , JCLF4 / 46 / , KBREAK(46) / 1 / ,
     &  VARS(47) /'   dCLdF5  '/ , JCLF5 / 47 / , KBREAK(47) / 1 / ,
     &  VARS(48) /'   dCLdF6  '/ , JCLF6 / 48 / , KBREAK(48) / 1 / ,
     &  VARS(49) /'   dCLdF7  '/ , JCLF7 / 49 / , KBREAK(49) / 1 / ,
     &  VARS(50) /'   dCLdF8  '/ , JCLF8 / 50 / , KBREAK(50) / 1 / ,
     &  VARS(51) /'   dCLdF9  '/ , JCLF9 / 51 / , KBREAK(51) / 1 / ,
     &  VARS(52) /'   dCLdF10 '/ , JCLF10/ 52 / , KBREAK(52) / 1 / ,
     &  VARS(53) /'   dCLdF11 '/ , JCLF11/ 53 / , KBREAK(53) / 1 / ,
     &  VARS(54) /'   dCLdF12 '/ , JCLF12/ 54 / , KBREAK(54) / 1 / ,
     &  VARS(55) /'   dCLdF13 '/ , JCLF13/ 55 / , KBREAK(55) / 1 / ,
     &  VARS(56) /'   dCLdF14 '/ , JCLF14/ 56 / , KBREAK(56) / 1 / ,
     &  VARS(57) /'   dCLdF15 '/ , JCLF15/ 57 / , KBREAK(57) / 1 / ,
     &  VARS(58) /'   dCLdF16 '/ , JCLF16/ 58 / , KBREAK(58) / 1 / ,
     &  VARS(59) /'   dCLdF17 '/ , JCLF17/ 59 / , KBREAK(59) / 1 / ,
     &  VARS(60) /'   dCLdF18 '/ , JCLF18/ 60 / , KBREAK(60) / 1 / ,
     &  VARS(61) /'   dCLdF19 '/ , JCLF19/ 61 / , KBREAK(61) / 1 / ,
     &  VARS(62) /'   dCLdF20 '/ , JCLF20/ 62 / , KBREAK(62) / 1 / ,
     &  VARS(63) /'   dCMdF1  '/ , JCMF1 / 63 / , KBREAK(63) / 1 / ,
     &  VARS(64) /'   dCMdF2  '/ , JCMF2 / 64 / , KBREAK(64) / 1 / ,
     &  VARS(65) /'   dCMdF3  '/ , JCMF3 / 65 / , KBREAK(65) / 1 / ,
     &  VARS(66) /'   dCMdF4  '/ , JCMF4 / 66 / , KBREAK(66) / 1 / ,
     &  VARS(67) /'   dCMdF5  '/ , JCMF5 / 67 / , KBREAK(67) / 1 / ,
     &  VARS(68) /'   dCMdF6  '/ , JCMF6 / 68 / , KBREAK(68) / 1 / ,
     &  VARS(69) /'   dCMdF7  '/ , JCMF7 / 69 / , KBREAK(69) / 1 / ,
     &  VARS(70) /'   dCMdF8  '/ , JCMF8 / 70 / , KBREAK(70) / 1 / ,
     &  VARS(71) /'   dCMdF9  '/ , JCMF9 / 71 / , KBREAK(71) / 1 / ,
     &  VARS(72) /'   dCMdF10 '/ , JCMF10/ 72 / , KBREAK(72) / 1 / ,
     &  VARS(73) /'   dCMdF11 '/ , JCMF11/ 73 / , KBREAK(73) / 1 / ,
     &  VARS(74) /'   dCMdF12 '/ , JCMF12/ 74 / , KBREAK(74) / 1 / ,
     &  VARS(75) /'   dCMdF13 '/ , JCMF13/ 75 / , KBREAK(75) / 1 / ,
     &  VARS(76) /'   dCMdF14 '/ , JCMF14/ 76 / , KBREAK(76) / 1 / ,
     &  VARS(77) /'   dCMdF15 '/ , JCMF15/ 77 / , KBREAK(77) / 1 / ,
     &  VARS(78) /'   dCMdF16 '/ , JCMF16/ 78 / , KBREAK(78) / 1 / ,
     &  VARS(79) /'   dCMdF17 '/ , JCMF17/ 79 / , KBREAK(79) / 1 / ,
     &  VARS(80) /'   dCMdF18 '/ , JCMF18/ 80 / , KBREAK(80) / 1 / ,
     &  VARS(81) /'   dCMdF19 '/ , JCMF19/ 81 / , KBREAK(81) / 1 / ,
     &  VARS(82) /'   dCMdF20 '/ , JCMF20/ 82 / , KBREAK(82) / 1 / ,
     &  VARS(83) /'   dCDdF1  '/ , JCDF1 / 83 / , KBREAK(83) / 1 / ,
     &  VARS(84) /'   dCDdF2  '/ , JCDF2 / 84 / , KBREAK(84) / 1 / ,
     &  VARS(85) /'   dCDdF3  '/ , JCDF3 / 85 / , KBREAK(85) / 1 / ,
     &  VARS(86) /'   dCDdF4  '/ , JCDF4 / 86 / , KBREAK(86) / 1 / ,
     &  VARS(87) /'   dCDdF5  '/ , JCDF5 / 87 / , KBREAK(87) / 1 / ,
     &  VARS(88) /'   dCDdF6  '/ , JCDF6 / 88 / , KBREAK(88) / 1 / ,
     &  VARS(89) /'   dCDdF7  '/ , JCDF7 / 89 / , KBREAK(89) / 1 / ,
     &  VARS(90) /'   dCDdF8  '/ , JCDF8 / 90 / , KBREAK(90) / 1 / ,
     &  VARS(91) /'   dCDdF9  '/ , JCDF9 / 91 / , KBREAK(91) / 1 / ,
     &  VARS(92) /'   dCDdF10 '/ , JCDF10/ 92 / , KBREAK(92) / 1 / ,
     &  VARS(93) /'   dCDdF11 '/ , JCDF11/ 93 / , KBREAK(93) / 1 / ,
     &  VARS(94) /'   dCDdF12 '/ , JCDF12/ 94 / , KBREAK(94) / 1 / ,
     &  VARS(95) /'   dCDdF13 '/ , JCDF13/ 95 / , KBREAK(95) / 1 / ,
     &  VARS(96) /'   dCDdF14 '/ , JCDF14/ 96 / , KBREAK(96) / 1 / ,
     &  VARS(97) /'   dCDdF15 '/ , JCDF15/ 97 / , KBREAK(97) / 1 / ,
     &  VARS(98) /'   dCDdF16 '/ , JCDF16/ 98 / , KBREAK(98) / 1 / ,
     &  VARS(99) /'   dCDdF17 '/ , JCDF17/ 99 / , KBREAK(99) / 1 / ,
     &  VARS(100)/'   dCDdF18 '/ , JCDF18/ 100/ , KBREAK(100)/ 1 / ,
     &  VARS(101)/'   dCDdF19 '/ , JCDF19/ 101/ , KBREAK(101)/ 1 / ,
     &  VARS(102)/'   dCDdF20 '/ , JCDF20/ 102/ , KBREAK(102)/ 1 / 
