
     
      subroutine airfun(cl,tau,Mach,
     &                  idim,jdim,kdim,ldim,
     &                  nAMa,nAcl,nAtau,nAfun,
     &                  AMa,Acl,Atau,ARe,
     &                  A,
     &                  A_M,
     &                  A_cl,
     &                  A_tau,
     &                  A_M_cl,
     &                  A_M_tau,
     &                  A_cl_tau,
     &                  A_M_cl_tau,
     &                  cdf, cdp, cdw, cm)
      implicit none

      real cl,tau,Mach
      integer idim,jdim,kdim,ldim
      integer nAMa, nAcl, nAtau,nAfun
      real AMa(idim), Acl(jdim), Atau(kdim), ARe
      real       A(idim,jdim,kdim,ldim),
     &         A_M(idim,jdim,kdim,ldim),
     &        A_cl(idim,jdim,kdim,ldim),
     &       A_tau(idim,jdim,kdim,ldim),
     &      A_M_cl(idim,jdim,kdim,ldim),
     &     A_M_tau(idim,jdim,kdim,ldim),
     &    A_cl_tau(idim,jdim,kdim,ldim),
     &  A_M_cl_tau(idim,jdim,kdim,ldim)
      real cdf, cdp, cdw, cm

      real M
      real clmin, clmax, taumin, taumax
c
      integer i,j,k, lfun,nfun

      integer jx,kx,lx
      parameter (jx=10,kx=10,lx=5)
      real f(jx,kx,lx)
      real fx(jx,kx),
     &     fy(jx,kx),
     &     fxy(jx,kx)

      real seval, interp2
      external seval, interp2

      if(nAcl .gt.jx) stop 'AIRFUN: Array overflow on jx'
      if(nAtau.gt.kx) stop 'AIRFUN: Array overflow on kx'
      if(nAfun.gt.lx) stop 'AIRFUN: Array overflow on lx'

      do j = 1, nAcl
        do k = 1, nAtau
          do lfun = 1, nfun
            M = max( Mach , aMa(1) )
            f(j,k,lfun) = seval(M, A(1,j,k,lfun),
     &                           A_M(1,j,k,lfun), AMa, nAMa)
          enddo   
        enddo
      enddo

      cdf = interp2(Acl,Atau,f(1,1,1),fx,fy,fxy,cl,tau,jx,kx,nAcl,nAtau)
      cdp = interp2(Acl,Atau,f(1,1,2),fx,fy,fxy,cl,tau,jx,kx,nAcl,nAtau)
c     cdw = interp2(Acl,Atau,f(1,1,3),fx,fy,fxy,cl,tau,jx,kx,nAcl,nAtau)
c     cm  = interp2(Acl,Atau,f(1,1,4),fx,fy,fxy,cl,tau,jx,kx,nAcl,nAtau)
      cdw = 0.
      cm = 0.

c---- add quadratic cd penalty for exceeding database's cl limits
      clmin = Acl(1)
      clmax = Acl(nAcl)
      if    (cl .lt. clmin) then
       cdp = cdp + 1.0*(cl-clmin)**2
      elseif(cl .gt. clmax) then
       cdp = cdp + 1.0*(cl-clmax)**2
      endif

c---- add quadratic cd penalty for exceeding database's tau max limit
      taumin = Atau(1)
      taumax = Atau(nAtau)
      if    (tau .gt. taumax) then
       cdp = cdp + 10.0*(tau-taumax)**2
      endif

      return
      end ! airfun
