
     
      subroutine airfun(cl,tau,Mach,
     &                  kdim,ldim,idim,jdim,
     &                  nAcl,nAtau,nAfun,
     &                  Acl,Atau,ARe,
     &                  nA,A,AM,
     &                  cdf, cdp, cdw, cm)
      implicit none

      real cl,tau,Mach
      integer kdim,ldim,idim,jdim
      integer nAcl, nAtau,nAfun
      real Acl(idim), Atau(jdim), ARe
      integer nA(idim,jdim)
      real A(kdim,ldim,idim,jdim),
     &    AM(kdim,ldim,idim,jdim)
      real cdf, cdp, cdw, cm

      real M
      real clmin, clmax, dcl, tcl ,
     &     taumin,taumax,dtau,ttau
c
      integer i,ii, j,jj, l
      integer ilow,imid,
     &        jlow,jmid

      integer ix,jx,lx
      parameter (ix=10,jx=10,lx=5)
      real f(ix,jx,lx)
      real fx(ix,jx),
     &     fy(ix,jx),
     &     fxy(ix,jx)

      real seval, interp2
      external seval, interp2

      if(nAcl .gt.ix) stop 'AIRFUN: Array overflow on ix'
      if(nAtau.gt.jx) stop 'AIRFUN: Array overflow on jx'
      if(nAfun.gt.lx) stop 'AIRFUN: Array overflow on lx'

c---- find cl interval i-1..i
      ilow = 1
      i = nAcl
c
   10 if(i-ilow .le. 1) go to 11
c
      imid = (i+ilow)/2
      if(cl .lt. Acl(imid)) then
       i = imid
      else
       ilow = imid
      endif
      go to 10
c
   11 continue
      dcl = Acl(i) - Acl(i-1)
      tcl = (cl - Acl(i-1)) / dcl


c---- find tau interval j-1..j
      jlow = 1
      j = nAtau
c
   20 if(j-jlow .le. 1) go to 21
c
      jmid = (j+jlow)/2
      if(tau .lt. Atau(jmid)) then
       j = jmid
      else
       jlow = jmid
      endif
      go to 20
c
   21 continue
      dtau = Atau(j) - Atau(j-1)
      ttau = (tau - Atau(j-1)) / dtau

      do ii = 1, 2
        do jj = 1, 2
          do l = 2, nAfun
           M = max( Mach , A(1,1,i,j) )
           f(i,j,l) = seval(M,A(1,l,i,j),AM(1,l,i,j),A(1,1,i,j),nA(i,j))
          enddo
        enddo
      enddo

      cdf = interp2(Acl,Atau,f(1,1,2),fx,fy,fxy,cl,tau,ix,jx,nAcl,nAtau)
      cdp = interp2(Acl,Atau,f(1,1,3),fx,fy,fxy,cl,tau,ix,jx,nAcl,nAtau)
c     cdw = interp2(Acl,Atau,f(1,1,4),fx,fy,fxy,cl,tau,ix,jx,nAcl,nAtau)
c     cm  = interp2(Acl,Atau,f(1,1,5),fx,fy,fxy,cl,tau,ix,jx,nAcl,nAtau)
      cdw = 0.
      cm = 0.

c---- add quadratic cd penalty for exceeding database's cl limits
      clmin = Acl(1)
      clmax = Acl(nAcl)
      if    (cl .lt. clmin) then
       cdp = cdp + 0.05*((clmin-cl)/0.1)**3
      elseif(cl .gt. clmax) then
       cdp = cdp + 0.10*((cl-clmax)/0.1)**3  ! 2.0*(cl-clmax)**2
       write(*,*) cl-clmax, 0.10*((cl-clmax)/0.1)**3, cdp
      endif

c---- add quadratic cd penalty for exceeding database's tau max limit
      taumin = Atau(1)
      taumax = Atau(nAtau)
      if    (tau .gt. taumax) then
       cdp = cdp + 0.1*((tau-taumax)/0.1)**2
      endif

      return
      end ! airfun
