 
      subroutine airpic(pari,parg,
     &                  nw,xw,yw,
     &                  nh,xh,yh,
     &                  nf,xf,yf,
     &                  ne,xe,ye )
      implicit real(a-h,l-z)

      integer pari(*)
      real parg(*)
      real xw(*),yw(*),
     &     xh(*),yh(*),
     &     xf(*),yf(*),
     &     xe(*),ye(*)
      integer nw,nh,nf,ne

      integer nnose, ntail
      data nnose, ntail / 8 , 5 /

      data pi / 3.1415926535897932384626 /

      include 'index.inc'

      ifclose = pari(iifclose)

      cm = -0.1
      CL = 0.70

      Rfuse = parg(igRfuse)
      wfb   = parg(igwfb)

      anose    = parg(iganose)
      btail    = parg(igbtail)

      xnose    = parg(igxnose   )
      xend     = parg(igxend    )
      xblend1  = parg(igxblend1 )
      xblend2  = parg(igxblend2 )
      xhtail   = parg(igxhtail  )
      xvtail   = parg(igxvtail  )
      xwing    = parg(igxwing   )

      xwbox    = parg(igxwbox   )
      xhbox    = parg(igxhbox   )
      xvbox    = parg(igxvbox   )

      lcyl = xblend2 - xblend1
      xtail = xvtail


      co = parg(igco)
      bo = parg(igbo)
      bs = parg(igbs)
      b  = parg(igb)
      sweep = parg(igsweep)
      lambdat = parg(iglambdat)
      lambdas = parg(iglambdas)


      boh = parg(igboh)
      Sh  = parg(igSh)
      ARh = parg(igARh)
      lambdah = parg(iglambdah)
      sweeph  = parg(igsweeph)

      bh = sqrt(Sh*ARh)
      coh = Sh/(boh + (bh-boh)*0.5*(1.0+lambdah))


      etas = bs/b
      etao = bo/b

      cosL = cos(sweep*pi/180.0)
      tanL = tan(sweep*pi/180.0)

      clp = CL/cosL**2
      cmp = cm

c     cmp = -0.25*clp
c     cmp = 0.

c---- chordwise location of spanwise axis
      xax = 0.40
      xcLE = -xax
      xcTE = 1.0 - xax

      cs = co*lambdas
      ct = co*lambdat
      xs = tanL*(bs-bo)/2.0
      xt = tanL*(b -bo)/2.0

      dx = xwbox
      xw(1) =      co*xcLE + dx
      xw(2) = xs + cs*xcLE + dx
      xw(3) = xt + ct*xcLE + dx
      xw(4) = xt + ct*xcTE + dx
      xw(5) = xs + cs*xcTE + dx
      xw(6) =      co*xcTE + dx

      yw(1) = bo/2.0
      yw(2) = bs/2.0
      yw(3) = b /2.0
      yw(4) = b /2.0
      yw(5) = bs/2.0
      yw(6) = bo/2.0

      nw = 6
c
c
      hwidth = Rfuse + wfb
      
      if(ifclose.eq.0) then
       dytail = -hwidth
      else
cc     dytail = 0.5*boh - hwidth
       dytail = -0.2*hwidth
      endif

      do i = 1, nnose
        fraci = float(i-1)/float(nnose-1)
        fracx = cos(0.5*pi*fraci)

        k = i
        xf(k) = xblend1 + (xnose-xblend1)*fracx
        yf(k) = hwidth*(1.0 - fracx**anose)**(1.0/anose)
      enddo

      do i = 1, ntail
        fraci = float(i-1)/float(ntail-1)
        fracx = fraci

        k = i + nnose
        xf(k) = xblend2 + (xend-xblend2)*fracx
        yf(k) = hwidth + dytail*fracx**btail
      enddo

      k = k+1
      xf(k) = xf(k-1)
      yf(k) = 0.

      nf = k




      dx = xhbox
      tanLh = tan(sweeph*pi/180.0)
      cth = coh*lambdah

      xaxh = 0.40


      xoLEh = coh*(    - xaxh) + dx
      xoTEh = coh*(1.0 - xaxh) + dx
      xtLEh = cth*(    - xaxh) + dx + 0.5*(bh - boh)*tanLh
      xtTEh = cth*(1.0 - xaxh) + dx + 0.5*(bh - boh)*tanLh

      yoLEh = 0.5*boh
      yoTEh = 0.5*boh
      ytLEh = 0.5*bh
      ytTEh = 0.5*bh


      if(ifclose.eq.0) then
       xcLEh = xoLEh
       xcTEh = xoTEh
       ycLEh = yoLEh
       ycTEh = yoTEh
      else
       xcLEh = coh*(    - xaxh) + dx + 0.5*(0. - boh)*tanLh
       xcTEh = coh*(1.0 - xaxh) + dx + 0.5*(0. - boh)*tanLh
       ycLEh = 0.0
       ycTEh = 0.0
      endif

      if(.false.) then
       yoLEh = hwidth
       xoLEh = yoLEh*tanLh + xcLEh
       if(xoLEh .gt. xblend2) then
        fracx = min( (xoLEh-xblend2)/(xend-xblend2) , 1.0 )
        yoLEh = hwidth + dytail*fracx**btail
        xoLEh = yoLEh*tanLh + xcLEh
       endif
       if(xoLEh .gt. xblend2) then
        fracx = min( (xoLEh-xblend2)/(xend-xblend2) , 1.0 )
        yoLEh = hwidth + dytail*fracx**btail
        xoLEh = yoLEh*tanLh + xcLEh
       endif

       yoTEh = 0.0
       xoTEh = yoTEh*tanLh + xcTEh
       if(xoTEh .gt. xblend2) then
        fracx = min( (xoTEh-xblend2)/(xend-xblend2) , 1.0 )
        yoTEh = hwidth + dytail*fracx**btail
        xoTEh = yoTEh*tanLh + xcTEh
       endif
       if(xoTEh .gt. xblend2) then
        fracx = min( (xoTEh-xblend2)/(xend-xblend2) , 1.0 )
        yoTEh = hwidth + dytail*fracx**btail
        xoTEh = yoTEh*tanLh + xcTEh
       endif

      endif

      xh( 1) = xcLEh
      xh( 2) = xoLEh
      xh( 3) = xtLEh
      xh( 4) = xtTEh
      xh( 5) = xoTEh
      xh( 6) = xcTEh

      yh( 1) = ycLEh
      yh( 2) = yoLEh
      yh( 3) = ytLEh
      yh( 4) = ytTEh
      yh( 5) = yoTEh
      yh( 6) = ycTEh

      nh = 6


      xeng = parg(igxeng)
      yeng = parg(igyeng)
      dfan = parg(igdfan)
      rSnace = parg(igrSnace)

      Afan = 0.25*pi*dfan**2
      lnace = dfan*rSnace*0.15
      Snace = Afan*rSnace
      dnace = (Snace*0.85)/(pi*lnace)

c      write(*,*) 'rSnace rlnace dfan dnace lnace', 
c     &  rSnace, rlnace, dfan*39.37, dnace*39.37, lnace/0.3048

      xeLE = -0.5*lnace
      xeTE =  0.5*lnace
      yeLE = 0.5*dnace
      yeTE = 0.4*dnace

      xe(1) =  xeTE
      ye(1) =  0.0
      xe(2) =  xeTE
      ye(2) =  yeTE
      xe(3) =  xeLE + 0.3*lnace
      ye(3) =  yeLE
      xe(4) =  xeLE
      ye(4) =  yeLE

      xe(5) =  xeLE
      ye(5) = -yeLE
      xe(6) =  xeLE + 0.3*lnace
      ye(6) = -yeLE
      xe(7) =  xeTE
      ye(7) = -yeTE
      xe(8) =  xeTE
      ye(8) =  0.0

      ne = 8

      return
      end
