
      subroutine airtable(
     &     fname,
     &     idim,jdim,kdim,ldim,
     &     nAMa,nAcl,nAtau,nAfun,
     &     AMa, Acl, Atau, ARe,
     &          A,
     &        A_M,
     &       A_cl,
     &      A_tau,
     &     A_M_cl,
     &    A_M_tau,
     &   A_cl_tau,
     & A_M_cl_tau  )
c------------------------------------------------------------
c     Reads airfoil database file, and uses this to generate
c     spline data for evaluation of airfoil functions
c       cdf(Ma,cl,tau) 
c       cdp(Ma,cl,tau) 
c        cm(Ma,cl,tau) 
c------------------------------------------------------------
      character*(*) fname
      real AMa(idim), Acl(jdim), Atau(kdim), ARe
      real      A(idim,jdim,kdim,ldim),
     &        A_M(idim,jdim,kdim,ldim),
     &       A_cl(idim,jdim,kdim,ldim),
     &      A_tau(idim,jdim,kdim,ldim),
     &     A_M_cl(idim,jdim,kdim,ldim),
     &    A_M_tau(idim,jdim,kdim,ldim),
     &   A_cl_tau(idim,jdim,kdim,ldim),
     & A_M_cl_tau(idim,jdim,kdim,ldim)

c----------------------------------------------------
c---- local work arrays
      parameter( iwdim = 100 )
      real f(iwdim),
     &     f_cl(iwdim),
     &     f_tau(iwdim)
      real f_M(iwdim),
     &     f_M_cl(iwdim),
     &     f_M_tau(iwdim)

c--------------------------------------------------------------------
      lu = 19
      open(lu,file=fname,status='old')

      read(lu,*) nAMa, nAcl, nAtau, nAfun

      nmax = max( nAMa, nAcl, nAtau )
      if(nmax.gt.iwdim) stop 'AIRTABLE: Local array overflow on iwdim'

      if(nAMa  .gt. idim) stop 'AIRTABLE: Array overflow on idim'
      if(nAcl  .gt. jdim) stop 'AIRTABLE: Array overflow on jdim'
      if(nAtau .gt. kdim) stop 'AIRTABLE: Array overflow on kdim'
      if(nAfun .gt. ldim) stop 'AIRTABLE: Array overflow on ldim'


      do i = 1, nAMa
        read(lu,*) AMa(i)
      enddo
      do j = 1, nAcl
        read(lu,*) Acl(j)
      enddo
      do k = 1, nAtau
        read(lu,*) Atau(k)
      enddo

      read(lu,*) ARe

      do k = 1, nAtau
        do j = 1, nAcl
          do i = 1, nAMa
            read(lu,*) (A(i,j,k,l), l=1, nAfun)
          enddo
        enddo
      enddo

c      do k = 1, nAtau
c        do j = 1, nAcl
c          do i = 1, nAMa
c            read(lu,*) (AM(i,j,k,l), l=1, nAfun)
c          enddo
c        enddo
c      enddo

      close(lu)
c--------------------------------------------------------------------

c 99   format(1x,12g12.4)

      do l = 1, nAfun

        do k = 1, nAtau
          do j = 1, nAcl
            call spline(A(1,j,k,l),A_M(1,j,k,l),AMa,nAMa)
          enddo
        enddo

c        if(l.eq.2) then
c        k = nAtau/2
c        j = nAcl/2
c        do i = 2, nAMa-1
c          write(*,99) AMa(i), A(i,j,k,l), A_M(i,j,k,l), 
c     &   (A(i+1,j,k,l)-A(i-1,j,k,l)) / (AMa(i+1)-AMa(i-1))
c        enddo
c        pause
c        endif

        do k = 1, nAtau
          do i = 1, nAMa
            do j = 1, nAcl
              f(j)   = A(i,j,k,l)
              f_M(j) = A_M(i,j,k,l)
            enddo
            call spline(f  ,f_cl  ,Acl,nAcl)
            call spline(f_M,f_M_cl,Acl,nAcl)
            do j = 1, nAcl
              A_cl(i,j,k,l)   = f_cl(j)
              A_M_cl(i,j,k,l) = f_M_cl(j)
            enddo
          enddo
        enddo

c        if(l.eq.2) then
c        i = (4*nAMa)/5
c        j = nAcl/2
c        k = nAtau/2
c        do j = 1, nAcl
c          jm = max(j-1,1)
c          jo = min(j+1,nAcl)
c          write(*,99) Acl(j), A(i,j,k,l), A_cl(i,j,k,l), 
c     &   (A(i,jo,k,l)-A(i,jm,k,l)) / (Acl(jo)-Acl(jm))
c        enddo
c        pause
c        endif

        do j = 1, nAcl
          do i = 1, nAMa
            do k = 1, nAtau
              f(k)   = A(i,j,k,l)
              f_M(k) = A_M(i,j,k,l)
            enddo
            call spline(f  ,f_tau  ,Atau,nAtau)
            call spline(f_M,f_M_tau,Atau,nAtau)
            do k = 1, nAtau
              A_tau(i,j,k,l)   = f_tau(k)
              A_M_tau(i,j,k,l) = f_M_tau(k)
            enddo
          enddo
        enddo


c        if(l.eq.2) then
c        i = (4*nAMa)/5
c        j = nAcl/2
c        k = nAtau/2
c        do k = 1, nAtau
c          km = max(k-1,1)
c          ko = min(k+1,nAtau)
c          write(*,99) Atau(k), 10*A(i,j,k,l), A_tau(i,j,k,l), 
c     &   (A(i,j,ko,l)-A(i,j,km,l)) / (Atau(ko)-Atau(km))
c        enddo
c        pause
c        endif


        do i = 1, nAMa
          do j = 1, nAcl
            do k = 1, nAtau
              f(k)   = A_cl(i,j,k,l)
              f_M(k) = A_M_cl(i,j,k,l)
            enddo
            call spline(f  , f_tau   ,Atau,nAtau)
            call spline(f_M, f_M_tau ,Atau,nAtau)
            do k = 1, nAtau
              A_cl_tau(i,j,k,l)   = f_tau(k)
              A_M_cl_tau(i,j,k,l) = f_M_tau(k)
            enddo
          enddo

          do k = 1, nAtau
            do j = 1, nAcl
              f(j)   = A_tau(i,j,k,l)
              f_M(j) = A_M_tau(i,j,k,l)
            enddo
            call spline(f  , f_cl   ,Acl,nAcl)
            call spline(f_M, f_M_cl ,Acl,nAcl)
            do j = 1, nAcl
              A_cl_tau(i,j,k,l)   =
     &  0.5*( A_cl_tau(i,j,k,l)   + f_cl(j)   )
              A_M_cl_tau(i,j,k,l) = 
     &  0.5*( A_M_cl_tau(i,j,k,l) + f_M_cl(j) )
            enddo
          enddo
        enddo

c        if(l.eq.2) then
c        i = (4*nAMa)/5
c        j = nAcl/2
c        k = nAtau/2
c        do j = 1, nAcl
c          jm = max(j-1,1)
c          jo = min(j+1,nAcl)
c          write(*,99) Acl(j), 2*A_M(i,j,k,l), A_M_cl(i,j,k,l), 
c     &   (A_M(i,jo,k,l)-A_M(i,jm,k,l)) / (Acl(jo)-Acl(jm))
c        enddo
c        pause
c        endif


c        if(l.eq.2) then
c        i = (4*nAMa)/5
c        j = nAcl/2
c        k = nAtau/2
c        do k = 1, nAtau
c          km = max(k-1,1)
c          ko = min(k+1,nAtau)
c          write(*,99) Atau(k), 10*A_cl(i,j,k,l), A_cl_tau(i,j,k,l), 
c     &   (A_cl(i,j,ko,l)-A_cl(i,j,km,l)) / (Atau(ko)-Atau(km))
c        enddo
c        pause
c        endif


c         if(l.eq.2) then
c         i = (4*nAMa)/5
c         j = nAcl/2
c         k = nAtau/2
c         do k = 1, nAtau
c           km = max(k-1,1)
c           ko = min(k+1,nAtau)
c           write(*,99) Atau(k), 10*A_M_cl(i,j,k,l), A_M_cl_tau(i,j,k,l), 
c     &   (A_M_cl(i,j,ko,l)-A_M_cl(i,j,km,l)) / (Atau(ko)-Atau(km))
c         enddo
c         pause
c         endif


      enddo

      return

      end ! airtable
