
      SUBROUTINE BINPUT(LU,IBX,JBX,
     &               NBX, NBEAM, NB, QB, TB, BNAME, KBNUM,IBEAM,
     &               NJX, NJOIN, TJOIN, KBJOIN, KJTYPE,
     &               NGX, NGROU, TGROU, KBGROU, KGTYPE,
     &          KPX, NPX, NPYLO, QPYLO, KBPYLO, KPTYPE, 
     &        NENGX, IENGTYP,
     &               NAJX,NANGJ, MOMJ, ANGJ, HJAX,
     &               UNITL, UNITM, UNITT, UNITF,
     &               UNCHL, UNCHM, UNCHT, UNCHF,
     &               GEE, RHOSL, VSOSL, SREF,CREF,BREF,XYZREF,
     &               NAME )
C---------------------------------------------------
C     Reads geometry description file from unit LU.
C---------------------------------------------------
      IMPLICIT REAL (M)
      DIMENSION NB(0:JBX,NBX), KBNUM(NBX), IBEAM(NBX)
      DIMENSION QB(IBX,0:JBX,NBX), TB(IBX,0:JBX,NBX)
C
      DIMENSION TJOIN(2,NJX)
      DIMENSION KBJOIN(2,NJX), KJTYPE(NJX)
C
      DIMENSION TGROU(NGX)
      DIMENSION KBGROU(NGX), KGTYPE(NGX)
C
      DIMENSION QPYLO(0:KPX,NPX)
      DIMENSION KBPYLO(NPX), KPTYPE(NPX)
      DIMENSION IENGTYP(NENGX)
      DIMENSION XYZREF(3,3)
C
      DIMENSION NANGJ(NJX)
      DIMENSION MOMJ(NAJX,NJX), ANGJ(NAJX,NJX), HJAX(3,NJX)
C
      CHARACTER*(*) UNCHL, UNCHM, UNCHT, UNCHF
      CHARACTER*(*) BNAME(NBX)
      CHARACTER*(*) NAME
C
C---- JDIM must be at least as large as JBX in INDEXB.INC
      PARAMETER (JDIM=102)
      DIMENSION RDAT(JDIM), QFAC(JDIM), QADD(JDIM)
      DIMENSION IDAT(JDIM), JVAR(JDIM)
      CHARACTER*256 LINE
      CHARACTER*7 VNAME
      LOGICAL ERROR
      LOGICAL LBLANK
C
      INCLUDE 'INDEXB.INC'
C
 1000 FORMAT(A)
C
      IF(JDIM.LT.JBX) STOP 'BINPUT: Array overflow.  JDIM < JBX'
C
C---- assume no units will be specified
      UNITL = 0.
      UNITM = 0.
      UNITT = 0.
      UNITF = 0.
C
      UNCHL = ' '
      UNCHM = ' '
      UNCHT = ' '
      UNCHF = ' '
C
C---- assume no constants or reference data will be specified
      GEE = 0.
      RHOSL = 0.
      VSOSL = 0.
      SREF = 0.
      CREF = 0.
      BREF = 0.
C
      DO K=1, 3
        XYZREF(K,1) = 0.
        XYZREF(K,2) = 0.
        XYZREF(K,3) = 0.
      ENDDO
C
C---- clear variable array sizes
      DO IS=1, NBX
        DO J=1, JBX
          NB(J,IS) = 0
        ENDDO
      ENDDO
C
      DO KJ=1, NJX
        NANGJ(KJ) = 0
      ENDDO
C
C---- initialize beam, joint, ground, and pylon counters
      NBEAM = 0
      NJOIN = 0
      NGROU = 0
      NPYLO = 0
C
      ILINE = 0
C==================================================
C---- begin keyword search here
 10   CONTINUE
C
C------ read next line, if end-of-file go finish up
        ILINE = ILINE + 1
        READ(LU,1000,END=9000) LINE
C
C***********************************************
C------ echo line to screen for debugging
CCC     WRITE(*,1000) LINE(1:120)
C***********************************************
C  
C====== first check for special keywords...
C  
C------ ... end of all input ?
        IF(INDEX('END End end',LINE(1:3)) .NE. 0) GO TO 9000
C  
C------ ... skip comment line ?
        IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 10
C  
C------ ... skip blank line ?
        IF(LBLANK(LINE)) GO TO 10
C  
C------ ... scale factor line doesn't belong here...
        IF(INDEX('*',LINE(1:1)) .NE. 0) GO TO 1002
C  
C------ ... add constant line doesn't belong here...
        IF(INDEX('+',LINE(1:1)) .NE. 0) GO TO 1003
C  
C------ ... go read name?
        IF(INDEX('NAME Name name',LINE(1:4)) .NE. 0) GO TO 100
C  
C------ ... go read units?
        IF(INDEX('UNIT Unit unit',LINE(1:4)) .NE. 0) GO TO 110
C  
C------ ... go read constant data?
        IF(INDEX('CONS Cons cons',LINE(1:4)) .NE. 0) GO TO 120
C  
C------ ... go read reference data?
        IF(INDEX('REFE Refe refe',LINE(1:4)) .NE. 0) GO TO 130
C  
C------ ... go read sensors?
        IF(INDEX('SENS Sens sens',LINE(1:4)) .NE. 0) GO TO 300
C  
C------ ... go read point engines?
        IF(INDEX('ENGI Engi engi',LINE(1:4)) .NE. 0) GO TO 400
C  
C------ ... go read point weights?
        IF(INDEX('WEIG Weig weig',LINE(1:4)) .NE. 0) GO TO 500
C  
C------ ... go read strut data?
        IF(INDEX('STRU Stru stru',LINE(1:4)) .NE. 0) GO TO 600
C  
C------ ... go read joint data?
        IF(INDEX('JOIN Join join',LINE(1:4)) .NE. 0) GO TO 700
C  
C------ ... go read joint angle data?
        IF(INDEX('JANG Jang jang',LINE(1:4)) .NE. 0) GO TO 740
C  
C------ ... go read ground data?
        IF(INDEX('GROU Grou grou',LINE(1:4)) .NE. 0) GO TO 800
C  
C------ ... go read beam data?
        IF(INDEX('BEAM Beam beam',LINE(1:4)) .NE. 0) GO TO 900
C  
C------ OK, I give up.  What is in LINE???
        GO TO 1005
C
C======================================
C---- pick up here to read name
 100  CONTINUE
      VNAME = ' name  '
C
C-----------------------------
C---- try to read name lines
 105  CONTINUE
        ILINE = ILINE + 1
        READ(LU,1000,END=9000) LINE
C
C------ ... skip comment line ?
        IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 105
C
C------ ... end of input?  ... resume trying to read keywords
        IF(INDEX('END End end',LINE(1:3)) .NE. 0) GO TO 10
C
        NAME = LINE
      GO TO 105
C-----------------------------
C
C======================================
C---- pick up here to read units
 110  CONTINUE
      VNAME = ' unit  '
C
C-----------------------------
C---- try to read unit labels
 115  CONTINUE
        ILINE = ILINE + 1
        READ(LU,1000,END=9000) LINE
C
C------ ... skip comment line ?
        IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 115
C
C------ ... end of input?  ... resume trying to read keywords
        IF(INDEX('END End end',LINE(1:3)) .NE. 0) GO TO 10
C
C------ ... skip blank line ?
        IF(LBLANK(LINE)) GO TO 115
C
C------ find start index of third "word" in LINE
        IWORD = 1
        DO KO=2, 256
          KM = KO-1
          IF(INDEX(LINE(KO:KO),' ').EQ.0 .AND.
     &       INDEX(LINE(KM:KM),' ').NE.0      ) THEN
           IWORD = IWORD + 1
          ENDIF
          IF(IWORD.EQ.3) GO TO 116
        ENDDO
        KO = 1
C
 116    CONTINUE
C
C------ extract unit values for the four possible cases  L M F T
        IF    (INDEX('Ll',LINE(1:1)).NE.0) THEN
          READ(LINE(2:256),*,ERR=119) UNITL
          UNCHL = LINE(KO:256)
C
        ELSEIF(INDEX('Mm',LINE(1:1)).NE.0) THEN
          READ(LINE(2:256),*,ERR=119) UNITM
          UNCHM = LINE(KO:256)
C
        ELSEIF(INDEX('Ff',LINE(1:1)).NE.0) THEN
          READ(LINE(2:256),*,ERR=119) UNITF
          UNCHF = LINE(KO:256)
C
        ELSEIF(INDEX('Tt',LINE(1:1)).NE.0) THEN
          READ(LINE(2:256),*,ERR=119) UNITT
          UNCHT = LINE(KO:256)
C
        ELSE
          GO TO 119
C
        ENDIF
      GO TO 115
C-----------------------------
C
 119  WRITE(*,1190) ILINE, LINE
 1190 FORMAT(' Read error in units block, line',I5,'...'/1X,A)
      RETURN
C
C
C======================================
C---- pick up here to read constants
 120  CONTINUE
      VNAME = 'const. '
      NVALUE = 3
C
C---- set default data for this block
      DO J = 1, NVALUE
        QFAC(J) = 1.0
        QADD(J) = 0.0
        RDAT(J) = 0.0
      ENDDO
C
C-----------------------------
C---- try to read constant lines
 125  CONTINUE
        ILINE = ILINE + 1
        READ(LU,1000,END=9000) LINE
C
C------ ... skip comment line ?
        IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 125
C
C------ ... end of input?  ... resume trying to read keywords
        IF(INDEX('END End end',LINE(1:3)) .NE. 0) GO TO 10
C
C------ ... skip blank line ?
        IF(LBLANK(LINE)) GO TO 125
C
C------ ... read specified scale factor line ?
        IF(INDEX('*',LINE(1:1)) .NE. 0) THEN
          NFAC = NVALUE
          CALL GETFLT(LINE(2:256),QFAC,NFAC,ERROR)
          IF(ERROR) THEN
           GO TO 1500
          ELSE
           GO TO 125
          ENDIF
        ENDIF
C
C------ ... read specified adder line ?
        IF(INDEX('+',LINE(1:1)) .NE. 0) THEN
          NADD = NVALUE
          CALL GETFLT(LINE(2:256),QADD,NADD,ERROR)
          IF(ERROR) THEN
           GO TO 1502
          ELSE
           GO TO 125
          ENDIF
        ENDIF
C
C------ extract data
        NDAT = NVALUE
        CALL GETFLT(LINE,RDAT,NDAT,ERROR)
        IF(ERROR .OR. NDAT.LT.NVALUE) GO TO 1505
C
        GEE   = RDAT(1) * QFAC(1)  +  QADD(1)
        RHOSL = RDAT(2) * QFAC(2)  +  QADD(2)
        VSOSL = RDAT(3) * QFAC(3)  +  QADD(3)
      GO TO 125
C-----------------------------
C
C=========================================
C---- pick up here to read reference data
 130  CONTINUE
      VNAME = ' ref.  '
      NVALUE = 3
C
C---- try to read four reference lines
      DO 138 I = 0, 12345
C------ set default data for this line
        DO J = 1, NVALUE
          QFAC(J) = 1.0
          QADD(J) = 0.0
          RDAT(J) = 0.0
        ENDDO
C
 135    CONTINUE
        ILINE = ILINE + 1
        READ(LU,1000,END=9000) LINE
C
C------ ... skip comment line ?
        IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 135
C
C------ ... end of input? ... resume trying to read blocks of data
        IF(INDEX('END End end',LINE(1:3)) .NE. 0) GO TO 10
C
C------ ... skip blank line ?
        IF(LBLANK(LINE)) GO TO 135
C
C------ ... read specified scale factor line ?
        IF(INDEX('*',LINE(1:1)) .NE. 0) THEN
          NFAC = NVALUE
          CALL GETFLT(LINE(2:256),QFAC,NFAC,ERROR)
          IF(ERROR) THEN
           GO TO 1500
          ELSE
           GO TO 135
          ENDIF
        ENDIF
C
C------ ... read specified scale factor line ?
        IF(INDEX('+',LINE(1:1)) .NE. 0) THEN
          NADD = NVALUE
          CALL GETFLT(LINE(2:256),QADD,NADD,ERROR)
          IF(ERROR) THEN
           GO TO 1502
          ELSE
           GO TO 135
          ENDIF
        ENDIF
C
        NDAT = NVALUE
        CALL GETFLT(LINE,RDAT,NDAT,ERROR)
        IF(ERROR) GO TO 1505
C
C------ set input data
        IF(I.EQ.0) THEN
C------- first input line is mandatory... draw error if it doesn't exist
         IF(NDAT.LT.3) GO TO 1505
C
         SREF        = RDAT(1) * QFAC(1)  +  QADD(1)
         CREF        = RDAT(2) * QFAC(2)  +  QADD(2)
         BREF        = RDAT(3) * QFAC(3)  +  QADD(3)
C
        ELSEIF(I.LE.3) THEN
         XYZREF(1,I) = RDAT(1) * QFAC(1)  +  QADD(1)
         XYZREF(2,I) = RDAT(2) * QFAC(2)  +  QADD(2)
         XYZREF(3,I) = RDAT(3) * QFAC(3)  +  QADD(3)
C
        ENDIF
C
C------ lines after the I=3 line are ignored until an END is found
C
 138  CONTINUE
      RETURN
C
C
C======================================
C---- pick up here to read sensors
 300  CONTINUE
      VNAME = 'sensor '
      NVALUE = 12 
C
C---- set default data for this block
      DO J = 1, NVALUE
        QFAC(J) = 1.0
        QADD(J) = 0.0
        RDAT(J) = 0.0
        IDAT(J) = 0
      ENDDO
C
C---- try to read sensor data
      IBEG = NPYLO + 1
      DO 380 I = IBEG, NPX+1
 350    CONTINUE
        ILINE = ILINE + 1
        READ(LU,1000,END=9000) LINE
C
C------ ... skip comment line ?
        IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 350
C
C------ ... end of input?  ... resume trying to read blocks of data
        IF(INDEX('END End end',LINE(1:3)) .NE. 0) GO TO 10
C
C------ ... skip blank line ?
        IF(LBLANK(LINE)) GO TO 350
C
C------ note: *,+ data is put into QFAC(2..), QADD(2..)  to match RDAT below
C
C------ ... read specified scale factor line ?
        IF(INDEX('*',LINE(1:1)) .NE. 0) THEN
          NFAC = NVALUE-2
          CALL GETFLT(LINE(2:256),QFAC(3),NFAC,ERROR)
          IF(ERROR) THEN
           GO TO 1500
          ELSE
           GO TO 350
          ENDIF
        ENDIF
C
C------ ... read specified adder line ?
        IF(INDEX('+',LINE(1:1)) .NE. 0) THEN
          NADD = NVALUE-2
          CALL GETFLT(LINE(2:256),QADD(3),NADD,ERROR)
          IF(ERROR) THEN
           GO TO 1502
          ELSE
           GO TO 350
          ENDIF
        ENDIF
C
C------ extract first two numbers as integers
        NDAT = 2
        CALL GETINT(LINE,IDAT,NDAT,ERROR)
        IF(ERROR) GO TO 1505
C
C------ extract all as reals
        NDAT = NVALUE
        CALL GETFLT(LINE,RDAT,NDAT,ERROR)
        IF(ERROR) GO TO 1505
C
        IF(I.GT.NPX) THEN
         WRITE(*,*) 'BINPUT: Sensor pylon array overflow. Increase NPX.'
         RETURN
        ENDIF
C
        KSEN       = IDAT( 1)                           !  Ksen
        KBPYLO(I)  = IDAT( 2)                           !  Nbeam
        QPYLO(0,I) = RDAT( 3) * QFAC( 3)  +  QADD( 3)   !  t  
        QPYLO(1,I) = RDAT( 4) * QFAC( 4)  +  QADD( 4)   !  x 
        QPYLO(2,I) = RDAT( 5) * QFAC( 5)  +  QADD( 5)   !  y 
        QPYLO(3,I) = RDAT( 6) * QFAC( 6)  +  QADD( 6)   !  z 
        QPYLO(4,I) = RDAT( 7) * QFAC( 7)  +  QADD( 7)   !  Vx
        QPYLO(5,I) = RDAT( 8) * QFAC( 8)  +  QADD( 8)   !  Vy
        QPYLO(6,I) = RDAT( 9) * QFAC( 9)  +  QADD( 9)   !  Vz
        QPYLO(7,I) = RDAT(10) * QFAC(10)  +  QADD(10)   !  Ax
        QPYLO(8,I) = RDAT(11) * QFAC(11)  +  QADD(11)   !  Ay
        QPYLO(9,I) = RDAT(12) * QFAC(12)  +  QADD(12)   !  Az
C
        KPTYPE(I) = 100 + KSEN
        NPYLO = I
 380  CONTINUE
C
C======================================
C---- pick up here to read engines
 400  CONTINUE
      VNAME = 'engine '
      NVALUE = 25
C
C---- set default data for this block
      DO J = 1, NVALUE
        QFAC(J) = 1.0
        QADD(J) = 0.0
        RDAT(J) = 0.0
        IDAT(J) = 0
      ENDDO
C
C---- try to read engine data
      IBEG = NPYLO + 1
      DO 480 I = IBEG, NPX+1
 450    CONTINUE
        ILINE = ILINE + 1
        READ(LU,1000,END=9000) LINE
C
C------ ... skip comment line ?
        IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 450
C
C------ ... end of input?  ... resume trying to read blocks of data
        IF(INDEX('END End end',LINE(1:3)) .NE. 0) GO TO 10
C
C------ ... skip blank line ?
        IF(LBLANK(LINE)) GO TO 450
C
C------ note: *,+ data is put into QFAC(2..), QADD(2..)  to match RDAT below
C
C------ ... read specified scale factor line ?
        IF(INDEX('*',LINE(1:1)) .NE. 0) THEN
          NFAC = NVALUE-2
          CALL GETFLT(LINE(2:256),QFAC(4),NFAC,ERROR)
          IF(ERROR) THEN
           GO TO 1500
          ELSE
           GO TO 450
          ENDIF
        ENDIF
C
C------ ... read specified adder line ?
        IF(INDEX('+',LINE(1:1)) .NE. 0) THEN
          NADD = NVALUE-2
          CALL GETFLT(LINE(2:256),QADD(4),NADD,ERROR)
          IF(ERROR) THEN
           GO TO 1502
          ELSE
           GO TO 450
          ENDIF
        ENDIF
C
C------ extract first three numbers as integers
        NDAT = 3
        CALL GETINT(LINE,IDAT,NDAT,ERROR)
        IF(ERROR) GO TO 1505
C
C------ extract all as reals
        NDAT = NVALUE
        CALL GETFLT(LINE,RDAT,NDAT,ERROR)
        IF(ERROR) GO TO 1505
C
        IF(I.GT.NPX) THEN
         WRITE(*,*) 'BINPUT: Engine pylon array overflow. Increase NPX.'
         RETURN
        ENDIF
C
        KENG        = IDAT( 1)                           !  Keng
        IETYP       = IDAT( 2)                           !  IEtyp
        KBPYLO(I)   = IDAT( 3)                           !  Nbeam
        QPYLO( 0,I) = RDAT( 4) * QFAC( 4)  +  QADD( 4)   !  t  
        QPYLO( 1,I) = RDAT( 5) * QFAC( 5)  +  QADD( 5)   !  x 
        QPYLO( 2,I) = RDAT( 6) * QFAC( 6)  +  QADD( 6)   !  y 
        QPYLO( 3,I) = RDAT( 7) * QFAC( 7)  +  QADD( 7)   !  z 
        QPYLO( 4,I) = RDAT( 8) * QFAC( 8)  +  QADD( 8)   !  Tx
        QPYLO( 5,I) = RDAT( 9) * QFAC( 9)  +  QADD( 9)   !  Ty
        QPYLO( 6,I) = RDAT(10) * QFAC(10)  +  QADD(10)   !  Tz
        QPYLO( 7,I) = RDAT(11) * QFAC(11)  +  QADD(11)   !  F/Peng
        QPYLO( 8,I) = RDAT(12) * QFAC(12)  +  QADD(12)   !  M/Peng
        QPYLO( 9,I) = RDAT(13) * QFAC(13)  +  QADD(13)   !  Rdisk
        QPYLO(10,I) = RDAT(14) * QFAC(14)  +  QADD(14)   !  Omega
        QPYLO(11,I) = RDAT(15) * QFAC(15)  +  QADD(15)   !  cdA
C
        QPYLO(12,I) = RDAT(16) * QFAC(16)  +  QADD(16)   !  cl
        QPYLO(13,I) = RDAT(17) * QFAC(17)  +  QADD(17)   !  CLa
        QPYLO(14,I) = RDAT(18) * QFAC(18)  +  QADD(18)   !  S0
        QPYLO(15,I) = RDAT(19) * QFAC(19)  +  QADD(19)   !  C0
        QPYLO(16,I) = RDAT(20) * QFAC(20)  +  QADD(20)   !  S1
        QPYLO(17,I) = RDAT(21) * QFAC(21)  +  QADD(21)   !  C1
        QPYLO(18,I) = RDAT(22) * QFAC(22)  +  QADD(22)   !  S2
        QPYLO(19,I) = RDAT(23) * QFAC(23)  +  QADD(23)   !  C2
        QPYLO(20,I) = RDAT(24) * QFAC(24)  +  QADD(24)   !  S3
        QPYLO(21,I) = RDAT(25) * QFAC(25)  +  QADD(25)   !  C3
C
        KPTYPE(I) = 10 + KENG
C
        KE = MAX( 1 , MIN( NENGX , KENG) )
        IENGTYP(KE) = IETYP
C
        NPYLO = I
 480  CONTINUE
C
C======================================
C---- pick up here to read weights
 500  CONTINUE
      VNAME = 'weight '
      NVALUE = 11
C
C---- set default data for this block
      DO J = 1, NVALUE
        QFAC(J) = 1.0
        QADD(J) = 0.0
        RDAT(J) = 0.0
        IDAT(J) = 0
      ENDDO
C
C---- try to read point weight data
      IBEG = NPYLO + 1
      DO 580 I = IBEG, NPX+1
 550    CONTINUE
        ILINE = ILINE + 1
        READ(LU,1000,END=9000) LINE
C
C------ ... skip comment line ?
        IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 550
C
C------ ... end of input?  ... resume trying to read blocks of data
        IF(INDEX('END End end',LINE(1:3)) .NE. 0) GO TO 10
C
C------ ... skip blank line ?
        IF(LBLANK(LINE)) GO TO 550
C
C------ note: *,+ data is put into QFAC(2..), QADD(2..)  to match RDAT below
C
C------ ... read specified scale factor line ?
        IF(INDEX('*',LINE(1:1)) .NE. 0) THEN
          NFAC = NVALUE-1
          CALL GETFLT(LINE(2:256),QFAC(2),NFAC,ERROR)
          IF(ERROR) THEN
           GO TO 1500
          ELSE
           GO TO 550
          ENDIF
        ENDIF
C
C------ ... read specified adder line ?
        IF(INDEX('+',LINE(1:1)) .NE. 0) THEN
          NADD = NVALUE-1
          CALL GETFLT(LINE(2:256),QADD(2),NADD,ERROR)
          IF(ERROR) THEN
           GO TO 1502
          ELSE
           GO TO 550
          ENDIF
        ENDIF
C
C------ extract only first number as integer
        NDAT = 1
        CALL GETINT(LINE,IDAT,NDAT,ERROR)
        IF(ERROR) GO TO 1505
C
        NDAT = NVALUE
        CALL GETFLT(LINE,RDAT,NDAT,ERROR)
        IF(ERROR) GO TO 1505
C
        IF(I.GT.NPX) THEN
         WRITE(*,*) 'BINPUT: Weight pylon array overflow. Increase NPX.'
         RETURN
        ENDIF
C
        KBPYLO(I)  = IDAT( 1)                          ! Nbeam
        QPYLO(0,I) = RDAT( 2) * QFAC( 2)  +  QADD( 2)  ! t
        QPYLO(1,I) = RDAT( 3) * QFAC( 3)  +  QADD( 3)  ! x 
        QPYLO(2,I) = RDAT( 4) * QFAC( 4)  +  QADD( 4)  ! y 
        QPYLO(3,I) = RDAT( 5) * QFAC( 5)  +  QADD( 5)  ! z 
        QPYLO(4,I) = RDAT( 6) * QFAC( 6)  +  QADD( 6)  ! mg 
        QPYLO(5,I) = RDAT( 7) * QFAC( 7)  +  QADD( 7)  ! CdA
        QPYLO(6,I) = RDAT( 8) * QFAC( 8)  +  QADD( 8)  ! Vol
        QPYLO(7,I) = RDAT( 9) * QFAC( 9)  +  QADD( 9)  ! Hx
        QPYLO(8,I) = RDAT(10) * QFAC(10)  +  QADD(10)  ! Hy
        QPYLO(9,I) = RDAT(11) * QFAC(11)  +  QADD(11)  ! Hz
C
        KPTYPE(I) = 1
        NPYLO = I
 580  CONTINUE
C
C
C======================================
C---- pick up here to read struts
 600  CONTINUE
      VNAME = ' strut '
      NVALUE = 10
C
C---- set default data for this block
      DO J = 1, NVALUE
        QFAC(J) = 1.0
        QADD(J) = 0.0
        RDAT(J) = 0.0
        IDAT(J) = 0
      ENDDO
C
C---- try to read strut data
      IBEG = NPYLO + 1
      DO 680 I = IBEG, NPX+1
 650    CONTINUE
        ILINE = ILINE + 1
        READ(LU,1000,END=9000) LINE
C
C------ ... skip comment line ?
        IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 650
C
C------ ... end of input?  ... resume trying to read blocks of data
ccc     IF(INDEX('end',LINE(1:3)) .NE. 0) GO TO 10
        IF(INDEX('END End end',LINE(1:3)) .NE. 0) GO TO 10
C
C------ ... skip blank line ?
        IF(LBLANK(LINE)) GO TO 650
C
C------ note: *,+ data is put into QFAC(2..), QADD(2..)  to match RDAT below
C
C------ ... read specified scale factor line ?
        IF(INDEX('*',LINE(1:1)) .NE. 0) THEN
          NFAC = NVALUE-1
          CALL GETFLT(LINE(2:256),QFAC(2),NFAC,ERROR)
          IF(ERROR) THEN
           GO TO 1500
          ELSE
           GO TO 650
          ENDIF
        ENDIF
C
C------ ... read specified adder line ?
        IF(INDEX('+',LINE(1:1)) .NE. 0) THEN
          NADD = NVALUE-1
          CALL GETFLT(LINE(2:256),QADD(2),NADD,ERROR)
          IF(ERROR) THEN
           GO TO 1502
          ELSE
           GO TO 650
          ENDIF
        ENDIF
C
C------ extract only first number as integer
        NDAT = 1
        CALL GETINT(LINE,IDAT,NDAT,ERROR)
        IF(ERROR) GO TO 1505
C
        NDAT = NVALUE
        CALL GETFLT(LINE,RDAT,NDAT,ERROR)
        IF(ERROR) GO TO 1505
C
        IF(I.GT.NPX) THEN
         WRITE(*,*) 'BINPUT: Strut pylon array overflow. Increase NPX.'
         RETURN
        ENDIF
C
        KBPYLO(I)  = IDAT( 1)                          ! Nbeam
        QPYLO(0,I) = RDAT( 2) * QFAC( 2)  +  QADD( 2)  ! t 
        QPYLO(1,I) = RDAT( 3) * QFAC( 3)  +  QADD( 3)  ! xp
        QPYLO(2,I) = RDAT( 4) * QFAC( 4)  +  QADD( 4)  ! yp
        QPYLO(3,I) = RDAT( 5) * QFAC( 5)  +  QADD( 5)  ! zp
        QPYLO(4,I) = RDAT( 6) * QFAC( 6)  +  QADD( 6)  ! xw
        QPYLO(5,I) = RDAT( 7) * QFAC( 7)  +  QADD( 7)  ! yw
        QPYLO(6,I) = RDAT( 8) * QFAC( 8)  +  QADD( 8)  ! zw
        QPYLO(7,I) = RDAT( 9) * QFAC( 9)  +  QADD( 9)  ! dL
        QPYLO(8,I) = RDAT(10) * QFAC(10)  +  QADD(10)  ! EA
C
        KPTYPE(I) = 2
        NPYLO = I
 680  CONTINUE
C
C======================================
C---- pick up here to read joints
 700  CONTINUE
      VNAME = ' joint '
      NVALUE = 5
C
C---- set default data for this block
      DO J = 1, NVALUE
        QFAC(J) = 1.0
        QADD(J) = 0.0
        RDAT(J) = 0.0
        IDAT(J) = 0
      ENDDO
C
C---- try to read joint data
      IBEG = NJOIN + 1
      DO 710 I = IBEG, NJX+1
 705    CONTINUE
        ILINE = ILINE + 1
        READ(LU,1000,END=9000) LINE
C
C------ ... skip comment line ?
        IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 705
C
C------ ... end of input?  ... resume trying to read blocks of data
ccc     IF(INDEX('end',LINE(1:3)) .NE. 0) GO TO 10
        IF(INDEX('END End end',LINE(1:3)) .NE. 0) GO TO 10
C
C------ ... skip blank line ?
        IF(LBLANK(LINE)) GO TO 705
C
C------ note: *,+ data is put into QFAC(3..), QADD(3..)  to match RDAT below
C
C------ ... read specified scale factor line ?
        IF(INDEX('*',LINE(1:1)) .NE. 0) THEN
          NFAC = NVALUE-2
          CALL GETFLT(LINE(2:256),QFAC(3),NFAC,ERROR)
          IF(ERROR) THEN
           GO TO 1500
          ELSE
           GO TO 705
          ENDIF
        ENDIF
C
C------ ... read specified adder line ?
        IF(INDEX('+',LINE(1:1)) .NE. 0) THEN
          NADD = NVALUE-2
          CALL GETFLT(LINE(2:256),QADD(3),NADD,ERROR)
          IF(ERROR) THEN
           GO TO 1502
          ELSE
           GO TO 705
          ENDIF
        ENDIF
C
C------ extract up to NVALUE numbers
        NDAT = NVALUE
        CALL GETINT(LINE,IDAT,NDAT,ERROR)
        IF(ERROR) GO TO 1505
C
        NDAT = NVALUE
        CALL GETFLT(LINE,RDAT,NDAT,ERROR)
        IF(ERROR) GO TO 1505
C
        IF(I.GT.NJX) THEN
          WRITE(*,*) 'BINPUT: Joint array overflow.  Increase NJX.'
          RETURN
        ENDIF
C
        KBJOIN(1,I) = IDAT(1)                        ! Nbeam1
        KBJOIN(2,I) = IDAT(2)                        ! Nbeam1
        TJOIN(1,I)  = RDAT(3) * QFAC(3)  +  QADD(3)  ! t1
        TJOIN(2,I)  = RDAT(4) * QFAC(4)  +  QADD(4)  ! t2
C
        IF(NDAT .LT. 5) THEN
C------- default case, if joint type wasn't specified
         KJTYPE(I) = 0
        ELSE
         KJTYPE(I) = IDAT(5)
        ENDIF
C
        NJOIN = I
C
 710  CONTINUE
C
C
C======================================
C---- pick up here to read joint angles
 740  CONTINUE
      VNAME = 'j.ang. '
C
C---- try to read joint angle header
 745  CONTINUE
      ILINE = ILINE + 1
      READ(LU,1000,END=9000) LINE
C
C---- ... skip comment line ?
      IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 745
C
C---- ... end of input?  ... resume trying to read blocks of data
ccc   IF(INDEX('end',LINE(1:3)) .NE. 0) GO TO 10
      IF(INDEX('END End end',LINE(1:3)) .NE. 0) GO TO 10
C
C---- ... skip blank line ?
      IF(LBLANK(LINE)) GO TO 745
C
C---- extract up to 4 numbers
      NDAT = 4
      CALL GETINT(LINE,IDAT,NDAT,ERROR)
      IF(ERROR) GO TO 1400
C
      NDAT = 4
      CALL GETFLT(LINE,RDAT,NDAT,ERROR)
      IF(ERROR) GO TO 1400
C
      IF(NDAT .LT. 4) GO TO 1400
C
      KJ = IDAT(1)
      IF(KJ .LT. 1 .OR. KJ .GT. NJX) THEN
       WRITE(*,7410) KJ, NJX, ILINE
 7410  FORMAT(' BINPUT: Joint index',I3,
     &        ' is outside array limit NJX =',I3,
     &        ' on line', I6)
       STOP
      ENDIF
C
      HJAX(1,KJ) = RDAT(2)
      HJAX(2,KJ) = RDAT(3)
      HJAX(3,KJ) = RDAT(4)
C
      NVALUE = 2
C
C---- set default data for this block
      DO J = 1, NVALUE
        QFAC(J) = 1.0
        QADD(J) = 0.0
        RDAT(J) = 0.0
      ENDDO
C
C---- now read joint angle data
      DO 760 I = 1, NAJX+1
 755    CONTINUE
        ILINE = ILINE + 1
        READ(LU,1000,END=9000) LINE
C
C------ ... skip comment line ?
        IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 755
C
C------ ... end of input?  ... resume trying to read blocks of data
ccc     IF(INDEX('end',LINE(1:3)) .NE. 0) GO TO 10
        IF(INDEX('END End end',LINE(1:3)) .NE. 0) GO TO 10
C
C------ ... skip blank line ?
        IF(LBLANK(LINE)) GO TO 755
C
C------ ... read specified scale factor line ?
        IF(INDEX('*',LINE(1:1)) .NE. 0) THEN
          NFAC = NVALUE
          CALL GETFLT(LINE(2:256),QFAC(1),NFAC,ERROR)
          IF(ERROR) THEN
           GO TO 1500
          ELSE
           GO TO 755
          ENDIF
        ENDIF
C
C------ ... read specified adder line ?
        IF(INDEX('+',LINE(1:1)) .NE. 0) THEN
          NADD = NVALUE
          CALL GETFLT(LINE(2:256),QADD(1),NADD,ERROR)
          IF(ERROR) THEN
           GO TO 1502
          ELSE
           GO TO 755
          ENDIF
        ENDIF
C
C------ extract up to NVALUE numbers
        NDAT = NVALUE
        CALL GETFLT(LINE,RDAT,NDAT,ERROR)
        IF(ERROR) GO TO 1405
C
        IF(I.GT.NAJX) THEN
         WRITE(*,*) 
     &  'BINPUT: Too many joint angle data lines.  Max is NAJX =', NAJX
         STOP
        ENDIF
C
        MOMJ(I,KJ)  = RDAT(1) * QFAC(1)  +  QADD(1)
        ANGJ(I,KJ)  = RDAT(2) * QFAC(2)  +  QADD(2)
        NANGJ(KJ) = I
 760  CONTINUE
C
C
C======================================
C---- pick up here to read grounds
 800  CONTINUE
      VNAME = 'ground '
      NVALUE = 3
C
C---- set default scale factors and adders for this block
      DO J = 1, NVALUE
        QFAC(J) = 1.0
        QADD(J) = 0.0
        RDAT(J) = 0.0
        IDAT(J) = 0
      ENDDO
C
C---- try to read strut data
      IBEG = NGROU + 1
      DO 880 I = IBEG, NGX+1
 850     CONTINUE
         ILINE = ILINE + 1
         READ(LU,1000,END=9000) LINE
C
C------ ... skip comment line ?
        IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 850
C
C------ ... end of input?  ... resume trying to read blocks of data
ccc     IF(INDEX('end',LINE(1:3)) .NE. 0) GO TO 10
        IF(INDEX('END End end',LINE(1:3)) .NE. 0) GO TO 10
C
C------ ... skip blank line ?
        IF(LBLANK(LINE)) GO TO 850
C
C------ note: *,+ data is put into QFAC(2..), QADD(2..)  to match RDAT below
C
C------ ... read specified scale factor line ?
        IF(INDEX('*',LINE(1:1)) .NE. 0) THEN
          NFAC = NVALUE-1
          CALL GETFLT(LINE(2:256),QFAC(2),NFAC,ERROR)
          IF(ERROR) THEN
           GO TO 1500
          ELSE
           GO TO 850
          ENDIF
        ENDIF
C
C------ ... read specified adder line ?
        IF(INDEX('+',LINE(1:1)) .NE. 0) THEN
          NADD = NVALUE-1
          CALL GETFLT(LINE(2:256),QADD(2),NADD,ERROR)
          IF(ERROR) THEN
           GO TO 1502
          ELSE
           GO TO 850
          ENDIF
        ENDIF
C
        NDAT = NVALUE
        CALL GETINT(LINE,IDAT,NDAT,ERROR)
        IF(ERROR) GO TO 1505
C
        NDAT = NVALUE
        CALL GETFLT(LINE,RDAT,NDAT,ERROR)
        IF(ERROR) GO TO 1505
C
        IF(I.GT.NGX) THEN
          WRITE(*,*) 'BINPUT: Ground array overflow.  Increase NGX.'
          RETURN
        ENDIF
C
        KBGROU(I) = IDAT(1)
        TGROU(I)  = RDAT(2) * QFAC(2)  +  QADD(2)
C
        IF(NDAT .LT. 3) THEN
         KGTYPE(I) = 0
        ELSE
         KGTYPE(I) = IDAT(3)
        ENDIF
C
        NGROU = I
 880  CONTINUE
C
C
C======================================
C---- pick up here to read beam data
 900  CONTINUE
C
C---- new beam definition begins...
      NBEAM = NBEAM + 1
      IF(NBEAM.GT.NBX)  STOP 'BINPUT: Array overflow. Too many beams.'
C
C---- extract beam number from keyword line
      K = INDEX(LINE,' ')
      NDAT = 2
      CALL GETINT(LINE(K:256),IDAT,NDAT,ERROR)
      IF(ERROR .OR. NDAT.EQ.0) GO TO 1005
C
      KBNUM(NBEAM) = IDAT(1)
C
      IF(NDAT.GE.2) THEN
       IBEAM(NBEAM) = IDAT(2)
      ELSE
C----- default beam logical index is its beam number
       IBEAM(NBEAM) = KBNUM(NBEAM)
      ENDIF
C
C---- read beam name from next non-comment line (blank lines NOT ignored)
 905  CONTINUE
      ILINE = ILINE + 1
      READ(LU,1000,END=9000) LINE
      IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 905
      BNAME(NBEAM) = LINE
C
C---- no variables detected yet
      NVAR = 0
C
C---- start reading distribution blocks for this beam
C-    (starts at 0 since no block variable list is yet defined)
      DO 990 IBLOCK = 0, 12345
C
C------ set default factors and adders for this distribution block
        TFAC = 1.0
        TADD = 0.0
        DO J = 1, JDIM
          QFAC(J) = 1.0
          QADD(J) = 0.0
        ENDDO
C
C------ read data lines for this distribution block
        DO 920, I=1, IBX
 910      CONTINUE
          ILINE = ILINE + 1
          READ(LU,1000,END=9000) LINE
C
C*************************************************
C-------- echo line to screen for debugging
CCC       WRITE(*,1000) LINE(1:120)
C*************************************************
C
C======== first check for special keywords...
C
C-------- ... end of beam input ?
          IF(INDEX('END End end',LINE(1:3)) .NE. 0) GO TO 10
C
C-------- ... skip comment line ?
          IF(INDEX('!%#',LINE(1:1)) .NE. 0) GO TO 910
C
C-------- ... skip blank line ?
          IF(LBLANK(LINE)) GO TO 910
C
C-------- ... read scale factor line? (but only if a variable list is present)
          IF(INDEX('*',LINE(1:1)).NE.0 .AND. NVAR.GT.0) THEN
c            NDAT = NVAR+1
c            CALL GETFLT(LINE(2:256),RDAT,NDAT,ERROR)
c            IF(ERROR) GO TO 3900
c            IF(NDAT.GE.1) TFAC = RDAT(1)
c            DO K = 1, NDAT-1
c              QFAC(JVAR(K)) = RDAT(K+1)
c            ENDDO
            READ(LINE(2:256),*,ERR=3900,END=3900) 
     &        TFAC, (QFAC(JVAR(K)),K=1,NVAR)
            GO TO 910
          ENDIF
C
C-------- ... read adder line? (but only if a variable list is present)
          IF(INDEX('+',LINE(1:1)).NE.0 .AND. NVAR.GT.0) THEN
c            NDAT = NVAR+1
c            CALL GETFLT(LINE(2:256),RDAT,NDAT,ERROR)
c            IF(ERROR) GO TO 3902
c            IF(NDAT.GE.1) TADD = RDAT(1)
c            DO K = 1, NDAT-1
c              QADD(JVAR(K)) = RDAT(K+1)
c            ENDDO
            READ(LINE(2:256),*,ERR=3902,END=3902) 
     &        TADD, (QADD(JVAR(K)),K=1,NVAR)
            GO TO 910
          ENDIF
C
C======== no special cases found... see if new block begins
C
C-------- if there's no current variable list, go try to extract it from LINE
          IF(NVAR.EQ.0) GO TO 980
C
C-------- ignore everything after first "!", "#", or "%"
          K = INDEX(LINE,'!')
          IF(K.GT.1) LINE = LINE(1:K-1)
C
          K = INDEX(LINE,'#')
          IF(K.GT.1) LINE = LINE(1:K-1)
C
          K = INDEX(LINE,'%')
          IF(K.GT.1) LINE = LINE(1:K-1)
C
C-------- explicit check if this is the start of new block
          IF(INDEX(LINE,'t ').NE.0) GO TO 980
C
C-------- read current variables from LINE string
C-        (if error occurs, it may be the start of new block)
          READ(LINE,*,ERR=980) TB1, (QB(I,JVAR(K),NBEAM),K=1,NVAR)
C
C-------- valid read: set t coordinates for variables and apply scale factors
          DO K = 1, NVAR
            J = JVAR(K)
            TB(I,J,NBEAM) = TB1           * TFAC     +  TADD
            QB(I,J,NBEAM) = QB(I,J,NBEAM) * QFAC(J)  +  QADD(J)
            NB(J,NBEAM)   = I
          ENDDO
C
 920    CONTINUE
        WRITE(*,*) 'BINPUT: Beam input array overflow. Increase IBX'
C
 980    CONTINUE
C
C------ parse input line to see if it has a new variable list
        CALL PARSEL(LINE,JDIM,NVAR,JVAR,ERROR)
        IF(ERROR) GO TO 4100
C
        IF(NVAR.GT.JDIM) STOP 
     &   'BINPUT: Too many beam parameters in one line. Increase JDIM'
C
C------ if still no variable list, line is totally unrecognizable
        IF(NVAR.EQ.0) GO TO 3905
C
C------ go around to set up for reading this new variable block
 990  CONTINUE
C
C
C======================================
C---- pick up here on unrecognizable or illegal lines
C
 1002 WRITE(*,2002) ILINE, LINE
 2002 FORMAT(' Misplaced multiplier line',I5,' ...'/1X,A)
      STOP
C     RETURN
C
 1003 WRITE(*,2003) ILINE, LINE
 2003 FORMAT(' Misplaced adder line',I5,' ...'/1X,A)
      STOP
C     RETURN
C
C
 1005 WRITE(*,2005) ILINE, LINE
 2005 FORMAT(' Unrecognizable keyword line',I5,' ...'/1X,A)
      STOP
C     RETURN
C
 1400 WRITE(*,2400) ILINE, LINE
 2400 FORMAT(' Unrecognizable joint angle header line',I5,' ...'/1X,A)
      STOP
C     RETURN
C
 1405 WRITE(*,2405) ILINE, LINE
 2405 FORMAT(' Unrecognizable joint angle data line',I5,' ...'/1X,A)
      STOP
C     RETURN
C
 1500 WRITE(*,2500) VNAME, ILINE, LINE
 2500 FORMAT(' Read error in ',A,' block, multiplier line',I5,' ...'
     &        /1X,A)
      STOP
C     RETURN
C
 1502 WRITE(*,2502) VNAME, ILINE,LINE
 2502 FORMAT(' Read error in ',A,' block, adder line',I5,' ...'/1X,A)
      STOP
C     RETURN
C
 1505 WRITE(*,2505) VNAME, ILINE,LINE
 2505 FORMAT(' Read error in ',A,' block, data line',I5,' ...'/1X,A)
      STOP
C     RETURN
C
C
 3900 WRITE(*,3990) NBEAM, IBLOCK, ILINE, LINE
 3990 FORMAT(' Read error in beam block',I3,', distribution block',I3,
     &       ', multiplier line',I5,' ...'/1X,A)
      STOP
C     RETURN
C
 3902 WRITE(*,3992) NBEAM, IBLOCK, ILINE, LINE
 3992 FORMAT(' Read error in beam block',I3,', distribution block',I3,
     &       ', adder line',I5,' ...'/1X,A)
      STOP
C     RETURN
C
 3905 WRITE(*,3995) NBEAM, IBLOCK, ILINE, LINE
 3995 FORMAT(' Read error in beam block',I3,', distribution block',I3,
     &       ', data line',I5,' ...'/1X,A)
      STOP
C     RETURN
C
 4100 WRITE(*,4195) NBEAM, IBLOCK, ILINE, LINE
 4195 FORMAT(' Error in beam block',I3,', distribution block',I3,
     &       ', data line',I5,' ...'/1X,A)
      STOP
C     RETURN
C
C
C---- pick up here at end-of-file
 9000 CONTINUE
      RETURN
      END ! BINPUT



      LOGICAL FUNCTION LBLANK(LINE)
C---------------------------------------------------------------------
C     Returns T if the string LINE contains only blanks and/or tabs.
C     Returns F otherwise.
C---------------------------------------------------------------------
      CHARACTER*(*) LINE
      CHARACTER*1 BLANK, TAB
C
      BLANK = ' '
      TAB = CHAR(9)
C
      LBLANK = .FALSE.
      NLINE = LEN(LINE)
      DO K = 1, NLINE
        IF(LINE(K:K) .NE. BLANK .AND. LINE(K:K) .NE. TAB) RETURN
      ENDDO
      LBLANK = .TRUE.
C
      RETURN
      END ! LBLANK
      


      SUBROUTINE PARSEL(LINET,JDIM,NVAR,JVAR,ERROR)
C----------------------------------------------------------------
C     Parses string LINE, looking for any substring matching
C     one of the VARS(j) strings defined in INDEXB.INC.
C
C     NVAR returns the number of sustrings found.
C
C     JVAR(1:NVAR) returns the j indices of the VARS(j) found.
C----------------------------------------------------------------
      CHARACTER*(*) LINET
      DIMENSION JVAR(JDIM)
      LOGICAL ERROR
C
      CHARACTER*256 LINE
      CHARACTER*32 SVARS
      CHARACTER*1 TAB
C
      INCLUDE 'INDEXB.INC'
C
      TAB = CHAR(9)
C
      NLINE = LEN(LINET)
C
      KBANG = INDEX(LINET,'!')
      IF(KBANG.NE.0) NLINE = KBANG-1
C
C---- make input line with any tabs replaced with blanks
      LINE = LINET
      DO L = 1, NLINE
        IF(LINE(L:L) .EQ. TAB) LINE(L:L) = ' '
      ENDDO
C
C
      ERROR = .FALSE.
C
      NVAR = 0

      L2 = 0
C
C---- search LINE for substrings LINE(L1:L2) which match VARS strings
      DO 10 IPASS = 1, 12345
C
C------ find first non-blank character in LINE after current L2
        DO L = L2+1, NLINE
          IF( INDEX(' ',LINE(L:L)) .EQ. 0) GO TO 2
        ENDDO
C------ end of LINE... just return
        RETURN
C
 2      CONTINUE
        L1 = L
C
C------ find next non-blank character in LINE after current L1
        DO L = L1+1, NLINE
          IF( INDEX(' ,',LINE(L:L)) .NE. 0) GO TO 4
        ENDDO
 4      CONTINUE

C------ found end of word --- see which variable it is
        L2 = L-1
C
C------ skip "t" variable (this is optional in the input file)
        SVARS = ' ' // LINE(L1:L2) // ' '
        LENS = L2 - L1 + 3
        IF(INDEX(' t ',SVARS(1:LENS)) .NE. 0) GO TO 10
C
C------ check LINE substring KEY against all possible input variables
        DO J=1, JBTOT
          SVARS = ' ' // LINE(L1:L2) // ' '
          LENS = L2 - L1 + 3
          IF(INDEX(VARS(J),SVARS(1:LENS)) .NE. 0) THEN
C---------- add input-variable to list, and keep looking...
            NVAR = NVAR + 1
C
C---------- index of detected parameter (limit counter to prevent overflow)
            NVAR1 = MIN( NVAR , JDIM )
            JVAR(NVAR1) = J
            GO TO 10
          ENDIF
        ENDDO
C
C------ LINE(L1:L2) didn't match any variable, so ignore it and keep looking
        WRITE(*,*) '** Unrecognized variable keyword: ',LINE(L1:L2)
        ERROR = .TRUE.
C
 10   CONTINUE
C
      END ! PARSEL


      SUBROUTINE BOUTPUT(LU,IBX,JBX, LQBDEF,
     &               NBX, NBEAM, NB, QB, TB, BNAME, KBNUM,IBEAM,
     &               NJX, NJOIN, TJOIN, KBJOIN, KJTYPE,
     &               NGX, NGROU, TGROU, KBGROU, KGTYPE,
     &          KPX, NPX, NPYLO, QPYLO, KBPYLO, KPTYPE,
     &        NENGX, IENGTYP,
     &               NAJX,NANGJ, MOMJ, ANGJ, HJAX,
     &               UNITL, UNITM, UNITT, UNITF,
     &               UNCHL, UNCHM, UNCHT, UNCHF,
     &               GEE, RHOSL, VSOSL, SREF,CREF,BREF,XYZREF,
     &               NAME, LBSYMM)
C---------------------------------------------------
C     Reads geometry description file from unit LU.
C---------------------------------------------------
      IMPLICIT REAL (M)
      LOGICAL LQBDEF(JBX,NBX)
C
      DIMENSION NB(0:JBX,NBX), KBNUM(NBX), IBEAM(NBX)
      DIMENSION QB(IBX,0:JBX,NBX), TB(IBX,0:JBX,NBX)
C
      DIMENSION TJOIN(2,NJX)
      DIMENSION KBJOIN(2,NJX), KJTYPE(NJX)
C
      DIMENSION TGROU(NGX)
      DIMENSION KBGROU(NGX), KGTYPE(NGX)
C
      DIMENSION QPYLO(0:KPX,NPX), QPUNIT(0:KPX)
      DIMENSION KBPYLO(NPX), KPTYPE(NPX)
      DIMENSION IENGTYP(NENGX)
      DIMENSION XYZREF(3,3)
C
      DIMENSION NANGJ(NJX)
      DIMENSION MOMJ(NAJX,NJX), ANGJ(NAJX,NJX), HJAX(3,NJX)
C
      CHARACTER*(*) UNCHL, UNCHM, UNCHT, UNCHF
      CHARACTER*(*) BNAME(NBX)
      CHARACTER*(*) NAME
      LOGICAL LBSYMM(JBX,NBX)
C
C---- JDIM must be at least as large as JBX in INDEXB.INC
      PARAMETER (JDIM=102)
      DIMENSION QFAC(0:JDIM), QUNIT(0:JDIM)
      DIMENSION JSAV(JDIM)
      LOGICAL LSAVE(JDIM)
      CHARACTER*256 LINE
C
      DIMENSION NTYPE(4)
C
      INCLUDE 'INDEXB.INC'
C
      IF(JDIM.LT.JBX) STOP 'BOUTPUT: Array overflow.  JDIM < JBX'
C
 1000 FORMAT(A)
 1005 FORMAT(A1,G13.5,1X,A)
C
 1700 FORMAT(50A)
 1011 FORMAT(A ,50A11)
 1013 FORMAT(A1,50A13)
 1211 FORMAT(1X, G14.6,50F11.5)
 1313 FORMAT(1X,5G13.5)
C
 1511 FORMAT( I6,2X, G14.6, 50F11.5)
 1521 FORMAT(2I6,2X, G14.6, 50F11.5)
 1531 FORMAT(3I6,2X, G14.6, 50F11.5)
 1613 FORMAT(2I7,2X, 2G14.6, I5)
 1713 FORMAT( I7,2X,  G14.6, I5)
 2005 FORMAT(A,2I7)
 2011 FORMAT(G11.1)
C
      DTOR = ATAN(1.0) / 45.0
C
C---- set unit for each J index according to the type of variable it is
      DO J=1, JDIM
        QUNIT(J) = 1.0
C
        IF(J.EQ.JXA ) QUNIT(J) = UNITL
        IF(J.EQ.JYA ) QUNIT(J) = UNITL
        IF(J.EQ.JZA ) QUNIT(J) = UNITL
        IF(J.EQ.JCH ) QUNIT(J) = UNITL
C
        IF(J.EQ.JTW ) QUNIT(J) = DTOR
        IF(J.EQ.JAL ) QUNIT(J) = DTOR
C
        IF(J.EQ.JCM ) QUNIT(J) = 1.0
        IF(J.EQ.JCDF) QUNIT(J) = 1.0
        IF(J.EQ.JCDP) QUNIT(J) = 1.0
        IF(J.EQ.JCMX) QUNIT(J) = 1.0
        IF(J.EQ.JCMN) QUNIT(J) = 1.0
        IF(J.EQ.JDCL) QUNIT(J) = 1.0
C
        IF(J.EQ.JECC) QUNIT(J) = UNITF*UNITL**2
        IF(J.EQ.JENN) QUNIT(J) = UNITF*UNITL**2
        IF(J.EQ.JECN) QUNIT(J) = UNITF*UNITL**2
        IF(J.EQ.JGJ ) QUNIT(J) = UNITF*UNITL**2
        IF(J.EQ.JEA ) QUNIT(J) = UNITF
C
        IF(J.EQ.JMG1 ) QUNIT(J) = UNITF/UNITL
        IF(J.EQ.JMCC1) QUNIT(J) = UNITF*UNITL
        IF(J.EQ.JMNN1) QUNIT(J) = UNITF*UNITL
C
        IF(J.EQ.JCCG1) QUNIT(J) = UNITL
        IF(J.EQ.JNCG1) QUNIT(J) = UNITL
C
        IF(J.EQ.JMG2 ) QUNIT(J) = UNITF/UNITL
        IF(J.EQ.JMCC2) QUNIT(J) = UNITF*UNITL
        IF(J.EQ.JMNN2) QUNIT(J) = UNITF*UNITL
C
        IF(J.EQ.JCCG2) QUNIT(J) = UNITL
        IF(J.EQ.JNCG2) QUNIT(J) = UNITL
C
        IF(J.EQ.JXAX) QUNIT(J) = 1.0
C
c        DO KF=1, NFLPX
c          JCLF = JCLF1-1 + KF
c          JCMF = JCMF1-1 + KF
c          JCDF = JCDF1-1 + KF
c          IF(J.EQ.JCLF) QUNIT(J) = 1.0
c          IF(J.EQ.JCMF) QUNIT(J) = 1.0
c          IF(J.EQ.JCDF) QUNIT(J) = 1.0
c        ENDDO
C
        IF(J.EQ.JTDE) QUNIT(J) = UNITT
        IF(J.EQ.JTDG) QUNIT(J) = UNITT
C
        IF(J.EQ.JCEA) QUNIT(J) = UNITL
        IF(J.EQ.JNEA) QUNIT(J) = UNITL
C
        IF(J.EQ.JCSH) QUNIT(J) = UNITL
        IF(J.EQ.JNSH) QUNIT(J) = UNITL
        IF(J.EQ.JASH) QUNIT(J) = UNITL**3
      ENDDO
C
C
C----------------------------------------------
C---- write name label line
C
      WRITE(LU,1000) '#========================================'
      WRITE(LU,1000) 'Name'
      WRITE(LU,1000) NAME
      WRITE(LU,1000) 'End'
C
C----------------------------------------------
C---- write units lines
C
      WRITE(LU,1000) '#========================================'
      WRITE(LU,1000) 'Unit'
      WRITE(LU,1005) 'L', UNITL, UNCHL
      WRITE(LU,1005) 'T', UNITT, UNCHT
      WRITE(LU,1005) 'F', UNITF, UNCHF
      WRITE(LU,1000) 'End'
C
C----------------------------------------------
C---- write Constants line
C
      WRITE(LU,1000) '#========================================'
      WRITE(LU,1000) 'Constant'
      WRITE(LU,1013) '#',
     &               '       g     ',
     &               '     rhoSL   ',
     &               '     VsoSL   '
      WRITE(LU,1313)  GEE  *UNITT**2/UNITL,
     &                RHOSL*UNITL**3/UNITM,
     &                VSOSL*UNITT   /UNITL
      WRITE(LU,1000) 'End'
C
C----------------------------------------------
C---- write Reference line
C
      WRITE(LU,1000) '#========================================'
      WRITE(LU,1000) 'Reference'
      WRITE(LU,1013) '#',
     &               '      Sref   ',
     &               '      Cref   ',
     &               '      Bref   '
      WRITE(LU,1313) SREF/UNITL**2,
     &               CREF/UNITL   ,
     &               BREF/UNITL
      WRITE(LU,1013) '#'
      WRITE(LU,1013) '#',
     &               '      Xmom   ',
     &               '      Ymom   ',
     &               '      Zmom   '
      WRITE(LU,1313) XYZREF(1,1)/UNITL,
     &               XYZREF(2,1)/UNITL,
     &               XYZREF(3,1)/UNITL
      WRITE(LU,1013) '#'
      WRITE(LU,1013) '#',
     &               '      Xacc   ',
     &               '      Yacc   ',
     &               '      Zacc   '
      WRITE(LU,1313) XYZREF(1,2)/UNITL,
     &               XYZREF(2,2)/UNITL,
     &               XYZREF(3,2)/UNITL
      WRITE(LU,1013) '#'
      WRITE(LU,1013) '#',
     &               '      Xvel   ',
     &               '      Yvel   ',
     &               '      Zvel   '
      WRITE(LU,1313) XYZREF(1,3)/UNITL,
     &               XYZREF(2,3)/UNITL,
     &               XYZREF(3,3)/UNITL
      WRITE(LU,1000) 'End'
C
C
C=======================================================================
C
C---- set number of weights, struts, engines, sensors
      NTYPE(1) = 0
      NTYPE(2) = 0
      NTYPE(3) = 0
      NTYPE(4) = 0
      DO IP = 1, NPYLO
        IF    (KPTYPE(IP).EQ. 1) THEN
         NTYPE(1) = NTYPE(1) + 1
        ELSEIF(KPTYPE(IP).EQ. 2) THEN
         NTYPE(2) = NTYPE(2) + 1
        ELSEIF(KPTYPE(IP).GT.100) THEN
         NTYPE(4) = NTYPE(4) + 1
        ELSEIF(KPTYPE(IP).GT.10) THEN
         NTYPE(3) = NTYPE(3) + 1
        ELSE
         WRITE(*,*) '? BOUTPUT: Illegal pylon type index:', KPTYPE(IP)
        ENDIF
      ENDDO
C
C----------------------------------------------
C---- write pylon data (weight, surface, strut) if these exist
C
C---- go over each type of pylon entity
      DO 50 IPTYPE = 1, 4
C
C---- skip this entity if there aren't any present
      IF(NTYPE(IPTYPE).EQ.0) GO TO 50
C
      IF    (IPTYPE.EQ.1) THEN
C------ set up for weight data output
        NJ = 9
C
        QPUNIT(0) = 1.0
        QPUNIT(1) = UNITL
        QPUNIT(2) = UNITL
        QPUNIT(3) = UNITL
        QPUNIT(4) = UNITF
        QPUNIT(5) = UNITL**2
        QPUNIT(6) = UNITL**3
        QPUNIT(7) = UNITF*UNITL**2/UNITT
        QPUNIT(8) = UNITF*UNITL**2/UNITT
        QPUNIT(9) = UNITF*UNITL**2/UNITT
C
        WRITE(LU,1000) '#========================================'
        WRITE(LU,1000) 'Weight'
C
C------ write point-weight label line
        WRITE(LU,1700) '#',
     &   ' Nbeam',
     &   '       t       ',
     &   '      Xp   ',
     &   '      Yp   ',
     &   '      Zp   ',
     &   '      Mg   ',
     &   '      CDA  ',
     &   '      Vol  ',
     &   '      Hxg  ',
     &   '      Hyg  ',
     &   '      Hzg  '
CCC       123456789012
C
      ELSEIF(IPTYPE.EQ.2) THEN
C------ set up for strut data output
        NJ = 8
C
        QPUNIT(0) = 1.0
        QPUNIT(1) = UNITL
        QPUNIT(2) = UNITL
        QPUNIT(3) = UNITL
        QPUNIT(4) = UNITL
        QPUNIT(5) = UNITL
        QPUNIT(6) = UNITL
        QPUNIT(7) = UNITL
        QPUNIT(8) = UNITF
C
        WRITE(LU,1000) '#========================================'
        WRITE(LU,1000) 'Strut'
C
C------ write strut-data label line
        WRITE(LU,1700) '#',
     &   ' Nbeam',
     &   '       t       ',
     &   '      Xp   ',
     &   '      Yp   ',
     &   '      Zp   ',
     &   '      Xw   ',
     &   '      Yw   ',
     &   '      Zw   ',
     &   '      dL   ',
     &   '      EA   '
CCC       123456789012
      ELSEIF(IPTYPE.EQ.3) THEN
C------ set up for engine data output
        NJ = 21
C
        QPUNIT( 0) = 1.0
        QPUNIT( 1) = UNITL
        QPUNIT( 2) = UNITL
        QPUNIT( 3) = UNITL
        QPUNIT( 4) = 1.0
        QPUNIT( 5) = 1.0
        QPUNIT( 6) = 1.0
        QPUNIT( 7) = UNITF
        QPUNIT( 8) = UNITF*UNITL
        QPUNIT( 9) = UNITL
        QPUNIT(10) = 1.0/UNITT
        QPUNIT(11) = UNITL**2
        DO J = 12, NJ
          QPUNIT(J) = 1.0
        ENDDO
C
        WRITE(LU,1000) '#========================================'
        WRITE(LU,1000) 'Engine'
C
C------ this assumes all engines are of the same type
        KE = 1
C
C------ write engine-data label line
        IF(IENGTYP(KE) .EQ. 0) THEN
          NJ = 8
          WRITE(LU,1700) '#',
     &   ' KPeng',
     &   ' IEtyp',
     &   ' Nbeam',
     &   '       t       ',
     &   '      Xp   ',
     &   '      Yp   ',
     &   '      Zp   ',
     &   '      Tx   ',
     &   '      Ty   ',
     &   '      Tz   ',
     &   '   dFdPeng ',
     &   '   dMdPeng '

        ELSEIF(IENGTYP(KE) .EQ. 1) THEN
          NJ = 11
          WRITE(LU,1700) '#',
     &   ' KPeng',
     &   ' IEtyp',
     &   ' Nbeam',
     &   '       t       ',
     &   '      Xp   ',
     &   '      Yp   ',
     &   '      Zp   ',
     &   '      Tx   ',
     &   '      Ty   ',
     &   '      Tz   ',
     &   '   dFdPeng ',
     &   '   dMdPeng ',
     &   '    Rdisk  ',
     &   '    Omega  ',
     &   '     cdA   '

        ELSE
          NJ = 21
          WRITE(LU,1700) '#',
     &   ' KPeng',
     &   ' IEtyp',
     &   ' Nbeam',
     &   '       t       ',
     &   '      Xp   ',
     &   '      Yp   ',
     &   '      Zp   ',
     &   '      Tx   ',
     &   '      Ty   ',
     &   '      Tz   ',
     &   '   dFdPeng ',
     &   '   dMdPeng ',
     &   '    Rdisk  ',
     &   '    Omega  ',
     &   '     cdA   ',
     &   '     S0    ',
     &   '     C0    ',
     &   '     S1    ',
     &   '     C1    ',
     &   '     S2    ',
     &   '     C2    ',
     &   '     S3    ',
     &   '     C3    ',
     &   '     S4    ',
     &   '     C4    ' 
CCC       123456789012
        ENDIF

      ELSEIF(IPTYPE.EQ.4) THEN
C------ set up for sensor data output
        NJ = 9
C
        QPUNIT(0) = 1.0
        QPUNIT(1) = UNITL
        QPUNIT(2) = UNITL
        QPUNIT(3) = UNITL
        QPUNIT(4) = 1.0
        QPUNIT(5) = 1.0
        QPUNIT(6) = 1.0
        QPUNIT(7) = 1.0
        QPUNIT(8) = 1.0
        QPUNIT(9) = 1.0
C
        WRITE(LU,1000) '#========================================'
        WRITE(LU,1000) 'Sensor'
C
C------ write sensor-data label line
        WRITE(LU,1700) '#',
     &   ' Ksens',
     &   ' Nbeam',
     &   '       t       ',
     &   '      Xo   ',
     &   '      Yo   ',
     &   '      Zo   ',
     &   '      Vx   ',
     &   '      Vy   ',
     &   '      Vz   ',
     &   '      Ax   ',
     &   '      Ay   ',
     &   '      Az   '
CCC       123456789012
      ENDIF
C
C----------------------------------------------
C---- generate and write multiplier line
C
      K0 = 0
      DO KP = 1, NPYLO
        IF    ((IPTYPE.EQ.1 .AND. KPTYPE(KP).EQ.1) .OR.
     &         (IPTYPE.EQ.2 .AND. KPTYPE(KP).EQ.2)      ) THEN
         K0 = 2 + 6  + 14
        ELSEIF( IPTYPE.EQ.4 .AND. KPTYPE(KP).GT.100     ) THEN
         K0 = 2 + 12 + 14
        ELSEIF( IPTYPE.EQ.3 .AND. KPTYPE(KP).GT.10      ) THEN
         K0 = 2 + 18 + 14
        ENDIF
      ENDDO
      IF(K0.EQ.0) WRITE(*,*) '? K0=0, IPTYPE=', IPTYPE

      LINE = '*'
      LINE(K0-14:K0-1) = '       1.     '
CCC                       12345678901234

C---- scale factors for all quantities
      QFAC(0) = 1.0
      DO J = 1, NJ
        QMAX = 0.
        DO KP = 1, NPYLO
          IF((KPTYPE(KP).EQ.IPTYPE) .OR.
     &       (KPTYPE(KP).GT.10 .AND.
     &           IPTYPE.EQ.3 ) ) QMAX = MAX(QMAX , ABS(QPYLO(J,KP)))
        ENDDO
C
        QMAX = QMAX / QPUNIT(J)
C
        IF(QMAX .EQ. 0.0) THEN
          QFAC(J) = 1.0
        ELSE
ccc       IEXP = INT( LOG10(QMAX)/3.0 + 100.0 )*3 - 300
          IEXP = INT( LOG10(2.0*QMAX) + 100.0 )   - 100
          QFAC(J) = 10.0**IEXP
        ENDIF
C
        K1 = K0 + 11*(J-1) + 1
        K2 = K0 + 11*(J-1) + 11
        WRITE(LINE(K1:K2),2011) QFAC(J)
      ENDDO
C
C---- write the scaling factor line
      WRITE(LU,1000) LINE(1:K2)
C
C---- write pylon entity data
      KP1 = 1
      KP2 = NPYLO
      DO KP = KP1, KP2
        IF    ((IPTYPE.EQ.1 .AND. KPTYPE(KP).EQ.1) .OR.
     &         (IPTYPE.EQ.2 .AND. KPTYPE(KP).EQ.2)      ) THEN
          WRITE(LU,1511) KBPYLO(KP), 
     &                   (QPYLO(J,KP)/QFAC(J)/QPUNIT(J), J=0, NJ)

        ELSEIF( IPTYPE.EQ.4 .AND. KPTYPE(KP).GT.100     ) THEN
          KS = KPTYPE(KP) - 100
          WRITE(LU,1521) KS, KBPYLO(KP), 
     &                   (QPYLO(J,KP)/QFAC(J)/QPUNIT(J), J=0, NJ)

        ELSEIF( IPTYPE.EQ.3 .AND. KPTYPE(KP).GT.10      ) THEN
          KE = KPTYPE(KP) - 10
          IETYP = IENGTYP(KE)
          WRITE(LU,1531) KE, IETYP, KBPYLO(KP), 
     &                   (QPYLO(J,KP)/QFAC(J)/QPUNIT(J), J=0, NJ)
        ENDIF
      ENDDO
      WRITE(LU,1000) 'End'
C
C
 50   CONTINUE
C
C
C=======================================================================
      IF(NJOIN.GT.0) THEN
C
C---- write Joint lines
C
      WRITE(LU,1000) '#========================================'
      WRITE(LU,1000) 'Joint'
      WRITE(LU,1000)
     &'# Nbeam1 Nbeam2      t1            t2         KJtype'
CCC     123456789012345678901234567890123123456789012312345678901234567890

      DO KJ = 1, NJOIN
        WRITE(LU,1613) KBJOIN(1,KJ), KBJOIN(2,KJ),
     &                 TJOIN(1,KJ),  TJOIN(2,KJ),
     &                 KJTYPE(KJ)
      ENDDO
      WRITE(LU,1000) 'End'
C
      ENDIF
C
C=======================================================================
C---- write Joint angle data, if any
      DO KJ = 1, NJOIN
        IF(NANGJ(KJ) .GT. 0) THEN
         WRITE(LU,1000) '#========================================'
         WRITE(LU,1000) 'Jangle'
         WRITE(LU,1000) '#'
         WRITE(LU,1000) '#   Kj      hx        hy        hz'
CCC                        1234     1.0234    1.0234    1.0234
         WRITE(LU,1621)  KJ, (HJAX(K,KJ), K=1,3)
 1621    FORMAT(1X,I5,2X,3F10.4)
C
         WRITE(LU,1000) '#'
         WRITE(LU,1000)  
     &'#       Mh           ah'
CCC     1234567890123 1234567890123
         DO I = 1, NANGJ(KJ)
           WRITE(LU,1622) MOMJ(I,KJ)/(UNITF*UNITL), ANGJ(I,KJ)/DTOR
 1622      FORMAT(1X,2G14.6)
         ENDDO
        ENDIF
      ENDDO
C
C=======================================================================
      IF(NGROU.GT.0) THEN
C
C---- write Ground lines
C
      WRITE(LU,1000) '#========================================'
      WRITE(LU,1000) 'Ground'
      WRITE(LU,1000) '#  Nbeam       t         KGtype'
CCC                    1234567812345678901231234567890123
      DO IG = 1, NGROU
        WRITE(LU,1713) KBGROU(IG), TGROU(IG), KGTYPE(IG)
      ENDDO
      WRITE(LU,1000) 'End'
C
      ENDIF
C
C=======================================================================
C
C---- go over beams
      DO 900 IS = 1, NBEAM
C
      WRITE(LU,1000) '#================================================'
      IF(IBEAM(IS).EQ.KBNUM(IS)) THEN
       WRITE(LU,2005) 'Beam', KBNUM(IS)
      ELSE
       WRITE(LU,2005) 'Beam', KBNUM(IS), IBEAM(IS)
      ENDIF
      WRITE(LU,1000)  BNAME(IS)
C
      DO J=1, JBTOT
C------ initialize factor
        QFAC(J) = 1.0
C
C------ mark variable for saving only if it was defined in input file
C-       or modified in the EDIT menu (LQBDEF=t either way)
        LSAVE(J) = LQBDEF(J,IS)
      ENDDO
C
C
C=======================================================================
C---- go over blocks of data
      DO 100 IBLOCK=1, 12345
C
C------ find next variable to be saved, go to next beam if none left
        DO 10 J=1, JBTOT
          IF(LSAVE(J)) GO TO 11
 10     CONTINUE
        WRITE(LU,1000) 'End'
        GO TO 900
C
 11     CONTINUE
        JKEY = J
C
C------ this variable will be saved now, but not later
        KSAV = 1
        JSAV(KSAV) = J
        LSAVE(J) = .FALSE.
C
C------ find all other to-be-saved variables with the same TB distributions
        DO 20 J = JKEY+1, JBTOT
          IF(.NOT.LSAVE(J) .OR. NB(J,IS).NE.NB(JKEY,IS)) GO TO 20
C
          IF(     LBSYMM(J,IS) .AND. .NOT.LBSYMM(JKEY,IS)) GO TO 20
          IF(.NOT.LBSYMM(J,IS) .AND.      LBSYMM(JKEY,IS)) GO TO 20
C
          DELTN = ABS(TB(NB(J,IS),J,IS) - TB(1,J,IS))
C
          DO I=1, NB(J,IS)
            DELT = ABS(TB(I,J,IS) - TB(I,JKEY,IS))
            IF( DELT .GT. 0.00001*DELTN ) GO TO 20
          ENDDO
C
C-------- vairable J has same TB array as variable JKEY ... mark it for saving
          KSAV = KSAV+1
          JSAV(KSAV) = J
          LSAVE(J) = .FALSE.
C
C-------- don't try to write more than 6 variables in one distribution block
C-         (file gets too wide to edit easily)
          IF(KSAV.GE.6) GO TO 21
 20     CONTINUE
 21     CONTINUE
C
C------ number of variables to be saved
        NSAV = KSAV
C
C---------------------------------------------
C------ write variable label line for this block
C
        WRITE(LU,1000) '#----------------------------------'
        WRITE(LU,1011) '       t        ',(VARS(JSAV(KSAV)),KSAV=1,NSAV)
C                       123456789012345
C
C---------------------------------------------
C------ generate and write multiplier line
C
        WRITE(LINE(1:15),1000) '*      1.      '
CCC                             123456789012345
C
C------ scale factors for all variables
        DO KSAV = 1, NSAV
          J = JSAV(KSAV)
C
          QMAX = 0.
          DO I = 1, NB(J,IS)
            QMAX = MAX( QMAX , ABS(QB(I,J,IS)) )
          ENDDO
C
          QMAX = QMAX/QUNIT(J)
C
          IF(QMAX .EQ. 0.0) THEN
            QFAC(J) = 1.0
          ELSE
ccc         IEXP = INT( LOG10(QMAX)/3.0 + 100.0 )*3 - 300
            IEXP = INT( LOG10(2.0*QMAX) + 100.0 )   - 100
            QFAC(J) = 10.0**IEXP
          ENDIF
C
          K1 = 15 + 11*(KSAV-1) + 1
          K2 = 15 + 11*(KSAV-1) + 11
          WRITE(LINE(K1:K2),2011) QFAC(J)
        ENDDO
C
C------ write the scaling factor line
        WRITE(LU,1000) LINE(1:K2)
C
C------------------------------------------------
C------ write variable distributions
        IB1 = 1
        IB2 = NB(JKEY,IS)
        IF(LBSYMM(JKEY,IS)) IB1 = NB(JKEY,IS)/2 + 1
        DO I = IB1, IB2
          WRITE(LU,1211) TB(I,JKEY,IS),
     &       (QB(I,JSAV(KSAV),IS)/QFAC(JSAV(KSAV))/QUNIT(JSAV(KSAV)), 
     &                KSAV=1, NSAV)
        ENDDO
C
 100  CONTINUE
 900  CONTINUE
C
      RETURN
      END ! BOUTPUT




      SUBROUTINE QBCHEK(J, IBX,JBX,NB,TB,QB, TL,TR,QDEF1)
      DIMENSION NB(0:JBX), TB(IBX,0:JBX), QB(IBX,0:JBX)
C-------------------------------------------------------------
C     Checks if distribution variable J has been specified.
C     If not, sets default distribution equal to QDEF1.
C
C     Special case: If QDEF1=999.0, variable J is taken to
C     be infinite, but stored internally as zero.
C-------------------------------------------------------------
      CHARACTER*10 VALUE
C
      INCLUDE 'INDEXB.INC'
C
C
      QDEF = QDEF1
      WRITE(VALUE,1000) QDEF
 1000 FORMAT(F10.5)
C
      IF(QDEF1 .EQ. 999. ) THEN
        QDEF = 0.
        VALUE = '  infinite'
      ENDIF
C
      IF(NB(J) .LT. 2) THEN
        WRITE(*,1100) VARS(J), VALUE
 1100   FORMAT(1X,A,'distribution not specified.   Assuming  ', A)
        NB(J) = 2
        TB(1,J) = TL
        TB(2,J) = TR
        QB(1,J) = QDEF
        QB(2,J) = QDEF
      ENDIF
C
      RETURN
      END ! QBCHEK



      SUBROUTINE QBDIR(NB,TB,QB)
      DIMENSION TB(*), QB(*)
C-------------------------------------------------------------
C     Checks if TB array is increasing.
C     If not, TB and QB get reversed.
C-------------------------------------------------------------
C
      IF(NB .LE. 0) RETURN
C
      IF(TB(1) .GT. TB(NB)) THEN
        DO IB = 1, NB/2
          IBR = NB - IB + 1
C
          TMP = TB(IB)
          TB(IB) = TB(IBR)
          TB(IBR) = TMP
C
          TMP = QB(IB)
          QB(IB) = QB(IBR)
          QB(IBR) = TMP
        ENDDO
      ENDIF
C
      RETURN
      END ! QBDIR

