

      subroutine axisol(xnose,xend,xcab1,xcab2,Afuse, Mach, n,
     &                  xc,yc,sc,qc)
      implicit real (a-h,m,o-z)

      real xc(*), yc(*), sc(*), qc(*)

      parameter (idim=51)
      real tl(idim), xl(idim), yl(idim), sl(idim), src(idim)
      real ul(idim), vl(idim), ql(idim)
      real tc(idim),  
     &     pc(idim), fc(idim), 
     &     uc(idim), vc(idim), ac(idim)
      real yxc(idim), nxc(idim), nyc(idim)

      real aa(idim,idim), rr(idim)

      data pi / 3.1415926535897932384626 /

      nmax = n+1 + n/2 + 1
      if(nmax .ge. idim) then
       write(*,*) 'AXISOL: Local-array overflow.  Increase idim to',nmax
       stop
      endif

      ispace = 1

      write(*,*) 'xend=', xend

      beta = sqrt(1.0 - Mach**2)

      Rfuse = sqrt(Afuse/pi)
      anose = 1.65
      btail = 2.0

      nl = n+1
      do i = 1, nl
        fi = float(i-1) / float(nl-1)
        tl(i) = fi

        if(ispace.eq.0) then
         frac = tl(i)
        else
         frac = 0.5*(1.0 - cos(pi*tl(i)))
        endif
        xl(i) = xnose*(1.0-frac) + xend*frac

        if(i.eq.1 .or. i.eq.nl) then
         yl(i) = 0.
        elseif(xl(i) .lt. xcab1) then
         f = 1.0 - (xl(i)-xnose)/(xcab1-xnose)
         yl(i) = Rfuse*(1.0 - f**anose)**(1.0/anose)
        elseif(xl(i) .lt. xcab2) then
         yl(i) = Rfuse
        else
         f = (xl(i)-xcab2)/(xend-xcab2)
         yl(i) = Rfuse*(1.0 - f**btail)
        endif
      enddo

      yl(nl) = 0.25*yl(nl-1)

      nlw = nl + (nl-1)/2 + 1
      do i = nl+1, nlw
        xl(i) = 2.0*xend - xl(2*nl-i)
        yl(i) = 0.125*yl(nl-1)
      enddo




      do i = 1, n
        tc(i) = 0.5*(tl(i)+tl(i+1))

        if(ispace.eq.0) then
         frac = tc(i)
        else
         frac = 0.5*(1.0 - cos(pi*tc(i)))
        endif
        xc(i) = xnose*(1.0-frac) + xend*frac

cc        xc(i) = 0.5*(xl(i) + xl(i+1))

        if    (xc(i) .lt. xcab1) then
         f = 1.0 - (xc(i)-xnose)/(xcab1-xnose)
         f_x = -1.0/(xcab1-xnose)
         yc(i) = Rfuse*(1.0 - f**anose)**(1.0/anose)
         y_f = -yc(i)/(1.0 - f**anose) * f**(anose-1.0)
         y_x = y_f*f_x
        elseif(xc(i) .lt. xcab2) then
         yc(i) = Rfuse
         y_x = 0.
        else
         f = (xc(i)-xcab2)/(xend-xcab2)
         f_x = 1.0/(xend-xcab2)
         yc(i) = Rfuse*(1.0 - f**btail)
         y_f = -Rfuse*btail*f**(btail-1.0)
         y_x = y_f*f_x
        endif

        nxc(i) =  y_x / sqrt(1.0 + y_x**2)
        nyc(i) = -1.0 / sqrt(1.0 + y_x**2)

        yxc(i) = y_x

        ds = sqrt((xl(i+1)-xl(i))**2 + (yl(i+1)-yl(i))**2)
        ac(i) = ds * 2.0*pi*(yl(i) + 4.0*yc(i) + yl(i+1))/6.0
      enddo

      nw = nlw-1
      do i = n+1, nw
        xc(i) = 2.0*xend - xc(2*n-i+1)
        yc(i) = 0.5*yc(n)
      enddo

      sc(1) = sqrt((xc(1)-xnose)**2 + (yc(1)-0.0)**2)
      do i = 1, nw-1
        ds = sqrt((xc(i+1)-xc(i))**2 + (yc(i+1)-yc(i))**2)
        sc(i+1) = sc(i) + ds
      enddo

      sl(1) = 0.
      do i = 1, nlw-1
        ds = sqrt((xl(i+1)-xl(i))**2 + (yl(i+1)-yl(i))**2)
        sl(i+1) = sl(i) + ds
      enddo




      do i = 1, n
        rr(i) = 0.
        do j = 1, n
          aa(i,j) = 0.
        enddo
      enddo

      do i = 1, n
        do j = 1, n
          call pfuv(xc(i),yc(i),xl(j),xl(j+1), p0,f0,u0,v0,beta)
          aa(i,j) = aa(i,j) + u0*nxc(i) + v0*nyc(i)
        enddo
        rr(i) = nxc(i)
      enddo

c     do i = 1, n
c       write(*,'(1x,20f8.3)') (aaf(i,j),j=1,n), rr(i)
c     enddo

      call gaussn(idim,n,aa,rr,1)
      do i = 1, n
        src(i) = -rr(i)
      enddo
      
c      do i = 1, n
c        write(1,*) xc(i), src(i)
c      enddo


      aq0tot = 0.
      aq2tot = 0.
      aq3tot = 0.
      do i = 1, nw
        pc(i) =     xc(i)
        fc(i) = 0.5*yc(i)**2
        uc(i) = 1.0
        vc(i) = 0.0
        do j = 1, n
          call pfuv(xc(i),yc(i), xl(j),xl(j+1), p0,f0,u0,v0,beta)
          pc(i) = pc(i) + p0*src(j)
          fc(i) = fc(i) + f0*src(j)
          uc(i) = uc(i) + u0*src(j)
          vc(i) = vc(i) + v0*src(j)
        enddo
        qc(i) = sqrt(uc(i)**2 + vc(i)**2)
        vdotn = uc(i)*nxc(i) + vc(i)*nyc(i)

        aq0tot = aq0tot + ac(i)
        aq2tot = aq2tot + ac(i) * qc(i)**2
        aq3tot = aq3tot + ac(i) * qc(i)**3

        write(2,'(1x,9g13.5)') 
     &     xc(i),yc(i),sc(i), qc(i), src(i), pc(i),fc(i), uc(i),vc(i)
      enddo


      do i = 2, nlw
        ul(i) = 1.0
        vl(i) = 0.0
        do j = 1, n
          call pfuv(xl(i),yl(i), xl(j),xl(j+1), p0,f0,u0,v0,beta)
          ul(i) = ul(i) + u0*src(j)
          vl(i) = vl(i) + v0*src(j)
        enddo
        ql(i) = sqrt(ul(i)**2 + vl(i)**2)

        write(3,'(1x,9g13.5)') 
     &     xl(i),yl(i),sl(i), ql(i)
      enddo

      return
      end




      subroutine pfuv(x,r,x1,x2, p0,f0,u0,v0,b)
      data qopi / 0.0795774715459476678 /

      bsq = b**2

      rb = r*b

      R1 = sqrt((x-x1)**2 + rb**2)
      R2 = sqrt((x-x2)**2 + rb**2)

c      p0_rb = -((x-x2)/R2 - (x-x1)/R1)*qopi/rb
c      v0 = p0_rb*rb_r

      p0 = log( (R1-x+x1) / (R2-x+x2) ) * qopi / bsq
      f0 = (R2 - R1 - (x2-x1)) * qopi
      u0 =  ( 1.0  /R2 -  1.0  /R1)*qopi  / bsq
      v0 = -((x-x2)/R2 - (x-x1)/R1)*qopi/r/ bsq

      return
      end
