
      subroutine blax(ndim, n,ite, xi,ri,uei, Reyn, Mach,
     &                thi, dsi, tsi, cfi, cdi, hki )
      implicit real (a-h,m,o-z)

      real xi(ndim), ri(ndim), uei(ndim), 
     &     thi(ndim), dsi(ndim), tsi(ndim),
     &     cfi(ndim), cdi(ndim), hki(ndim)

      real aa(3,3), res(3)

      logical simi, lami, direct

      data acon, bcon / 6.70, 0.75 /
      data hksep / 3.0 /

      data eps / 1.0e-6 /


      direct = .true.

      do 500 i = 2, n

      x = xi(i)
      r = ri(i)

      simi = xi(i-1) .eq. 0.0
      lami = simi

c---- initialize this station
      if(simi) then
       ue = uei(i)
       rex = ue*x * Reyn
       th = 0.4*x / sqrt(rex)
       ds = th * 2.4
      else
       th = thi(i-1)
       ds = dsi(i-1)
       if(direct) then
        ue = uei(i)
       else
        ue = uei(i-1)
       endif
      endif


      direct = .true.
      hkprev = 0.

      do 100 iter = 1, 20

      msq = (ue*Mach)**2
      msq_ue = 2.0*ue*Mach**2

      h = ds/th
      h_ds = 1.0/th
      h_th =  -h/th

      call hkin( h , msq , hk, hk_h, hk_msq)
      hk_th = hk_h*h_th
      hk_ds = hk_h*h_ds
      hk_ue = hk_msq*msq_ue

      hk = max( hk , 1.005 )
      if(iter.eq.1) then
       hkprev = hk
      else
       if(hk .gt. hksep) then ! .and. hk .gt. hkprev) then
        direct = .false.
       endif
      endif

      call hct( hk, msq, hc, hc_hk, hc_msq )
      hc_th = hc_hk*hk_th
      hc_ds = hc_hk*hk_ds
      hc_ue = hc_hk*hk_ue + hc_msq*msq_ue

      rt = ue*th*Reyn
      rt_ue = th*Reyn
      rt_th = ue*Reyn

      if(lami) then
       call hsl( hk, rt, msq, hs, hs_hk, hs_rt, hs_msq )
       call cfl( hk, rt, msq, cf, cf_hk, cf_rt, cf_msq )
      else
       call hst( hk, rt, msq, hs, hs_hk, hs_rt, hs_msq )
       call cft( hk, rt, msq, cf, cf_hk, cf_rt, cf_msq )
      endif

      hs_th = hs_hk*hk_th + hs_rt*rt_th
      hs_ds = hs_hk*hk_ds
      hs_ue = hs_hk*hk_ue + hs_rt*rt_ue + hs_msq*msq_ue
 
      cf_th = cf_hk*hk_th + cf_rt*rt_th
      cf_ds = cf_hk*hk_ds
      cf_ue = cf_hk*hk_ue + cf_rt*rt_ue + cf_msq*msq_ue

      if(i .gt. ite) then
       cf = 0.
       cf_th = 0.
       cf_ds = 0.
       cd_ue = 0.
       cfxm = 0.
      endif

      if(lami) then
       call dil( hk, rt, di, di_hk, di_rt )
       di_th = di_hk*hk_th + di_rt*rt_th
       di_ds = di_hk*hk_ds
       di_ue = di_hk*hk_ue + di_rt*rt_ue
      else
       hrat = (hk-1.0)/(acon*hk)
       hrat_hk = 1.0/(acon*hk**2)

       uq = (0.5*cf - hrat**2) / (bcon*hk)
       uq_cf = 0.5 / (bcon*hk)
       uq_hk = -2.0*hrat/(bcon*hk) * hrat_hk - uq/hk

       uq_th = uq_cf*cf_th + uq_hk*hk_th
       uq_ds = uq_cf*cf_ds + uq_hk*hk_ds
       uq_ue = uq_cf*cf_ue + uq_hk*hk_ue

       di = 0.5*cf - (hk-1.0)*uq
       di_cf = 0.5
       di_hk = -uq
       di_uq = -(hk-1.0)

       di_th = di_cf*cf_th + di_hk*hk_th + di_uq*uq_th
       di_ds = di_cf*cf_ds + di_hk*hk_ds + di_uq*uq_ds
       di_ue = di_cf*cf_ue + di_hk*hk_ue + di_uq*uq_ue
      endif

 
      cfx    = cf   *x/th
      cfx_th = cf_th*x/th - cfx/th
      cfx_ds = cf_ds*x/th
      cfx_ue = cf_ue*x/th

      dix    = di   *x/th
      dix_th = di_th*x/th - dix/th
      dix_ds = di_ds*x/th
      dix_ue = di_ue*x/th

      if(simi) then
       xl = 1.0
       rl = 1.0
       ul = 1.0
       tl = 0.0
       hl = 0.0
       ul_ue = 0.
       tl_th = 0.
       hl_hs = 0.

       cfxa    = cfx   
       cfxa_th = cfx_th
       cfxa_ds = cfx_ds
       cfxa_ue = cfx_ue

      else
       xl = log(xi(i)/xi(i-1))
       rl = log(ri(i)/ri(i-1))
       ul = log(ue/uem)
       tl = log(th/thm)
       hl = log(hs/hsm)
       ul_ue = 1.0/ue
       tl_th = 1.0/th
       hl_hs = 1.0/hs

       cfxa    = 0.5*(cfx    + cfxm   )
       cfxa_th = 0.5* cfx_th
       cfxa_ds = 0.5* cfx_ds
       cfxa_ue = 0.5* cfx_ue
 
      endif

      hl_th = hl_hs*hs_th
      hl_ds = hl_hs*hs_ds
      hl_ue = hl_hs*hs_ue

      res(1)  = tl    - 0.5*cfxa    + (h + 2.0 - msq)*ul  +  rl
      aa(1,1) = tl_th - 0.5*cfxa_th +  h_th          *ul
      aa(1,2) =       - 0.5*cfxa_ds +  h_ds          *ul
      aa(1,3) =       - 0.5*cfxa_ue       - msq_ue   *ul
     &                              + (h + 2.0 - msq)*ul_ue


      btmp    =  2.0*hc/hs + 1.0 - h 
      btmp_hc =  2.0   /hs
      btmp_hs = -2.0*hc/hs**2
      btmp_h  =                 - 1.0

      btmp_th = btmp_hc*hc_th + btmp_hs*hs_th + btmp_h*h_th
      btmp_ds = btmp_hc*hc_ds + btmp_hs*hs_ds + btmp_h*h_ds
      btmp_ue = btmp_hc*hc_ue + btmp_hs*hs_ue

      res(2)  = hl    + 0.5*cfx    - dix    + btmp   *ul
      aa(2,1) = hl_th + 0.5*cfx_th - dix_th + btmp_th*ul
      aa(2,2) = hl_ds + 0.5*cfx_ds - dix_ds + btmp_ds*ul
      aa(2,3) = hl_ue + 0.5*cfx_ue - dix_ue + btmp_ue*ul
     &                                      + btmp   *ul_ue

      if(direct) then
       res(3)  = ue - uei(i)
       aa(3,1) = 0.
       aa(3,2) = 0.
       aa(3,3) = 1.0
      else
       res(3)  = hk - hksep
       aa(3,1) = hk_th
       aa(3,2) = hk_ds
       aa(3,3) = hk_ue
      endif


      call gaussn(3,3,aa,res,1)
      dth = -res(1)
      dds = -res(2)
      due = -res(3)

      rlx = 1.0
      if(rlx*dth .gt.  1.6*th) rlx =  1.6*th/dth
      if(rlx*dth .lt. -0.5*th) rlx = -0.5*th/dth
      if(rlx*dds .gt.  1.6*ds) rlx =  1.6*ds/dds
      if(rlx*dds .lt. -0.5*ds) rlx = -0.5*ds/dds
      if(rlx*due .gt.  0.2*ue) rlx =  0.2*ue/due
      if(rlx*due .lt. -0.1*ue) rlx = -0.1*ue/due

      dmax = max( abs(dth)/th , abs(dds)/ds , abs(due)/ue )

      if(iter.eq.1) write(*,*)
      write(*,1200) iter, direct, dmax, ue, hk, rt, cf, di
 1200 format(1x,i4, l2, e12.4, 9g13.5)

      th = th + rlx*dth
      ds = ds + rlx*dds
      ue = ue + rlx*due

      if(dmax .lt. eps) go to 105

 100  continue
 105  continue

      thm = th
      dsm = ds
      hsm = hs
      uem = ue
      cfxm = cfx

      uei(i) = ue
      thi(i) = th
      dsi(i) = ds
      tsi(i) = hs*th
      cfi(i) = cf
      cdi(i) = di*hs/2.0
      hki(i) = hk

 500  continue


      return
      end

      

      





 
 
      SUBROUTINE HKIN( H, MSQ, HK, HK_H, HK_MSQ )
      REAL MSQ
C
C---- calculate kinematic shape parameter (assuming air)
C     (from Whitfield )
      HK     =    (H - 0.29*MSQ)/(1.0 + 0.113*MSQ)
      HK_H   =     1.0          /(1.0 + 0.113*MSQ)
      HK_MSQ = (-.29 - 0.113*HK)/(1.0 + 0.113*MSQ)
C
      RETURN
      END
 


      SUBROUTINE DIL( HK, RT, DI, DI_HK, DI_RT )
C
C---- Laminar dissipation function  ( 2 CD/H* )     (from Falkner-Skan)
      IF(HK.LT.4.0) THEN
       DI    = ( 0.00205  *  (4.0-HK)**5.5 + 0.207 ) / RT
       DI_HK = ( -.00205*5.5*(4.0-HK)**4.5         ) / RT
      ELSE
       HKB = HK - 4.0
       DEN = 1.0 + 0.02*HKB**2
       DI    = ( -.0016  *  HKB**2  /DEN   + 0.207             ) / RT
       DI_HK = ( -.0016*2.0*HKB*(1.0/DEN - 0.02*HKB**2/DEN**2) ) / RT
      ENDIF
      DI_RT = -DI/RT
C
      RETURN
      END


      SUBROUTINE DILW( HK, RT, DI, DI_HK, DI_RT )
      REAL MSQ
C
      MSQ = 0.
      CALL HSL( HK, RT, MSQ, HS, HS_HK, HS_RT, HS_MSQ )
C
C---- Laminar wake dissipation function  ( 2 CD/H* )
      RCD    =  1.10 * (1.0 - 1.0/HK)**2  / HK
      RCD_HK = -1.10 * (1.0 - 1.0/HK)*2.0 / HK**3
     &       - RCD/HK
C
      DI    = 2.0*RCD   /(HS*RT)
      DI_HK = 2.0*RCD_HK/(HS*RT) - (DI/HS)*HS_HK
      DI_RT = -DI/RT             - (DI/HS)*HS_RT
C
      RETURN
      END


      SUBROUTINE HSL( HK, RT, MSQ, HS, HS_HK, HS_RT, HS_MSQ )
      REAL MSQ
C
C---- Laminar HS correlation
      IF(HK.LT.4.35) THEN
       TMP = HK - 4.35
       HS    = 0.0111*TMP**2/(HK+1.0)
     &       - 0.0278*TMP**3/(HK+1.0)  + 1.528
     &       - 0.0002*(TMP*HK)**2
       HS_HK = 0.0111*(2.0*TMP    - TMP**2/(HK+1.0))/(HK+1.0)
     &       - 0.0278*(3.0*TMP**2 - TMP**3/(HK+1.0))/(HK+1.0)
     &       - 0.0002*2.0*TMP*HK * (TMP + HK)
      ELSE
       HS    = 0.015*    (HK-4.35)**2/HK + 1.528
       HS_HK = 0.015*2.0*(HK-4.35)   /HK
     &       - 0.015*    (HK-4.35)**2/HK**2
      ENDIF
C
      HS_RT  = 0.
      HS_MSQ = 0.
C
      RETURN
      END


      SUBROUTINE CFL( HK, RT, MSQ, CF, CF_HK, CF_RT, CF_MSQ )
      REAL MSQ
C
C---- Laminar skin friction function  ( Cf )    ( from Falkner-Skan )
      IF(HK.LT.5.5) THEN
       TMP = (5.5-HK)**3 / (HK+1.0)
       CF    = ( 0.0727*TMP                      - 0.07       )/RT
       CF_HK = ( -.0727*TMP*3.0/(5.5-HK) - 0.0727*TMP/(HK+1.0))/RT
      ELSE
       TMP = 1.0 - 1.0/(HK-4.5)
       CF    = ( 0.015*TMP**2      - 0.07  ) / RT
       CF_HK = ( 0.015*TMP*2.0/(HK-4.5)**2 ) / RT
      ENDIF
      CF_RT = -CF/RT
      CF_MSQ = 0.0
C
      RETURN
      END



      SUBROUTINE DIT( HS, US, CF, ST, DI, DI_HS, DI_US, DI_CF, DI_ST )
C
C---- Turbulent dissipation function  ( 2 CD/H* )
      DI    =  ( 0.5*CF*US + ST*ST*(1.0-US) ) * 2.0/HS
      DI_HS = -( 0.5*CF*US + ST*ST*(1.0-US) ) * 2.0/HS**2
      DI_US =  ( 0.5*CF    - ST*ST          ) * 2.0/HS
      DI_CF =  ( 0.5   *US                  ) * 2.0/HS
      DI_ST =  (            2.0*ST*(1.0-US) ) * 2.0/HS
C
      RETURN
      END


      SUBROUTINE HST( HK, RT, MSQ, HS, HS_HK, HS_RT, HS_MSQ )
      IMPLICIT REAL (A-H,M,O-Z)
C
C---- Turbulent HS correlation
C
      DATA HSMIN, DHSINF / 1.500, 0.015 /
C
C---- ###  12/4/94
C---- limited Rtheta dependence for Rtheta < 200
C
C
      IF(RT.GT.400.0) THEN
       HO    = 3.0 + 400.0/RT
       HO_RT =     - 400.0/RT**2
      ELSE
       HO    = 4.0
       HO_RT = 0.
      ENDIF
C
      IF(RT.GT.200.0) THEN
       RTZ    = RT
       RTZ_RT = 1.
      ELSE
       RTZ    = 200.0
       RTZ_RT = 0.
      ENDIF
C
      IF(HK.LT.HO) THEN
C----- attached branch
C=======================================================
C----- old correlation
C-     (from Swafford profiles)
c       SRT = SQRT(RT)
c       HEX = (HO-HK)**1.6
c       RTMP = 0.165 - 1.6/SRT
c       HS    = HSMIN + 4.0/RT + RTMP*HEX/HK
c       HS_HK = RTMP*HEX/HK*(-1.6/(HO-HK) - 1.0/HK)
c       HS_RT = -4.0/RT**2 + HEX/HK*0.8/SRT/RT
c     &             + RTMP*HEX/HK*1.6/(HO-HK)*HO_RT
C=======================================================
C----- new correlation  29 Nov 91
C-     (from  arctan(y+) + Schlichting  profiles)
       HR    = ( HO - HK)/(HO-1.0)
       HR_HK =      - 1.0/(HO-1.0)
       HR_RT = (1.0 - HR)/(HO-1.0) * HO_RT
       HS    = (2.0-HSMIN-4.0/RTZ)*HR**2  * 1.5/(HK+0.5) + HSMIN
     &       + 4.0/RTZ
       HS_HK =-(2.0-HSMIN-4.0/RTZ)*HR**2  * 1.5/(HK+0.5)**2
     &       + (2.0-HSMIN-4.0/RTZ)*HR*2.0 * 1.5/(HK+0.5) * HR_HK
       HS_RT = (2.0-HSMIN-4.0/RTZ)*HR*2.0 * 1.5/(HK+0.5) * HR_RT
     &       + (HR**2 * 1.5/(HK+0.5) - 1.0)*4.0/RTZ**2 * RTZ_RT
C
      ELSE
C
C----- separated branch
       GRT = LOG(RTZ)
       HDIF = HK - HO 
       RTMP = HK - HO + 4.0/GRT
       HTMP    = 0.007*GRT/RTMP**2 + DHSINF/HK
       HTMP_HK = -.014*GRT/RTMP**3 - DHSINF/HK**2
       HTMP_RT = -.014*GRT/RTMP**3 * (-HO_RT - 4.0/GRT**2/RTZ * RTZ_RT)
     &         + 0.007    /RTMP**2 / RTZ * RTZ_RT
       HS    = HDIF**2 * HTMP + HSMIN + 4.0/RTZ
       HS_HK = HDIF*2.0* HTMP
     &       + HDIF**2 * HTMP_HK
       HS_RT = HDIF**2 * HTMP_RT      - 4.0/RTZ**2 * RTZ_RT
     &       + HDIF*2.0* HTMP * (-HO_RT)
C
      ENDIF
C
C---- fudge HS slightly to make sure   HS -> 2   as   HK -> 1
C-    (unnecessary with new correlation)
c      HTF    = 0.485/9.0 * (HK-4.0)**2/HK  +  1.515
c      HTF_HK = 0.485/9.0 * (1.0-16.0/HK**2)
c      ARG = MAX( 10.0*(1.0 - HK) , -15.0 )
c      HXX = EXP(ARG)
c      HXX_HK = -10.0*HXX
cC
c      HS_HK  = (1.0-HXX)*HS_HK  +  HXX*HTF_HK
c     &       + (        -HS     +      HTF    )*HXX_HK
c      HS_RT  = (1.0-HXX)*HS_RT
c      HS     = (1.0-HXX)*HS     +  HXX*HTF
C
C---- Whitfield's minor additional compressibility correction
      FM = 1.0 + 0.014*MSQ
      HS     = ( HS + 0.028*MSQ ) / FM
      HS_HK  = ( HS_HK          ) / FM
      HS_RT  = ( HS_RT          ) / FM
      HS_MSQ = 0.028/FM  -  0.014*HS/FM
C
      RETURN
      END
 
 
 
      SUBROUTINE CFT( HK, RT, MSQ, CF, CF_HK, CF_RT, CF_MSQ )
      IMPLICIT REAL (A-H,M,O-Z)
C
      DATA GAM /1.4/

      CFFAC = 1.0
C
C---- Turbulent skin friction function  ( Cf )    (Coles)
      GM1 = GAM - 1.0
      FC = SQRT(1.0 + 0.5*GM1*MSQ)
      GRT = LOG(RT/FC)
      GRT = MAX(GRT,3.0)
C
      GEX = -1.74 - 0.31*HK
C
      ARG = -1.33*HK
      ARG = MAX(-20.0, ARG )
C
      THK = TANH(4.0 - HK/0.875)
C
      CFO =  CFFAC * 0.3*EXP(ARG) * (GRT/2.3026)**GEX
      CF     = ( CFO  +  1.1E-4*(THK-1.0) ) / FC
      CF_HK  = (-1.33*CFO - 0.31*LOG(GRT/2.3026)*CFO
     &         - 1.1E-4*(1.0-THK**2) / 0.875    ) / FC
      CF_RT  = GEX*CFO/(FC*GRT) / RT
      CF_MSQ = GEX*CFO/(FC*GRT) * (-0.25*GM1/FC**2) - 0.25*GM1*CF/FC**2
C
      RETURN
      END ! CFT



 
      SUBROUTINE HCT( HK, MSQ, HC, HC_HK, HC_MSQ )
      REAL MSQ
C
C---- density shape parameter    (from Whitfield)
      HC     = MSQ * (0.064/(HK-0.8) + 0.251)
      HC_HK  = MSQ * (-.064/(HK-0.8)**2     )
      HC_MSQ =        0.064/(HK-0.8) + 0.251
C
      RETURN
      END
