
      subroutine cdsum(pari,parg,para,pare, icdfun, iairf)
c----------------------------------------------------------------------
c     Calculates aircraft CD components for operating point ipoint
c     If icdfun=1, computes wing cdf,cdp from airfoil database # iairf,
c     otherwise uses defaujlt values in para array.
c----------------------------------------------------------------------
      implicit real (a-h,l-z)
c
      include 'index.inc'
      integer pari(iitotal)
      real parg(igtotal), 
     &     para(iatotal),
     &     pare(ietotal)
      integer icdfun

      include 'airf.inc'
      include 'constants.inc'

      logical Ldebug

      common /com_lu/ ilu


      Ldebug = .false.
c      Ldebug = .true.

      AR       = parg(igAR     )
      sweep    = parg(igsweep  )
      hboxo    = parg(ighboxo  )
      hboxs    = parg(ighboxs  )
      hboxt    = hboxs
      fSnace   = parg(igfSnace )
      bo       = parg(igbo     )
      bs       = parg(igbs     )
      zs       = parg(igzs     )
      boh      = parg(igboh    )
      bov      = parg(igbov    )
      hstrut   = parg(ighstrut )


      Rfuse    = parg(igRfuse  )
      dRfuse   = parg(igdRfuse )
      wfb      = parg(igwfb    )

      xnose    = parg(igxnose  )
      xend     = parg(igxend   )
      xblend1  = parg(igxblend1)
      xblend2  = parg(igxblend2)
      xhtail   = parg(igxhtail )
      xvtail   = parg(igxvtail )
      xwing    = parg(igxwing  )

      lambdac  = parg(iglambdac)

      lambdat  = parg(iglambdat)
      lambdas  = parg(iglambdas)
      gammat   = parg(iglambdat)*para(iarclt)
      gammas   = parg(iglambdas)*para(iarcls)

      ARh      = parg(igARh    )
      ARv      = parg(igARv    )
      lambdah  = parg(iglambdah)
      lambdav  = parg(iglambdav)
      sweeph   = parg(igsweeph )
      sweepv   = parg(igsweepv )
      cosLs    = parg(igcosLs  )
      Sstrut   = parg(igSstrut )

      co   = parg(igco )
      coh  = parg(igcoh)
      cov  = parg(igcov)

      b    = parg(igb  )
      bh   = parg(igbh )
      bv   = parg(igbv )

      S    = parg(igS  )
      Sh   = parg(igSh )
      Sv   = parg(igSv )

      fLo  = parg(igfLo)
      fLt  = parg(igfLt)

      fCDwcen = 0.0
      fCDhcen = parg(igfCDhcen)
      fCDvcen = 0.0

      Astrut   = parg(igAstrut )
      cstrut   = parg(igcstrut )
      nvtail   = parg(ignvtail )

      rVnace = parg(igrVnace)

      CL   = para(iaCL)
      Mach = para(iaMach)

      fduo = para(iafduo)
      fdus = para(iafdus)
      fdut = para(iafdut)

      DAfsurf = para(iaDAfsurf)
      DAfwake = para(iaDAfwake)
      PAfinf = para(iaPAfinf)

      fexcdw = para(iafexcdw)

c---- tail lift
      CLhtail = para(iaCLh)*Sh/S

c---- parameters for Re-scaling of cd's
      Reunit = para(iaReunit)
      Rerefw = para(iaRerefw)
      Rereft = para(iaRereft)
      Rerefs = para(iaRerefs)
      aRexp  = para(iaaRexp)

c---- root shock unsweep constant
      rkSunsw = 0.5
      rkSunsh = 0.
      rkSunsv = 0.
c
c---- Re referenced to root chord
      Reco = Reunit*co

c- - - - - - - - - - - - - - - - - - - - - - - - - - - -
      if(icdfun.eq.1) then
c----- integrated across span for CDwing

       if(Ldebug) write(*,*) 'calling SURFCD2...'

       call surfcd2(
     &   S,
     &   b,bs,bo,
     &   lambdat,lambdas,gammat,gammas,
     &   hboxo,hboxs,hboxt,
     &   Mach,sweep,co, 
     &   CL,CLhtail, fLo,fLt,
     &   Reco,aRexp, rkSunsw,fexcdw,
     &   iAdim,jAdim,kAdim,lAdim,
     &   nAMa(iairf),nAcl(iairf),nAtau(iairf),nAfun(iairf),
     &   AMa(1,iairf),Acl(1,iairf),Atau(1,iairf),ARe(iairf),
     &          A(1,1,1,1,iairf),
     &        A_M(1,1,1,1,iairf),
     &       A_cl(1,1,1,1,iairf),
     &      A_tau(1,1,1,1,iairf),
     &     A_M_cl(1,1,1,1,iairf),
     &    A_M_tau(1,1,1,1,iairf),
     &   A_cl_tau(1,1,1,1,iairf),
     & A_M_cl_tau(1,1,1,1,iairf),
     &   fduo,fdus,fdut,
     &   clpo,clps,clpt,
     &   cdfw,cdpw,CDwing,CDover)

       if(Ldebug) write(*,*) '...exited SURFCD2'

c      call wingcl(b,bs,bo,
c     &             lambdat,lambdas,gammat,gammas,
c     &             sweep,AR,CL,CLhtail,fLo,fLt,
c     &             fduo,fdus,fdut,
c     &             clpo,clps,clpt)
c
c       CLperp = clps
c       Mperp = Mach*cos(sweep*pi/180.0)
c
c       hbox = hboxs
c
c       iairf = 1
c       call airfun(CLperp,hbox,Mperp,
c     &             kAdim,lAdim,iAdim,jAdim,
c     &             nAcl(iairf),nAtau(iairf),nAfun(iairf),
c     &             Acl(1,iairf),Atau(1,iairf),ARe(iairf),
c     &            nA(1,1,iairf),
c     &             A(1,1,1,1,iairf),
c     &            AM(1,1,1,1,iairf),
c     &             cdf, cdp, cdwbar, cm)
c
cc----- apply excrescense scaling factor
c       cdfw = cdf * fexcdw
c       cdpw = cdp * fexcdw
c
cc----- database reference Re number overrides value in .tas file
c       Rerefw = ARe(iairf)
c       call surfcd(S,
c     &  b,bs,bo,lambdat,lambdas,sweep,co, 
c     &  cdfw,cdpw,Reco,Rerefw,aRexp,rkSunsw,
c     &  fCDwcen,
c     &  CDwing)
c
c----- store CD values
       para(iaCDwing) = CDwing
       para(iaCDover) = CDover
       para(iacdfw) = cdfw
       para(iacdpw) = cdpw

c- - - - - - - - - - - - - - - - - - - - - - - - - - - -
      else
c----- just use stored values
       cdfw = para(iacdfw) * fexcdw
       cdpw = para(iacdpw) * fexcdw

       call surfcd(S,
     &  b,bs,bo,lambdat,lambdas,sweep,co, 
     &  cdfw,cdpw,Reco,Rerefw,aRexp,rkSunsw,
     &  fCDwcen,
     &  CDwing,CDover)
       
       para(iaCDwing) = CDwing
       para(iaCDover) = CDover

       call wingcl(b,bs,bo,
     &             lambdat,lambdas,gammat,gammas,
     &             sweep,AR,CL,CLhtail,fLo,fLt,
     &             fduo,fdus,fdut,
     &             clpo,clps,clpt)

      endif

c---- store local cl values
      para(iaclpo) = clpo
      para(iaclps) = clps
      para(iaclpt) = clpt

c- - - - - - - - - - - - - - - - - - - - - - - - - - - -

c      write(*,*) ip
c      write(*,*) 'cdf cdp', cdf, cdp

c- - - - - - - - - - - - - - - - - - - - - - - - - - - -


c- - - - - - - - - - - - - - - - - - - - - - - - - - - -
c---- tail profile Cd's
      cdft = para(iacdft) * para(iafexcdt)
      cdpt = para(iacdpt) * para(iafexcdt)

c---- horizontal tail profile CD
      Recoh = Reunit*coh
      call surfcd(S,
     &  bh,boh,boh,lambdah,1.0,sweeph,coh, 
     &  cdft,cdpt,Recoh,Rereft,aRexp,rkSunsh,
     &  fCDhcen,
     &  CDhtail,CDhover)
c      write(*,*) 'CDhtail', CDhtail
c
c---- vertical tail profile CD
      Recov = Reunit*cov
      call surfcd(S,
     &  bv,bov,bov,lambdav,1.0,sweepv,cov, 
     &  cdft,cdpt,Recov,Rereft,aRexp,rkSunsv,
     &  fCDvcen,
     &  CDvtail1,CDvover1)
      CDvtail = CDvtail1*nvtail
c      write(*,*) 'CDvtail', CDvtail
c
      para(iaCDhtail) = CDhtail
      para(iaCDvtail) = CDvtail

c- - - - - - - - - - - - - - - - - - - - - - - - - - - -
c---- fuselage profile CD from wetted area
c      ltot = xend - xnose
c      Rel = Reunit*ltot
c      Cfwet = cfturb(Rel) * para(iafexcdf)
c      call bodycd(S,
c     &  Rfuse,dRfuse,wfb,xnose,xblend1,xblend2,xend, Cfwet,
c     &  CDfuse)

c- - - - - - - - - - - - - - - - - - - - - - - - - - - -
c---- fuselage profile CD, using fuselage CDA from BLI calculation
      CDfuse = PAfinf/S
      para(iaCDfuse) = CDfuse

      if(Ldebug) write(*,*) 'nacelle CD...'
c- - - - - - - - - - - - - - - - - - - - - - - - - - - -
c---- set new nacelle skin friction coefficient Cfnace
c-     (use fuselage excrescence factor)
      lnace = parg(iglnace)
      Reunit = para(iaReunit)
      if(Reunit .eq. 0.0) then
       Cfnace = 0.
      else
       Renace = Reunit*lnace
       Cfnace = cfturb(Renace) * para(iafexcdf)
      endif
      para(iaCfnace) = Cfnace

c---- set Mnac on outside of nacelle, using vortex sheet model of nacelle,
c-     (Mnac+M2)/2 = Mach*rVnace
      rVnLE = max( 2.0*rVnace - pare(ieM2) / max(Mach,0.001) , 0.0 )
      rVnsurf3 = 0.25*(rVnLE+rVnace)*(rVnLE**2+rVnace**2)
      CDnace = fSnace * Cfnace * rVnsurf3
      para(iaCDnace) = CDnace

c- - - - - - - - - - - - - - - - - - - - - - - - - - - -
c---- strut profile CD
      cdfs = para(iacdfs)
      cdps = para(iacdps)
      rVstrut = parg(igrVstrut)
      CDstrut = (Sstrut/S)*(cdfs + cdps*cosLs**3) * rVstrut**3
      para(iaCDstrut) = CDstrut

c- - - - - - - - - - - - - - - - - - - - - - - - - - - -
c---- induced CD
      if(Ldebug) write(*,*) '...calling CDITRP...'

      call cditrp(pari,parg,para)
      CDi = para(iaCDi)

c      spaneff = 0.8825
c      CDi = CL**2 / (pi*AR*spaneff)
c      para(iaCDi) = CDi
c      para(iaspaneff) = spaneff
c      write(*,*)
c      write(*,*) para(iaCDi), para(iaspaneff)
c      write(*,*) CDi, spaneff



c- - - - - - - - - - - - - - - - - - - - - - - - - - - -
c---- apparent fuselage deltaCD from ingestion
      fBLIf = parg(igfBLIf)
      dCDBLIf = -fBLIf*DAfwake/S

c- - - - - - - - - - - - - - - - - - - - - - - - - - - -
c---- apparent wing deltaCD from ingestion
      fBLIw = parg(igfBLIw)
      CDWwake = CDwing * 0.15  ! assume 15% of the wing dissipation is in wake
      dCDBLIw = -fBLIw*CDWwake

c- - - - - - - - - - - - - - - - - - - - - - - - - - - -
c---- total CD
      CD = CDi + CDfuse + CDwing + CDover
     &   + CDhtail + CDvtail + CDstrut
     &   + CDnace
     &   + dCDBLIf + dCDBLIw
      para(iaCD) = CD

c      tau = hboxo
c      rsb3 = 0.25*((0.5*clpo + tau+1.0)    + (tau+1.0)   )
c     &           *((0.5*clpo + tau+1.0)**2 + (tau+1.0)**2)
c      Cdiss = 0.0009 * 1.5
c      aksb = 0.25
c      CDsb = 2.0*Cdiss*(rsb3-1.0)*(co**2/S)*2.0*aksb
c      CD = CD + CDsb
c      para(iaCD) = CD
cc      write(*,'(1x,3f12.7)') CDsb, CD, CDsb/CD

c- - - - - - - - - - - - - - - - - - - - - - - - - - - -
      if(Ldebug) write(*,*) '...exiting CDSUM...'

      return
      end ! cdsum



      subroutine cditrp(pari,parg,para)
      implicit real (a-h,l-z)

      include 'index.inc'
      integer pari(iitotal)
      real parg(igtotal), 
     &     para(iatotal)

      include 'trp.inc'

      include 'time.inc'

      logical Lspec
      common /com_lu/ ilu

c     call tset(time0)

      ifclose = pari(iifclose)

      CL = para(iaCL)

      if(CL .eq. 0.0) then
       para(iaCDi) = 0.
       para(iaspaneff) = 1.0
       return
      endif

      CLhtail = para(iaCLh)*parg(igSh)/parg(igS)

      bref = parg(igb)
      Sref = parg(igS)

      Mach = para(iaMach)

      Lspec = .true.


c---- wing wake parameters
      fLo = parg(igfLo)
c      fLo = 0.0

c---- span, wing-break span, wing-root span
      b(1)  = parg(igb)
      bs(1) = parg(igbs)
      bo(1) = parg(igbo)

c---- span of wing-root streamline in Trefftz Plane
      bop(1) = parg(igbo) * 0.2

      zcent(1) = parg(igzwing)
      gammas(1) = parg(iglambdas)*para(iarcls)
      gammat(1) = parg(iglambdat)*para(iarclt)
      po(1)     = 1.0
      CLsurfsp(1) = CL - CLhtail

c---- velocity-change fractions at wing spanwise locations due to fuselage flow
      fduo = para(iafduo)
      fdus = para(iafdus)
      fdut = para(iafdut)

c---- horizontal tail wake parameters
      b(2)   = parg(igbh)
      bs(2)  = parg(igboh)
      bo(2)  = parg(igboh)
      bop(2) = parg(igboh)

      zcent(2) = parg(igzhtail)
      gammas(2) = 1.0
      gammat(2) = parg(iglambdah)
      po(2)     = 1.0
      CLsurfsp(2) = CLhtail


c---- number of surfaces  (wing, horizontal tail)
      nsurf = 2

c---- number of spanwise intervals
      npout(1) = 20  ! outer panel
      npinn(1) = 6   ! inner panel
      npimg(1) = 3   ! image inside fuselage
  
      npout(2) = 10  ! outer panel
      npinn(2) = 0   ! inner panel
      if(bo(2) .eq. 0.0) then
       npimg(2) = 0
      else
       npimg(2) = 2   ! image inside fuselage  (or inner panel if T-tail)
      endif

c     npout(1) = 40  ! outer panel
c     npinn(1) = 12  ! inner panel
c     npimg(1) = 6   ! image inside fuselage
c 
c     npout(2) = 20  ! outer panel
c     npinn(2) = 0   ! inner panel
c     npimg(2) = 4   ! image inside fuselage  (or inner panel if T-tail)

c      npout(1) = 160  ! outer panel
c      npinn(1) = 48   ! inner panel
c      npimg(1) = 24   ! image inside fuselage
c 
c      npout(2) = 80  ! outer panel
c      npinn(2) = 0   ! inner panel
c      npimg(2) = 16  ! image inside fuselage  (or inner panel if T-tail)

      ktip = 16
      call trefftz1(nsurf, npout, npinn, npimg, 
     &             Sref, bref,
     &             b,bs,bo,bop, zcent,
     &             po,gammat,gammas, fLo, ktip,
     &             Lspec,CLsurfsp,
     &             CLsurf,CLtp,CDtp,sefftp,
     &             itpdim,ifrst,ilast,
     &             yc,zc,gc,vc,wc,vnc, ycp,zcp)

c     call trefftz(nsurf, nisurf, Sref, bref, Mach,
c    &             b,bs,bo,bop, zcent,
c    &             fduo,fdus,fdut,
c    &             po,gammat,gammas, fLo, ktip,
c    &             Lspec,CLsurfsp,
c    &             CLsurf,CLtp,CDtp,sefftp,
c    &             itpdim,ifrst,ilast,
c    &             yc,zc,gc,vc,wc,vnc, ycp,zcp)

c     write(*,*) 'L =', (lsurf(k), k=1,nsurf)
c     write(*,*) 'D =', dragtp
c     write(*,*) 'e =', sefftp

      para(iaCDi) = CDtp
      para(iaspaneff) = sefftp

c     call tadd(time0,t_cditrp)

      return
      end ! cditrp
