
      program cooltest
c------------------------------------------------------------
c     Checks the derivatives returned by subroutine mcool,
c     by comparing them against finite-differenced values
c------------------------------------------------------------
      data eps / 1.0e-6 /

      parameter (ncrowx=8)
      real Tmrow(ncrowx)

      real epsrow(ncrowx)
      real epsrow_Tt3(ncrowx),
     &     epsrow_Tt4(ncrowx),
     &     epsrow_Trr(ncrowx)

      real epsrow$(ncrowx)
      real epsrow_Tt3$(ncrowx),
     &     epsrow_Tt4$(ncrowx),
     &     epsrow_Trr$(ncrowx)

      character*2 ss1, ss2, ss3, ss4, ss5, ss6

      efilm = 0.7
      tfilm = 0.4
      StA = 0.05

      Tmrow = 1200.0
      Tt3 = 650.0
      Tt4 = 2000.0
      dTstrk = 300.0
      Trrat = 0.85

      dT   = eps*Tt3
      dTrr = eps*Trrat

      call mcool(ncrowx, ncrow,
     &           Tmrow,Tt3,Tt4,dTstrk, Trrat,
     &           efilm,tfilm,StA,
     &           epsrow,epsrow_Tt3,epsrow_Tt4,epsrow_Trr)

      write(*,*) ncrow

 2010 format(2x,  a,g16.8,1x,a,4x )
 2020 format(2x,2(a,g16.8,1x,a,4x))
 2030 format(2x,3(a,g16.8,1x,a,4x))

      Tt3$   = Tt3
      Tt4$   = Tt4
      Trrat$ = Trrat


      Tt3$ = Tt3 + dT
      call mcool(ncrowx, ncrow,
     &           Tmrow,Tt3$,Tt4$,dTstrk, Trrat$,
     &           efilm,tfilm,StA,
     &           epsrow$,epsrow_Tt3$,epsrow_Tt4$,epsrow_Trr$)
      Tt3$ = Tt3
      dd1 = (epsrow$(1)-epsrow(1))/dT
      dd2 = (epsrow$(2)-epsrow(2))/dT
      dd3 = (epsrow$(3)-epsrow(3))/dT
      aa1 = (epsrow_Tt3$(1)+epsrow_Tt3(1))*0.5
      aa2 = (epsrow_Tt3$(2)+epsrow_Tt3(2))*0.5
      aa3 = (epsrow_Tt3$(3)+epsrow_Tt3(3))*0.5
      call compare(ss1,aa1,dd1)
      call compare(ss2,aa2,dd2)
      call compare(ss3,aa3,dd3)
      write(*,*)
      write(*,2030) 'e3_Tt3',aa1,ss1,
     &              'e3_Tt3',aa2,ss2,
     &              'e3_Tt3',aa3,ss3
      write(*,2030) '      ',dd1,ss1,
     &              '      ',dd2,ss2,
     &              '      ',dd3,ss3


      Tt4$ = Tt4 + dT
      call mcool(ncrowx, ncrow,
     &           Tmrow,Tt3$,Tt4$,dTstrk, Trrat$,
     &           efilm,tfilm,StA,
     &           epsrow$,epsrow_Tt3$,epsrow_Tt4$,epsrow_Trr$)
      Tt4$ = Tt4
      dd1 = (epsrow$(1)-epsrow(1))/dT
      dd2 = (epsrow$(2)-epsrow(2))/dT
      dd3 = (epsrow$(3)-epsrow(3))/dT
      aa1 = (epsrow_Tt4$(1)+epsrow_Tt4(1))*0.5
      aa2 = (epsrow_Tt4$(2)+epsrow_Tt4(2))*0.5
      aa3 = (epsrow_Tt4$(3)+epsrow_Tt4(3))*0.5
      call compare(ss1,aa1,dd1)
      call compare(ss2,aa2,dd2)
      call compare(ss3,aa3,dd3)
      write(*,*)
      write(*,2030) 'e3_Tt4',aa1,ss1,
     &              'e3_Tt4',aa2,ss2,
     &              'e3_Tt4',aa3,ss3
      write(*,2030) '      ',dd1,ss1,
     &              '      ',dd2,ss2,
     &              '      ',dd3,ss3


      Trrat$ = Trrat + dTrr
      call mcool(ncrowx, ncrow,
     &           Tmrow,Tt3$,Tt4$,dTstrk, Trrat$,
     &           efilm,tfilm,StA,
     &           epsrow$,epsrow_Tt3$,epsrow_Tt4$,epsrow_Trr$)
      Trrat$ = Trrat
      dd1 = (epsrow$(1)-epsrow(1))/dTrr
      dd2 = (epsrow$(2)-epsrow(2))/dTrr
      dd3 = (epsrow$(3)-epsrow(3))/dTrr
      aa1 = (epsrow_Trr$(1)+epsrow_Trr(1))*0.5
      aa2 = (epsrow_Trr$(2)+epsrow_Trr(2))*0.5
      aa3 = (epsrow_Trr$(3)+epsrow_Trr(3))*0.5
      call compare(ss1,aa1,dd1)
      call compare(ss2,aa2,dd2)
      call compare(ss3,aa3,dd3)
      write(*,*)
      write(*,2030) 'e3_Trr',aa1,ss1,
     &              'e3_Trr',aa2,ss2,
     &              'e3_Trr',aa3,ss3
      write(*,2030) '      ',dd1,ss1,
     &              '      ',dd2,ss2,
     &              '      ',dd3,ss3

      stop
      end
