
      subroutine getsave(lu,iototal,idim,jdim, 
     &                   nvar,ni,nj, iovar,
     &                   ispars,jspars,
     &                   vars,ferr )
      implicit real (a-h,o-z)
      integer iovar(*)
      real vars(iototal,iototal+1,idim,jdim)
      logical ferr

      parameter (nvmax=50)
      integer iovar1(nvmax)

      character*1 cdummy

      ferr = .false.
      read(lu,*,end=800,err=900) nvar1, ispars1, jspars1

      if(nvar1 .ne. nvar) then
       write(*,*) 
       write(*,*) 
     &   '** Save file mismatch in number of optimization variables'
       ferr = .true.
      endif
      if(ispars1 .ne. ispars) then
       write(*,*) 
       write(*,*) '** Save file mismatch in type of i parameter'
       ferr = .true.
      endif
      if(jspars1 .ne. jspars) then
       write(*,*) 
       write(*,*) '** Save file mismatch in type of j parameter'
       ferr = .true.
      endif
      if(ferr) return

      if(nvar .gt. nvmax) then
       write(*,*) 
       write(*,*)
     &   'GETSAVE: Local array overflow.  Increase nvmax to', nvar
       ferr = .true.
       return
      endif

      read(lu,*,end=800,err=900) (iovar1(iv), iv = 1, nvar)

      do iv = 1, nvar
        if(iovar1(iv) .ne. iovar(iv)) then
         write(*,*) 
     &    '** Save file mismatch in optimization variable selection'
         ferr = .true.
         return
        endif
      enddo

 1000 format(a)

      imax = 0
      jmax = 0

 10   continue
       read(lu,1000,end=500) cdummy
       read(lu,*,end=500,err=900) i1, j1
       imax = max( i1, imax )
       jmax = max( j1, jmax )
       i    = min( i1, idim )
       j    = min( j1, jdim )
       do jv = 1, nvar+1
         read(lu,*,end=800,err=900) (vars(iv,jv,i,j), iv=1,nvar)
       enddo
       go to 10

 500  continue
      if(imax .ne. ni) then
       write(*,*) '** Save file i number mismatch:   Ni_run  Ni_sav =', 
     &             ni, imax
       ferr = .true.
      endif
      if(jmax .ne. nj) then
       write(*,*) '** Save file j number mismatch:   Nj_run  Nj_sav =', 
     &             nj, jmax
       ferr = .true.
      endif
      return

 800  continue
      write(*,*) '** Unexpected end of save file'
      ferr = .true.
      return

 900  continue
      write(*,*) '** Read error on save file'
      ferr = .true.
      return
      end ! getsave



      subroutine wrtsave(lu,iototal,idim,jdim, 
     &                   nvar,ni,nj, iovar,
     &                   ispars,jspars,
     &                   vars )
      implicit real (a-h,o-z)
      integer iovar(*)
      real vars(iototal,iototal+1,idim,jdim)

 1100 format(1x,60i4)
 1200 format(1x,60g22.14)

      write(lu,1100) nvar, ispars, jspars
      write(lu,1100) (iovar(iv), iv = 1, nvar)
      do i = 1, ni
        do j = 1, nj
          write(lu,*) ' '
          write(lu,1100) i, j
          do jv = 1, nvar+1
            write(lu,1200) (vars(iv,jv,i,j), iv=1,nvar)
          enddo
        enddo
      enddo
      return
      end ! wrtsave


      subroutine wrtsave0(lu,iototal,idim,jdim, 
     &                    nvar, iovar,
     &                    ispars,jspars )
      implicit real (a-h,o-z)
      integer iovar(*)
 1100 format(1x,60i4)
      write(lu,1100) nvar, ispars, jspars
      write(lu,1100) (iovar(iv), iv = 1, nvar)
      return
      end ! wrtsave0

      subroutine wrtsave1(lu,iototal,idim,jdim, 
     &                    nvar,i,j,
     &                    vars )
      implicit real (a-h,o-z)
      real vars(iototal,iototal+1,idim,jdim)
 1100 format(1x,60i4)
 1200 format(1x,60g22.14)
      write(lu,*) ' '
      write(lu,1100) i, j
      do jv = 1, nvar+1
        write(lu,1200) (vars(iv,jv,i,j), iv=1,nvar)
      enddo
      return
      end ! wrtsave1

