
      subroutine geowrt(lu,pari,parg)
c----------------------------------------------------
c     Writes aircraft geometry and weight parameters
c----------------------------------------------------
      implicit real (a-h,l-z)

      integer lu
      integer pari(*)
      real parg(*)

      include 'index.inc'
      include 'constants.inc'

C-----------------------------------------

      Wpadd   = parg(igWpay) * parg(igfpadd  )
      Wseat   = parg(igWpay) * parg(igfseat  )
      Wapu    = parg(igWpay) * parg(igfapu   )

      Whpesys = parg(igWMTO) * parg(igfhpesys)
      Wlgnose = parg(igWMTO) * parg(igflgnose)
      Wlgmain = parg(igWMTO) * parg(igflgmain)
      Wtotadd = Whpesys
     &        + Wlgnose
     &        + Wlgmain

      Wbox    = parg(igWweb) + parg(igWcap)
      Wflap   = Wbox * parg(igfflap)
      Wslat   = Wbox * parg(igfslat)
      Waile   = Wbox * parg(igfaile)
      Wlete   = Wbox * parg(igflete)
      Wribs   = Wbox * parg(igfribs)
      Wspoi   = Wbox * parg(igfspoi)
      Wwatt   = Wbox * parg(igfwatt)
      Wwing   = Wbox
     &        + Wflap
     &        + Wslat
     &        + Waile
     &        + Wlete
     &        + Wribs
     &        + Wspoi
     &        + Wwatt

      Wempty =  parg(igWMTO)
     &        - parg(igWfuel)
     &        - parg(igWpay)

      Weadd  = parg(igWebare)*parg(igfeadd)
      Wpylon = (parg(igWebare) + Weadd + parg(igWnace))*parg(igfpylon)

c      Wfuse = Wpadd
c     &      + Wseat
c     &      + parg(igWshell)
c     &      + parg(igWcone)
c     &      + parg(igWwindow)
c     &      + parg(igWinsul)
c     &      + parg(igWfloor)
c     &      + parg(igWhbend)
c     &      + parg(igWvbend)
c      Weng = Webare + Weadd + Wnace + Wpylon
c      WMTO = Wfix + Wpay + Wpadd + Wshell
c     &     + Wwindow + Winsul + Wfloor + Wseat
c     &     + Whbend + Wvbend + Wcone
c     &     + Wwing + Wstrut
c     &     + Whtail + Wvtail
c     &     + Weng + Wfuel + Wlgnose + Wlgmain + Wtotadd

cc      Fopt = parg(igFOpt)
cc      write(lu,'(a,f12.4,a)') ' Fopt '   , Fopt           *lb_N,'  lb'
cc      write(lu,*)
      write(lu,'(a,f9.1,a)') ' Wempty  +', Wempty         *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wpay    +', parg(igWpay)   *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wfuel   +', parg(igWfuel)  *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' (max)    ', parg(igWfmax)  *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' WMTO    =', parg(igWMTO)   *lb_N,'  lb'
      write(lu,*)
      write(lu,'(a,f9.1,a)') ' Whpesys +', Whpesys        *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wlgnose +', Wlgnose        *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wlgmain +', Wlgmain        *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wtotadd =', Wtotadd        *lb_N,'  lb'
      write(lu,*)
      write(lu,'(a,f9.1,a)') ' Wfix    +', parg(igWfix)   *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wapu    +', Wapu           *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wpadd   +', Wpadd          *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wshell  +', parg(igWshell) *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wcone   +', parg(igWcone)  *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Whbend  +', parg(igWhbend) *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wvbend  +', parg(igWvbend) *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wwindow +', parg(igWwindow)*lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Winsul  +', parg(igWinsul) *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wfloor  +', parg(igWfloor) *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wseat   +', Wseat          *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wfuse   =', parg(igWfuse)  *lb_N,'  lb'
      write(lu,*)
      write(lu,'(a,f9.1,a)') ' Wcap    +', parg(igWcap)   *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wweb    +', parg(igWweb)   *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wflap   +', Wflap          *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wslat   +', Wslat          *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Waile   +', Waile          *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wlete   +', Wlete          *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wribs   +', Wribs          *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wspoi   +', Wspoi          *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wwatt   +', Wwatt          *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wwing   =', Wwing          *lb_N,'  lb'
      write(lu,*)
      write(lu,'(a,f9.1,a)') ' Wstrut  =', parg(igWstrut) *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Whtail  =', parg(igWhtail) *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wvtail  =', parg(igWvtail) *lb_N,'  lb'
      write(lu,*)
      write(lu,'(a,f9.1,a)') ' Webare  +', parg(igWebare) *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Weadd   +', Weadd          *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wnace   +', parg(igWnace)  *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Wpylon  +', Wpylon         *lb_N,'  lb'
      write(lu,'(a,f9.1,a)') ' Weng    =', parg(igWeng)   *lb_N,'  lb'
      write(lu,*)
      write(lu,'(a,i4)')     ' ifwcen  =', pari(iifwcen)
      write(lu,*)
      write(lu,'(a,i8  ,a)') ' neng    =', int(parg(igneng))
      write(lu,'(a,f9.3,a)') ' dfan    =', parg(igdfan)*in_m  ,'  in'
      write(lu,'(a,f9.3,a)') ' lnace   =', parg(iglnace)*ft_m ,'  ft'
      write(lu,'(a,f9.4,a)') ' Snace/S =', parg(igfSnace)
      write(lu,*)
      write(lu,'(a,f8.3,a)') ' w/c     =', parg(igwbox)
      write(lu,'(a,f8.4,a)') ' ho/c    =', parg(ighboxo)
      write(lu,'(a,f8.4,a)') ' hs/c    =', parg(ighboxs)
      write(lu,'(a,f8.5,a)') ' tcapo/c =', parg(igtbcapo)
      write(lu,'(a,f8.5,a)') ' tcaps/c =', parg(igtbcaps)
      write(lu,'(a,f8.5,a)') ' twebo/c =', parg(igtbwebo)
      write(lu,'(a,f8.5,a)') ' twebs/c =', parg(igtbwebs)

      cosL = cos(parg(igsweep)*pi/180.0)

      co = parg(igco)
      cs = parg(igco)*parg(iglambdas)
      ct = parg(igco)*parg(iglambdat)

      tcapo = parg(igtbcapo)*co*cosL
      tcaps = parg(igtbcaps)*cs*cosL
      tcapt = parg(igtbcaps)*ct*cosL
      twebo = parg(igtbwebo)*co*cosL
      twebs = parg(igtbwebs)*cs*cosL
      twebt = parg(igtbwebs)*ct*cosL

      Somax = parg(igSomax)
      Ssmax = parg(igSsmax)
      Momax = parg(igMomax)
      Msmax = parg(igMsmax)

      SMfwd = (parg(igxNP)-parg(igxCGfwd))/parg(igcma)
      SMaft = (parg(igxNP)-parg(igxCGaft))/parg(igcma)

      xLGnose = parg(igxlgnose)
      xLGmain = parg(igxCGaft) + parg(igdxlgmain)

      xLEw = parg(igxwbox) - parg(igXaxis)*parg(igco)
      xLEh = parg(igxhbox) - parg(igXaxis)*parg(igcoh)
      xLEv = parg(igxvbox) - parg(igXaxis)*parg(igcov)

      write(lu,'(a,f8.5,a)') ' tcapo   =', tcapo*in_m, '  in  '
      write(lu,'(a,f8.5,a)') ' tcaps   =', tcaps*in_m, '  in  '
      write(lu,'(a,f8.5,a)') ' tcapt   =', tcapt*in_m, '  in  '
      write(lu,'(a,f8.5,a)') ' twebo   =', twebo*in_m, '  in  '
      write(lu,'(a,f8.5,a)') ' twebs   =', twebs*in_m, '  in  '
      write(lu,'(a,f8.5,a)') ' twebt   =', twebt*in_m, '  in  '

      write(lu,'(a,f9.1,a)') ' So_max  =', Somax*lb_N, '  lb  '
      write(lu,'(a,f9.1,a)') ' Ss_max  =', Ssmax*lb_N, '  lb  '
      write(lu,'(a,f9.0,a)') ' Mo_max  =', Momax*lb_N*ft_m,' ft-lb'
      write(lu,'(a,f9.0,a)') ' Ms_max  =', Msmax*lb_N*ft_m,' ft-lb'
      write(lu,*)
      write(lu,'(a,f8.3,a)') ' Nlift   =', parg(igNlift)
      write(lu,'(a,f8.3,a)') ' Nland   =', parg(igNland)
      write(lu,'(a,f8.1,a)') ' Vne     =', parg(igVne)*nmi_m/hr_s,' kt'
      write(lu,*)
      write(lu,'(a,f8.2,a)') ' xnose   =', parg(igxnose  )*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xend    =', parg(igxend   )*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xLEw    =', xLEw           *ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xLEh    =', xLEh           *ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xLEv    =', xLEv           *ft_m ,'  ft '
      write(lu,*)
      write(lu,'(a,f8.2,a)') ' xwing   =', parg(igxwing  )*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xhtail  =', parg(igxhtail )*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xvtail  =', parg(igxvtail )*ft_m ,'  ft '
      write(lu,*)
      write(lu,'(a,f8.2,a)') ' xblend1 =', parg(igxblend1)*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xblend2 =', parg(igxblend2)*ft_m ,'  ft '
      write(lu,*)
      write(lu,'(a,f8.2,a)') ' xshell1 =', parg(igxshell1)*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xshell2 =', parg(igxshell2)*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xhbend  =', parg(igxhbend )*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xvbend  =', parg(igxvbend )*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xwbox   =', parg(igxwbox  )*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xhbox   =', parg(igxhbox  )*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xvbox   =', parg(igxvbox  )*ft_m ,'  ft '
      write(lu,*)
      write(lu,'(a,f8.2,a)') ' xfix    =', parg(igxfix   )*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xLGnose =', xLGnose        *ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xLGmain =', xLGmain        *ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xapu    =', parg(igxapu   )*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xhpesys =', parg(igxhpesys)*ft_m ,'  ft '
      write(lu,*)
      write(lu,'(a,f8.2,a)') ' xeng    =', parg(igxeng   )*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' yeng    =', parg(igyeng   )*ft_m ,'  ft '
      write(lu,*)
      write(lu,'(a,f8.2,a)') ' rpayfwd =', parg(igrpayfwd)
      write(lu,'(a,f8.2,a)') ' rpayaft =', parg(igrpayaft)
      write(lu,'(a,f8.2,a)') ' xCGfwd  =', parg(igxCGfwd )*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xCGaft  =', parg(igxCGaft )*ft_m ,'  ft '
      write(lu,'(a,f8.2,a)') ' xNP     =', parg(igxNP    )*ft_m ,'  ft '
      write(lu,'(a,f8.3,a)') ' mac     =', parg(igcma    )*ft_m ,'  ft '
      write(lu,'(a,f8.3,a)') ' S.M.fwd =', SMfwd
      write(lu,'(a,f8.3,a)') ' S.M.aft =', SMaft
      write(lu,*)
      write(lu,'(a,f8.3,a)') ' deps/da =', parg(igdepsda)
      write(lu,'(a,f8.3,a)') ' dCLn/da =', parg(igdCLnda)
      write(lu,*)
      write(lu,'(a,f8.3,a)') ' dCLh/dCL=', parg(igdCLhdCL)
      write(lu,'(a,f8.3,a)') ' dCLn/dCL=', parg(igdCLndCL)
      write(lu,*)
      write(lu,'(a,f8.3,a)') ' deltap  =', parg(igdeltap)*psi_Pa,'  psi'
      write(lu,'(a,f8.3,a)') ' tskin   =', parg(igtskin)*in_m, '  in  '
      write(lu,'(a,f8.3,a)') ' tfweb   =', parg(igtfweb)*in_m, '  in  '
      write(lu,'(a,f8.3,a)') ' tcone   =', parg(igtcone)*in_m, '  in  '
      write(lu,'(a,f8.3,a)') ' tfloor  =', parg(igtfloor)*in_m,'  in  '
      write(lu,'(a,f8.2,a)') ' hfloor  =', parg(ighfloor)*in_m,'  in  '
      write(lu,'(a,f8.3,a)') ' Rfuse   =', parg(igRfuse)*in_m ,'  in  '
      write(lu,'(a,f8.3,a)') ' dRfuse  =', parg(igdRfuse)*in_m,'  in  '
      write(lu,'(a,f8.3,a)') ' wfb     =', parg(igwfb  )*in_m ,'  in  '
      write(lu,'(a,f8.1,a)') ' cabVol  =', parg(igcabVol)*ft_m**3,
     &                                                         '  ft^3'
      write(lu,*)
      write(lu,'(a,f8.4,a)') ' AR      =', parg(igAR)
      write(lu,'(a,f8.3,a)') ' sweep   =', parg(igsweep)
      write(lu,'(a,f8.4,a)') ' lambdas =', parg(iglambdas) 
      write(lu,'(a,f8.4,a)') ' lambdat =', parg(iglambdat)  
      write(lu,'(a,f8.3,a)') ' co      =',       co *ft_m    ,'  ft  '
      write(lu,'(a,f8.3,a)') ' cs      =',       cs *ft_m    ,'  ft  '
      write(lu,'(a,f8.3,a)') ' ct      =',       ct *ft_m    ,'  ft  '
      write(lu,'(a,f8.3,a)') ' bo      =',parg(igbo)*ft_m    ,'  ft  '
      write(lu,'(a,f8.3,a)') ' bs      =',parg(igbs)*ft_m    ,'  ft  '
      write(lu,'(a,f8.3,a)') ' b       =',parg(igb)*ft_m     ,'  ft  '
      write(lu,'(a,f8.2,a)') ' S       =',parg(igS)*ft_m**2  ,'  ft^2'
      write(lu,*)
c      write(lu,'(a,f9.0,a)') ' Pstrut  =', Pstrutp*lb_N,' lb  '
c      write(lu,'(a,f9.0,a)') ' Pcrit   =', Pcrit  *lb_N,' lb  '
      write(lu,'(a,f8.3,a)') ' cstrut  =',parg(igCstrut)*ft_m ,'  ft  '
      write(lu,*)
      write(lu,'(a,f8.4,a)') ' ARh     =',parg(igARh)
      write(lu,'(a,f8.4,a)') ' lambdah =',parg(iglambdah) 
      write(lu,'(a,f8.2,a)') ' coh     =',parg(igcoh)*ft_m   ,'  ft  '
      write(lu,'(a,f8.2,a)') ' bh      =',parg(igbh)*ft_m    ,'  ft  '
      write(lu,'(a,f8.2,a)') ' Sh      =',parg(igSh)*ft_m**2 ,'  ft^2'
      write(lu,'(a,f8.3,a)') ' Sh/S    =',parg(igSh)/parg(igS)
      write(lu,'(a,f8.3,a)') ' Vh      =',parg(igVh)
      write(lu,'(a,f8.3,a)') ' CLhCGfwd=',parg(igCLhCGfwd)
      write(lu,*)
      write(lu,'(a,f8.4,a)') ' ARv     =',parg(igARv)
      write(lu,'(a,f8.4,a)') ' lambdav =',parg(iglambdav) 
      write(lu,'(a,f8.2,a)') ' cov     =',parg(igcov)*ft_m   ,'  ft  '
      write(lu,'(a,f8.2,a)') ' bv      =',parg(igbv)*ft_m    ,'  ft  '
      write(lu,'(a,f8.2,a)') ' Sv      =',parg(igSv)*ft_m**2 ,'  ft^2'
      write(lu,'(a,f8.3,a)') ' Sv/S    =',parg(igSv)/parg(igS)
      write(lu,'(a,f8.3,a)') ' Vv      =',parg(igVv)
      write(lu,'(a,f8.3,a)') ' CLveout =',parg(igCLveout)
      write(lu,*)
      write(lu,'(a,f8.2,a)') ' xwing   =', parg(igxwing)*ft_m ,'  ft '

      write(lu,*)
c
      return
      end ! geowrt


      subroutine tofwrt(lu,parg,parm,para,pare)
c----------------------------------------------------
c     Writes takeoff performance parameters
c----------------------------------------------------
      implicit real (a-h,l-z)
      include 'index.inc'
      include 'constants.inc'

      integer lu
      real parg(igtotal),
     &     parm(imtotal)
      real para(iatotal,iptotal), 
     &     pare(ietotal,iptotal)

      real Kinl

      tangBF = tan(parm(imgamVBF))
      tangTO = tan(parm(imgamVTO))
      tangCB = tan(parm(imgamVCB))
      dBSL = parm(imdBSL)
      dBCB = parm(imdBCB)
      dBFO = parm(imdBFO)
      zTO = 0.0
      xTO = 6500.0 - parm(imlTO)
      xCB = parm(imxCB)
      xFO = parm(imxFO)
      zCB = parm(imzCB)
      zFO = parm(imzFO)
      write(lu,'(a,f8.1,a)') ' F_TO =', parm(imFTO)*lb_N,' lb'
      write(lu,'(a,f8.2,a)') ' V_1  =', parm(imV1)*nmi_m/hr_s,' kt'
      write(lu,'(a,f8.2,a)') ' V_2  =', parm(imV2)*nmi_m/hr_s,' kt'
      write(lu,'(a,f8.4,a)') ' CL2  =', para(iaCL,ipclimb1)
      write(lu,'(a,f8.1,a)') ' l_1  =', parm(iml1) *ft_m,' ft'
      write(lu,'(a,f8.1,a)') ' l_BF =', parm(imlBF)*ft_m,' ft'
      write(lu,'(a,f8.1,a)') ' l_TO =', parm(imlTO)*ft_m,' ft'
      write(lu,'(a,f7.2,a)') ' tan(gam)_BF =', tangBF*100.0,' %'
      write(lu,'(a,f7.2,a)') ' tan(gam)_TO =', tangTO*100.0,' %'
      write(lu,'(a,f7.2,a)') ' tan(gam)_CB =', tangCB*100.0,' %'

      write(lu,*)
      write(lu,*)
     & ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
      write(lu,*) 'Noise...'
      write(lu,*)
      write(lu,*) '   x [m]   z [m]     dB'
      write(lu,'(1x,2f8.1,f9.3,a)') xTO, zTO, dBSL, '  sideline'
      write(lu,'(1x,2f8.1,f9.3,a)') xCB, zCB, dBCB, '  cutback'
      write(lu,'(1x,2f8.1,f9.3,a)') xFO, zFO, dBFO, '  flyover'

      return
      end ! tofwrt


      subroutine engwrt(lu,chp,pare)
c----------------------------------------------------
c     Writes engine operating state parameters
c----------------------------------------------------
      implicit real (a-h,l-z)

      integer lu
      character*(*) chp
      real pare(*)

      integer ncrow, icrow
      include 'index.inc'
      include 'constants.inc'

      real epsrow(ncrowx), Tmrow(ncrowx)

      ncrow = 0
      do icrow = 1, ncrowx
        epsrow(icrow) = pare(ieepsc1+icrow-1)
        Tmrow(icrow)  = pare(ieTmet1+icrow-1)
        if(epsrow(icrow) .gt. 0.0) ncrow = icrow
      enddo

      Tt0  = pare(ieTt0 )
      ht0  = pare(ieht0 )
      pt0  = pare(iept0 )
      cpt0 = pare(iecpt0)
      Rt0  = pare(ieRt0 )

      Tt18 = pare(ieTt18)
      ht18 = pare(ieht18)
      pt18 = pare(iept18)
      cpt18= pare(iecpt18)
      Rt18 = pare(ieRt18)

      Tt19 = pare(ieTt19)
      ht19 = pare(ieht19)
      pt19 = pare(iept19)
      cpt19= pare(iecpt19)
      Rt19 = pare(ieRt19)

      Tt2  = pare(ieTt2 )
      ht2  = pare(ieht2 )
      pt2  = pare(iept2 )
      cpt2 = pare(iecpt2)
      Rt2  = pare(ieRt2 )

      Tt21 = pare(ieTt21)
      ht21 = pare(ieht21)
      pt21 = pare(iept21)
      cpt21= pare(iecpt21)
      Rt21 = pare(ieRt21)

      Tt25 = pare(ieTt25 )
      ht25 = pare(ieht25 )
      pt25 = pare(iept25 )
      cpt25= pare(iecpt25)
      Rt25 = pare(ieRt25 )

      Tt3  = pare(ieTt3 )
      ht3  = pare(ieht3 )
      pt3  = pare(iept3 )
      cpt3 = pare(iecpt3)
      Rt3  = pare(ieRt3 )

      Tt4  = pare(ieTt4 )
      ht4  = pare(ieht4 )
      pt4  = pare(iept4 )
      cpt4 = pare(iecpt4)
      Rt4  = pare(ieRt4 )

      Tt41 = pare(ieTt41 )
      ht41 = pare(ieht41 )
      pt41 = pare(iept41 )
      cpt41= pare(iecpt41)
      Rt41 = pare(ieRt41 )

      Tt45 = pare(ieTt45 )
      ht45 = pare(ieht45 )
      pt45 = pare(iept45 )
      cpt45= pare(iecpt45)
      Rt45 = pare(ieRt45 )

      Tt49 = pare(ieTt49 )
      ht49 = pare(ieht49 )
      pt49 = pare(iept49 )
      cpt49= pare(iecpt49)
      Rt49 = pare(ieRt49 )

      Tt5  = pare(ieTt5 )
      ht5  = pare(ieht5 )
      pt5  = pare(iept5 )
      cpt5 = pare(iecpt5)
      Rt5  = pare(ieRt5 )

      Tt7  = pare(ieTt7 )
      ht7  = pare(ieht7 )
      pt7  = pare(iept7 )
      cpt7 = pare(iecpt7)
      Rt7  = pare(ieRt7 )


      p0 = pare(iep0)
      T0 = pare(ieT0)
      u0 = pare(ieu0)

      M0 = pare(ieM0)
      a0 = pare(iea0)
      rho0 = pare(ierho0)
      mu0  = pare(iemu0)


      p2 = pare(iep2)
      T2 = pare(ieT2)
      u2 = pare(ieu2)
      R2 = pare(ieR2)
      A2 = pare(ieA2)
      cp2 = pare(iecp2)

      p25 = pare(iep25)
      T25 = pare(ieT25)
      u25 = pare(ieu25)
      R25 = pare(ieR25)
      A25 = pare(ieA25)
      cp25 = pare(iecp25)

      p5 = pare(iep5)
      T5 = pare(ieT5)
      u5 = pare(ieu5)
      R5 = pare(ieR5)
      A5 = pare(ieA5)
      cp5 = pare(iecp5)

      p6 = pare(iep6)
      T6 = pare(ieT6)
      u6 = pare(ieu6)
      R6 = pare(ieR6)
      A6 = pare(ieA6)
      cp6 = pare(iecp6)

      p7 = pare(iep7)
      T7 = pare(ieT7)
      u7 = pare(ieu7)
      R7 = pare(ieR7)
      A7 = pare(ieA7)
      cp7 = pare(iecp7)

      p8 = pare(iep8)
      T8 = pare(ieT8)
      u8 = pare(ieu8)
      R8 = pare(ieR8)
      A8 = pare(ieA8)
      cp8 = pare(iecp8)

      u9 = pare(ieu9)
      A9 = pare(ieA9)

      M2  = pare(ieM2 )
      M25 = pare(ieM25)
      M5 = u5 / sqrt(T5*R5*cp5/(cp5-R5))
      M6 = u6 / sqrt(T6*R6*cp6/(cp6-R6))
      M7 = u7 / sqrt(T7*R7*cp7/(cp7-R7))
      M8 = u8 / sqrt(T8*R8*cp8/(cp8-R8))

      BPR  = pare(ieBPR)
      pif  = pare(iepif)
      pilc = pare(iepilc)
      pihc = pare(iepihc)
      pid  = pare(iepid)
      pib  = pare(iepib)
      pifn = pare(iepifn)
      pitn = pare(iepitn)

      Nf = pare(ieNf)
      N1 = pare(ieN1)
      N2 = pare(ieN2)

      epolf  = pare(ieepolf)
      epollc = pare(ieepollc)
      epolhc = pare(ieepolhc)
      epolht = pare(ieepolht)
      epollt = pare(ieepollt)

      ff = pare(ieff)
      fo = pare(iemofft)/pare(iemcore)
      fc = pare(iefc)

      mofft = pare(iemofft)
      Pofft = pare(iePofft)

      Kinl   = pare(ieKinl)
      Phiinl = pare(iePhiinl)

      Fsp   = pare(ieFsp)
      Fe    = pare(ieFe)
      hfuel = pare(iehfuel)
      mcore = pare(iemcore)
      mcool = pare(iemcore)*pare(iefc)
      mfuel = pare(iemcore)*pare(ieff)
      TSFC  = pare(ieTSFC)

      epf  = pare(ieepf )
      eplc = pare(ieeplc)
      ephc = pare(ieephc)
      epht = pare(ieepht)
      eplt = pare(ieeplt)

      etab = pare(ieetab)

      etaf  = pare(ieetaf )
      etalc = pare(ieetalc)
      etahc = pare(ieetahc)
      etaht = pare(ieetaht)
      etalt = pare(ieetalt)


      NbfD   = pare(ieNbfD )
      NblcD  = pare(ieNblcD)
      NbhcD  = pare(ieNbhcD)
      NbhtD  = pare(ieNbhtD)
      NbltD  = pare(ieNbltD)

      mbfD  = pare(iembfD )
      mblcD = pare(iemblcD)
      mbhcD = pare(iembhcD)
      mbhtD = pare(iembhtD)
      mbltD = pare(iembltD)

      pifD  = pare(iepifD )
      pilcD = pare(iepilcD)
      pihcD = pare(iepihcD)
      pihtD = pare(iepihtD)
      piltD = pare(iepiltD)

c---- corrected values
      Nbf  = Nf/sqrt(Tt2 /Tref)
      Nblc = N1/sqrt(Tt19/Tref)
      Nbhc = N2/sqrt(Tt25/Tref)
      Nbht = N2/sqrt(Tt41/Tref)
      Nblt = N1/sqrt(Tt45/Tref)
      mbf  = mcore*sqrt(Tt2 /Tref)/(pt2 /pref)*BPR
      mblc = mcore*sqrt(Tt19/Tref)/(pt19/pref)
      mbhc = mcore*sqrt(Tt25/Tref)/(pt25/pref)*(1.0-fo)
      mbht = mcore*sqrt(Tt41/Tref)/(pt41/pref)*(1.0-fo+ff)
      mblt = mcore*sqrt(Tt45/Tref)/(pt45/pref)*(1.0-fo+ff)

c---- cp/cv
      gam0  = cpt0 /(cpt0 -Rt0 )
      gam2  = cpt2 /(cpt2 -Rt2 )
      gam21 = cpt21/(cpt21-Rt21)
      gam7  = cpt7 /(cpt7 -Rt7 )
      gam18 = cpt18/(cpt18-Rt18)
      gam19 = cpt19/(cpt19-Rt19)
      gam25 = cpt25/(cpt25-Rt25)
      gam3  = cpt3 /(cpt3 -Rt3 )
      gam4  = cpt4 /(cpt4 -Rt4 )
      gam41 = cpt41/(cpt41-Rt41)
      gam45 = cpt45/(cpt45-Rt45)
      gam49 = cpt49/(cpt49-Rt49)
      gam5  = cpt5 /(cpt5 -Rt5 )

c---- mass flows
      mdot0  = mcore*(1.0 + BPR)
      mdot2  = mcore*BPR
      mdot21 = mcore*BPR
      mdot7  = mcore*BPR
      mdot18 = mcore
      mdot19 = mcore
      mdot25 = mcore*(1.0-fo)
      mdot3  = mcore*(1.0-fo-fc)
      mdot4  = mcore*(1.0-fo-fc+ff)
      mdot41 = mcore*(1.0-fo+ff)
      mdot45 = mcore*(1.0-fo+ff)
      mdot49 = mcore*(1.0-fo+ff)
      mdot5  = mcore*(1.0-fo+ff)

c---- powers
      Pfan = mdot2 *(ht2 -ht21)
      Plpc = mdot19*(ht19-ht25)
      Phpc = mdot25*(ht25-ht3 )
      Phpt = mdot41*(ht41-ht45)
      Plpt = mdot45*(ht45-ht49)

c---- effective device specific heats
      cpf  = (ht21-ht2 )/(Tt21-Tt2 )
      cplc = (ht25-ht19)/(Tt25-Tt19)
      cphc = (ht3 -ht25)/(Tt3 -Tt25)
      cpht = (ht45-ht41)/(Tt45-Tt41)
      cplt = (ht49-ht45)/(Tt49-Tt45)

 3000 format(1x,a,': ',a,6g13.5)
 3010 format(1x,a,': ',a,g13.5,a)

      write(lu,*)
      write(lu,3000) chp, 'BPR    =', BPR
      write(lu,3000) chp, 'FPR    =', pif
      write(lu,3000) chp, 'OPR    =', pilc*pihc
      write(lu,3000) chp, 'pilc   =', pilc
      write(lu,3000) chp, 'pihc   =', pihc
      write(lu,3000) chp, '1/piht =', pt41/pt45
      write(lu,3000) chp, '1/pilt =', pt45/pt49
      write(lu,3000) chp, 'pid    =', pid
      write(lu,3000) chp, 'pib    =', pib
      write(lu,3000) chp, 'pifn   =', pifn
      write(lu,3000) chp, 'pitn   =', pitn
      write(lu,3000) chp, 'N1     =', N1
      write(lu,3000) chp, 'N2     =', N2
      write(lu,3000) chp, 'Nlc_c% =', Nblc/NblcD * 100.0
      write(lu,3000) chp, 'Nhc_c% =', Nbhc/NbhcD * 100.0
      write(lu,3000) chp, 'Nht_c% =', Nbht/NbhtD * 100.0
      write(lu,3000) chp, 'Nlt_c% =', Nblt/NbltD * 100.0
      write(lu,3000) chp, 'mlc_c% =', mblc/mblcD * 100.0
      write(lu,3000) chp, 'mhc_c% =', mbhc/mbhcD * 100.0
      write(lu,3000) chp, 'mht_c% =', mbht/mbhtD * 100.0
      write(lu,3000) chp, 'mlt_c% =', mblt/mbltD * 100.0
      write(lu,3000) chp, 'mf_c%  =', mbf /mbfD  * 100.0
      write(lu,3000) chp, 'epf    =', epf
      write(lu,3000) chp, 'eplc   =', eplc
      write(lu,3000) chp, 'ephc   =', ephc
      write(lu,3000) chp, 'epht   =', epht
      write(lu,3000) chp, 'eplt   =', eplt
      write(lu,3000) chp, 'etab   =', etab
      write(lu,3000) chp, 'fo     =', fo   
      write(lu,3000) chp, 'ffbar  =', ff/(1.0-fo-fc)
      write(lu,3000) chp, 'ff     =', ff
      write(lu,3000) chp, 'fc     =', fc
      write(lu,3000) chp, 'epsrow =', (epsrow(icrow), icrow=1,ncrow)
      write(lu,3000) chp, 'Tmrow  =', (Tmrow(icrow) , icrow=1,ncrow)


      effp6 = 2.0*u0/(u0 + u6)
      effp8 = 2.0*u0/(u0 + u8)

      if(u0+u9 .eq. 0.0) then
       effp9 = 0.
      else
       effp9 = 2.0*u0/(u0 + u9)
      endif

      mdot = ff*mcore
      PK   = 0.5*( (1.0-fo+ff)*(u6**2 - u0**2) 
     &            +       BPR *(u8**2 - u0**2) 
     &            +        fo *(u9**2 - u0**2))*mcore  +  Phiinl
      Phij = 0.5*( (1.0-fo+ff)*(u6 - u0)**2 
     &            +       BPR *(u8 - u0)**2 
     &            +        fo *(u9 - u0)**2)*mcore
      Pprop = PK - Phij + mdot*u0**2
      if(PK .eq. 0.0) then
       etap = 0.
      else
       etap = Pprop / PK
      endif


      F6sp =     ((1.0-fo+ff)*u6 - u0)/((1.0+BPR)*a0)
      F8sp = BPR*(            u8 - u0)/((1.0+BPR)*a0)
      F9sp =     (        fo *u9     )/((1.0+BPR)*a0)
      Fsp = F6sp + F8sp + F9sp

C---- alternative thrust definition (Kerrebrock)
      FA6 =     ((1.0-fo+ff)*u5 - u0)*mcore  +  (p5-p0)*A5
      FA8 = BPR*(            u7 - u0)*mcore  +  (p7-p0)*A7
      FA9 =     (        fo *u9     )*mcore
      FA  = FA6 + FA8 + FA9

      if(u0 .eq. 0.0) then
       Acap = 99.9999
      else
       Acap = mcore*(1.0+BPR)/(rho0*u0)
      endif

      write(lu,*)
      write(lu,3010) chp, 'Fsp    =', Fsp
      write(lu,3010) chp, 'Feng   =', Fe/1.0e3     , ' kN'
      write(lu,3010) chp, 'FengA  =', FA/1.0e3     , ' kN'
      write(lu,3010) chp, 'mcore  =', mcore        , ' kg/s'
      write(lu,3010) chp, 'mcool  =', mcool        , ' kg/s'
      write(lu,3010) chp, 'mfuel  =', mfuel        , ' kg/s'
      write(lu,3010) chp, 'mofft  =', mofft        , ' kg/s'
      write(lu,3010) chp, 'Pofft  =', Pofft/1000.0 , ' kW'
      write(lu,3010) chp, 'PK     =', PK/1000.0    , ' kW'
      write(lu,3010) chp, 'Phijet =', Phij/1000.0  , ' kW'
      write(lu,3010) chp, 'Phiinl =', Phiinl/1000.0, ' kW'
      write(lu,3010) chp, 'Kinl   =', Kinl/1000.0  , ' kW'
      write(lu,3010) chp, 'etap   =', etap
      write(lu,3010) chp, 'TSFC   =', TSFC*3600.0  , ' 1/hr'
      write(lu,3010) chp, 'hfuel  =', hfuel/1.0e6  , ' MJ/kg'

 3100 format(
     & /1x,a,':  loc     Tt      pt       cpt       R    cpt/(cpt-R)',
     & /3x,  '           K       kPa     J/kg K   J/kg K')
c               10     1500.0   400.12   1020.0    287.0   1.4234
c               123 23456789 23456789 23456789 23456789 23456789
 3150 format(1x,5x,a, f9.1, f9.2, f9.1, f9.1, f9.4)

      write(lu,3100) chp
      write(lu,3150)' 0 ',Tt0 ,pt0 /1000.0,cpt0 ,Rt0 ,gam0 
      write(lu,3150)' 2 ',Tt2 ,pt2 /1000.0,cpt2 ,Rt2 ,gam2 
      write(lu,3150)' 21',Tt21,pt21/1000.0,cpt21,Rt5 ,gam21
      write(lu,3150)' 7 ',Tt7 ,pt7 /1000.0,cpt7 ,Rt7 ,gam7 
      write(lu,*)
      write(lu,3150)' 0 ',Tt0 ,pt0 /1000.0,cpt0 ,Rt0 ,gam0 
      write(lu,3150)' 18',Tt18,pt18/1000.0,cpt18,Rt5 ,gam18
      write(lu,3150)' 19',Tt19,pt19/1000.0,cpt19,Rt5 ,gam19
      write(lu,3150)' 25',Tt25,pt25/1000.0,cpt25,Rt5 ,gam25
      write(lu,3150)' 3 ',Tt3 ,pt3 /1000.0,cpt3 ,Rt3 ,gam3 
      write(lu,3150)' 4 ',Tt4 ,pt4 /1000.0,cpt4 ,Rt4 ,gam4 
      write(lu,3150)' 41',Tt41,pt41/1000.0,cpt41,Rt41,gam41
      write(lu,3150)' 45',Tt45,pt45/1000.0,cpt45,Rt45,gam45
      write(lu,3150)' 49',Tt49,pt49/1000.0,cpt49,Rt49,gam49
      write(lu,3150)' 5 ',Tt5 ,pt5 /1000.0,cpt5 ,Rt5 ,gam5 

 3210 format(
     & /1x,a ,':  device     power    dh/dT     epol     eta',
     & /3x,   '               kW      J/kg K                ')
c                   2 -7  13000.0    1210.0   0.8612   0.8612
c               234567 23456789 23456789 23456789 23456789
 3250 format(1x,4x,a, f9.1, f9.1, 2f9.4)

      write(lu,3210) chp
      write(lu,3250) 'fan 2 -21', Pfan/1000.0, cpf , epf,  etaf
      write(lu,3250) 'LPC 19-25', Plpc/1000.0, cplc, eplc, etalc
      write(lu,3250) 'HPC 25-3 ', Phpc/1000.0, cphc, ephc, etahc
      write(lu,3250) 'HPT 41-45', Phpt/1000.0, cpht, epht, etaht
      write(lu,3250) 'LPT 45-49', Plpt/1000.0, cplt, eplt, etalt

 3300 format(
     & /1x,a,':  loc   T       p       M       u        A ',
     &       '    Fsp    eta_p',
     & /4x,  '        K      kPa             m/s      m^2' )
c             10   1500.0  400.12  0.9042  602.00  0.4123  0.4123  0.7801
c             123 2345678 2345678 2345678 2345678 2345678 2345678 23456789
 3350 format(1x,4x,a, f8.1, f8.2, f8.4, f8.2, f8.4, f8.4, f8.4)
 3351 format(1x,4x,a, 8x  , 8x  , 8x  , f8.2, f8.4, f8.4, f8.4)

      write(lu,3300) chp
      write(lu,3350) ' 0 ', T0 , p0 /1000.0, M0 , u0 , Acap, Fsp  
      write(lu,3350) ' 2 ', T2 , p2 /1000.0, M2 , u2 , A2 
      write(lu,*)
      write(lu,3350) ' 25', T25, p25/1000.0, M25, u25, A25 
      write(lu,*)
      write(lu,3350) ' 5 ', T5 , p5 /1000.0, M5 , u5 , A5  
      write(lu,3350) ' 6 ', T6 , p6 /1000.0, M6 , u6 , A6  , F6sp, effp6
      write(lu,*)
      write(lu,3350) ' 7 ', T7 , p7 /1000.0, M7 , u7 , A7
      write(lu,3350) ' 8 ', T8 , p8 /1000.0, M8 , u8 , A8  , F8sp, effp8
      write(lu,*)
      write(lu,3351) ' 9 ',                       u9 , A9  , F9sp, effp9
c
      return
      end ! engwrt



      subroutine mapwrt(lu,pare,chp,ilabel)
c----------------------------------------------------
c     Writes compressor map parameters
c----------------------------------------------------
      implicit real (a-h,l-z)

      integer lu
      real pare(*)
      character*(*) chp

      integer ncrow, icrow
      include 'index.inc'
      include 'constants.inc'

      Tt0  = pare(ieTt0 )
      Tt19 = pare(ieTt19)
      Tt2  = pare(ieTt2 )
      Tt25 = pare(ieTt25)
      Tt3  = pare(ieTt3 )
      Tt4  = pare(ieTt4 )
      Tt41 = pare(ieTt41)
      Tt45 = pare(ieTt45)
      Tt5  = pare(ieTt5 )
      Tt7  = pare(ieTt7 )

      pt0  = pare(iept0 )
      pt19 = pare(iept19)
      pt2  = pare(iept2 )
      pt25 = pare(iept25)
      pt3  = pare(iept3 )
      pt4  = pare(iept4 )
      pt41 = pare(iept41)
      pt45 = pare(iept45)
      pt5  = pare(iept5 )
      pt7  = pare(iept7 )


      BPR  = pare(ieBPR)
      pif  = pare(iepif)
      pilc = pare(iepilc)
      pihc = pare(iepihc)
      pid  = pare(iepid)
      pib  = pare(iepib)

      Nf = pare(ieNf)
      N1 = pare(ieN1)
      N2 = pare(ieN2)

      epolf  = pare(ieepolf)
      epollc = pare(ieepollc)
      epolhc = pare(ieepolhc)
      epolht = pare(ieepolht)
      epollt = pare(ieepollt)

      ff = pare(ieff)

      Fsp   = pare(ieFsp)
      Fe    = pare(ieFe)
      hfuel = pare(iehfuel)
      mcore = pare(iemcore)
      TSFC  = pare(ieTSFC)

      epf  = pare(ieepf )
      eplc = pare(ieeplc)
      ephc = pare(ieephc)
      epht = pare(ieepht)
      eplt = pare(ieeplt)

      etaf  = pare(ieetaf )
      etalc = pare(ieetalc)
      etahc = pare(ieetahc)
      etaht = pare(ieetaht)
      etalt = pare(ieetalt)


      NbfD   = pare(ieNbfD )
      NblcD  = pare(ieNblcD)
      NbhcD  = pare(ieNbhcD)
      NbhtD  = pare(ieNbhtD)
      NbltD  = pare(ieNbltD)

      mbfD  = pare(iembfD )
      mblcD = pare(iemblcD)
      mbhcD = pare(iembhcD)
      mbhtD = pare(iembhtD)
      mbltD = pare(iembltD)

      pifD  = pare(iepifD )
      pilcD = pare(iepilcD)
      pihcD = pare(iepihcD)
      pihtD = pare(iepihtD)
      piltD = pare(iepiltD)

c---- corrected values
      Nbf  = Nf/sqrt(Tt2 /Tref)
      Nblc = N1/sqrt(Tt19/Tref)
      Nbhc = N2/sqrt(Tt25/Tref)
      Nbht = N2/sqrt(Tt41/Tref)
      Nblt = N1/sqrt(Tt45/Tref)
      mbf  = mcore*sqrt(Tt2 /Tref)/(pt2 /pref)*BPR
      mblc = mcore*sqrt(Tt19/Tref)/(pt19/pref)
      mbhc = mcore*sqrt(Tt25/Tref)/(pt25/pref)
      mbht = mcore*sqrt(Tt41/Tref)/(pt41/pref)*(1.0+ff)
      mblt = mcore*sqrt(Tt45/Tref)/(pt45/pref)*(1.0+ff)


      OPR = pilc*pihc

      if(ilabel.ne.0) then
       write(lu,4100)
 4100  format('#' /
     & '#   mf/mfD    pif     Nf/NfD   epolf    ',
     &  '  mlc/mlcD   pilc   Nlc/NlcD  epollc   ',
     &  '  mhc/mhcD   pihc   Nhc/NhcD  epolhc   ',
     &  '    OPR      Fsp      TSFC  ' )
ccc       12345678 12345678 12345678 12345678 xxx 
      endif

 4200 format(1x,3(4f9.5,3x), 3f9.5)
      write(lu,4200) 
     &   mbf /mbfD , pif , Nbf /NbfD , epf,
     &   mblc/mblcD, pilc, Nblc/NblcD, eplc,
     &   mbhc/mbhcD, pihc, Nbhc/NbhcD, ephc, OPR, Fsp, TSFC/hr_s

      return
      end ! mapwrt



      subroutine airwrt(lu,chp,para,parg)
c----------------------------------------------------
c     Writes aerodynamic parameters
c----------------------------------------------------
      implicit real (a-h,l-z)
      include 'index.inc'
      
      integer lu
      character*(*) chp
      real para(iatotal), parg(igtotal)

      include 'constants.inc'

      real Kc,Ko,Kp,Kf

      gamV = para(iagamV)
      gamVdeg = gamV*180.0/pi

      cosL = cos(parg(igsweep)*pi/180.0)
      tang = tan(gamV)
      if(para(iaCD) .eq. 0.0) then
       LoD = 0.
      else
       LoD = para(iaCL)/para(iaCD)
      endif

      clpo = para(iaclpo)
      clps = para(iaclps)
      clpt = para(iaclpt)

      cmpo = para(iacmpo)
      cmps = para(iacmps)
      cmpt = para(iacmpt)


      SM = (para(iaxNP)-para(iaxCG))/parg(igcma)

      xwbox = parg(igxwbox)
      xhbox = parg(igxhbox)
      xCG   = para(iaxCG)

      S    = parg(igS)
      Sh   = parg(igSh)
      co   = parg(igco)
      coh  = parg(igcoh)
      cma  = parg(igcma)

      CMw0 = para(iaCMw0)
      CMw1 = para(iaCMw1)
      CMh0 = para(iaCMh0)
      CMh1 = para(iaCMh1)

      CL  = para(iaCL )
      CLh = para(iaCLh)
      CMVf1 = parg(igCMVf1)
      CLMf0 = parg(igCLMf0)

      CLhtail = CLh*Sh/S


      altkm = para(iaalt)/1000.0
      call atmos(altkm, T0,p0,rho0,a0,mu0)
      u0 = a0*para(iaMach)
      q0 = 0.5*rho0*u0**2

      lambdat = parg(iglambdat)
      lambdas = parg(iglambdas)
      gammat = lambdat*para(iarclt)
      gammas = lambdas*para(iarcls)
      etao = parg(igbo)/parg(igb)
      etas = parg(igbs)/parg(igb)
      fLo = parg(igfLo)
      fLt = parg(igfLt)
      AR = parg(igAR)
      Kc = etao
     &   + 0.5*(1.0    +lambdas)*(etas-etao)
     &   + 0.5*(lambdas+lambdat)*(1.0 -etas)
      Ko = 1.0/(AR*Kc)
      Kp = etao
     &   + 0.5*(1.0    +gammas )*(etas-etao)
     &   + 0.5*(gammas +gammat )*(1.0 -etas)
     &   + fLo*etao + 2.0*fLt*Ko*gammat*lambdat
      Kf = etao
     &   + fLo*etao
      if(CL.eq.0.0) then
       Lwingf = 0.
       Lfusef = 0.
       Ltailf = 0.
      else
       Lwingf = (1.0 - CLhtail/CL)*(1.0-Kf/Kp)
       Lfusef = (1.0 - CLhtail/CL)*     Kf/Kp
       Ltailf =        CLhtail/CL
      endif


      CLwing = (CL - CLhtail)*(1.0-Kf/Kp)
      CLfuse = (CL - CLhtail)*     Kf/Kp
      CLtail =       CLhtail



c      CMwing = (co *CMw0      + (co *CMw1-xwbox+xCG)*CLwing )/cma
c      CMfuse = (                (co *CMw1-xwbox+xCG)*CLfuse )/cma
c     &       + CMVf1*(CL-CLMf0)/(S*cma)
c      CMtail = (coh*CMh0*Sh/S + (coh*CMh1-xhbox+xCG)*CLtail )/cma
c
c      CMwing = para(iaCMwing)
c      CMfuse = para(iaCMfuse)
c      CMtail = para(iaCMtail)

      CMwing = (co *CMw0      + (co *CMw1-xwbox)*(CL-CLh*Sh/S))/cma
      CMtail = (coh*CMh0*Sh/S + (coh*CMh1-xhbox)*    CLh*Sh/S )/cma
      CMfuse = CMVf1*(CL-CLMf0)/(S*cma)

      write(lu,*)
      write(lu,'(1x,a,a,f8.0,a)') chp,': alt.   =', para(iaalt)*ft_m,
     &                                              ' ft'
      write(lu,'(1x,a,a,f8.2,a)') chp,': dyn.pr.=', q0*lb_N/ft_m**2,
     &                                              ' psf'
      write(lu,'(1x,a,a,f8.2,a)') chp,': VTAS   =', u0*ft_m,
     &                                              ' ft/s'
      write(lu,'(1x,a,a,f8.5,a)') chp,': W/WMTO =', para(iafracW)
      write(lu,'(1x,a,a,f8.4,a)') chp,': Mach   =', para(iaMach)
      write(lu,'(1x,a,a,f8.3,a)') chp,': L/D    =', LoD
      write(lu,'(1x,a,a,f8.5,a)') chp,': gamV   =', gamVdeg,' deg'
      write(lu,'(1x,a,a,f8.4,a)') chp,': e      =', para(iaspaneff)
      write(lu,'(1x,a,a,f8.4,a)') chp,': CL     =', para(iaCL)
      write(lu,'(1x,a,a,f8.5,a)') chp,': CD     =', para(iaCD)
      write(lu,'(1x,a,a,f8.5,a)') chp,': CDi    =', para(iaCDi)
      write(lu,'(1x,a,a,f8.5,a)') chp,': CDfuse =', para(iaCDfuse)
      write(lu,'(1x,a,a,f8.5,a)') chp,': CDwing =', para(iaCDwing)
      write(lu,'(1x,a,a,f8.5,a)') chp,': CDover =', para(iaCDover)
      write(lu,'(1x,a,a,f8.5,a)') chp,': CDhtail=', para(iaCDhtail)
      write(lu,'(1x,a,a,f8.5,a)') chp,': CDvtail=', para(iaCDvtail)
      write(lu,'(1x,a,a,f8.5,a)') chp,': CDnace =', para(iaCDnace)
      write(lu,'(1x,a,a,f8.5,a)') chp,': CDstrut=', para(iaCDstrut)
      write(lu,'(1x,a,a,f8.4,a)') chp,': Mperp  =', para(iaMach)*cosL
      write(lu,'(1x,a,a,f8.4,a)') chp,': clpo   =', clpo
      write(lu,'(1x,a,a,f8.4,a)') chp,': clps   =', clps
      write(lu,'(1x,a,a,f8.4,a)') chp,': clpt   =', clpt
      write(lu,'(1x,a,a,f8.4,a)') chp,': fduo   =', para(iafduo)
      write(lu,'(1x,a,a,f8.4,a)') chp,': fdus   =', para(iafdus)
      write(lu,'(1x,a,a,f8.4,a)') chp,': fdut   =', para(iafdut)
      write(lu,'(1x,a,a,f8.5,a)') chp,': cdpw   =', para(iacdpw)
      write(lu,'(1x,a,a,f8.5,a)') chp,': cdfw   =', para(iacdfw)
      write(lu,'(1x,a,a,f8.5,a)') chp,': cdw    =', para(iacdpw)
     &                                            + para(iacdfw)
      write(lu,'(1x,a,a,f8.4,a)') chp,': Clh    =', para(iaCLh)
      write(lu,'(1x,a,a,f8.4,a)') chp,': ClhSh/S=', CLhtail
      write(lu,'(1x,a,a,f8.4,a)') chp,': CMwing =', CMwing
      write(lu,'(1x,a,a,f8.4,a)') chp,': CMfuse =', CMfuse
      write(lu,'(1x,a,a,f8.4,a)') chp,': CMtail =', CMtail
      write(lu,'(1x,a,a,f8.4,a)') chp,': cmpo   =', cmpo
      write(lu,'(1x,a,a,f8.4,a)') chp,': cmps   =', cmps
      write(lu,'(1x,a,a,f8.4,a)') chp,': cmpt   =', cmpt
      write(lu,'(1x,a,a,f8.5,a)') chp,': dh/dR  =', tang
      write(lu,'(1x,a,a,f8.2,a)') chp,': xCG    =', para(iaxCG)*ft_m,
     &                                              ' ft'
      write(lu,'(1x,a,a,f8.2,a)') chp,': xNP    =', para(iaxNP)*ft_m,
     &                                              ' ft'
      write(lu,'(1x,a,a,f8.3,a)') chp,': S.M.   =', SM
      write(lu,'(1x,a,a,f8.1,a)') chp,': Wbuoy  =', para(iaWbuoy)*lb_N,
     &                                              ' lb'
      write(lu,'(1x,a,a,f8.2,a)') chp,': Lwing  =', Lwingf*100.0, ' %'
      write(lu,'(1x,a,a,f8.2,a)') chp,': Lfuse  =', Lfusef*100.0, ' %'
      write(lu,'(1x,a,a,f8.2,a)') chp,': Ltail  =', Ltailf*100.0, ' %'
      return
      end ! airwrt



      subroutine prfwrt(lu,parg,parm,para,pare)
c----------------------------------------------------
c     Writes mission profile parameters
c----------------------------------------------------
      implicit real (a-h,l-z)
      include 'index.inc'
      include 'constants.inc'
      
      integer lu
      real parg(igtotal),
     &     parm(imtotal)
      real para(iatotal,iptotal), 
     &     pare(ietotal,iptotal)

      rWTO = parg(igWMTO)/parm(imWTO)
c
 3010 format(a,a,a,a,a)
 3100 format(
     & 1x,a,':  ', f8.2,   f9.1,    f9.4,    f9.2,
     &      f9.5,  f8.4,   f8.3,    f9.5,    f9.5,
     &      f8.1,  f8.4,   f9.4,    f9.5,    f9.3 )
      write(lu,3010)
     & '           R        h        t       VTAS ',
     & '    Mach    CL     L/D''    W/WMTO   W/WTO ',
     & '    Tt4     M2     mdotf    TSFC''     gamma'
      write(lu,3010)
     & '         [nmi]     [ft]     [hr]     [kt] ',
     & '                                         ',
     & '     [K]            [kg/s]  [1/hr]     [deg]'
      do ip = ipstatic, ipdescentn
        if(ip.ne.iprotate) then
         if(para(iaCD,ip) .eq. 0.0) then
          LoD = 0.
         else
          LoD = para(iaCL,ip)/para(iaCD,ip)
         endif
         write(lu,3100)
     &      cplab(ip),
     &      para(iaRange,ip)*nmi_m,
     &      para(iaalt  ,ip)*ft_m,
     &      para(iatime ,ip)*hr_s,
     &      pare(ieu0   ,ip)*nmi_m/hr_s,
     &      para(iaMach ,ip),
     &      para(iaCL,ip),
     &      LoD,
     &      para(iafracW,ip),
     &      para(iafracW,ip)*rWTO,
     &      pare(ieTt4,ip),
     &      pare(ieM2,ip),
     &      pare(iemcore,ip)*pare(ieff,ip)*parg(igneng),
     &      pare(ieTSFC,ip)/hr_s,
     &      para(iagamV,ip)*180.0/pi

c         write(90,3100)
c     &      ' ',
c     &      para(iaRange,ip)*nmi_m,
c     &      para(iaalt  ,ip)*ft_m,
c     &      para(iatime ,ip)*hr_s,
c     &      pare(ieu0   ,ip)*nmi_m/hr_s,
c     &      para(iaMach ,ip),
c     &      para(iaCL,ip),
c     &      LoD,
c     &      para(iafracW,ip),
c     &      para(iafracW,ip)*rWTO,
c     &      pare(ieTt4,ip),
c     &      pare(ieM2,ip),
c     &      pare(iemcore,ip)*pare(ieff,ip)*parg(igneng),
c     &      pare(ieTSFC,ip)/hr_s,
c     &      para(iagamV,ip)*180.0/pi

        endif
      enddo

      return
      end ! prfwrt


      subroutine blfwrt(lu,nbl,iblte,Mach,Reunit,
     &                  xbl,zbl,sbl,bbl,
     &                  uinv,uebl,
     &                  dsbl,thbl,tsbl,dcbl,
     &                  ctbl,cfbl,cdbl,hkbl,phbl)
c----------------------------------------------------
c     Writes fuselage BL parameters
c----------------------------------------------------
      implicit real (a-h,l-z)
      integer lu, nbl, iblte

      real xbl(*),zbl(*),sbl(*),bbl(*),
     &     uinv(*),uebl(*),
     &     dsbl(*),thbl(*),tsbl(*),dcbl(*),
     &     ctbl(*),cfbl(*),cdbl(*),hkbl(*),phbl(*)
      include 'constants.inc'


 1100 format(1x,a,a,a,a,a)
      write(lu,1100)
     & '     s       x       r       b  ',
     & '  uinv/V    ue/V     Me      Hk    Rtheta  ',
     & '    Cf/2      CD    ',
     & ' delta*   theta ',
     & '  D/rV    P/rV2   K/rV3   Q/rV   Phi/rV3   b CD    b Cf/2'

c----- for SI output
c     lunit = 1.0
c     write(lu,1100)
c    & '    [m]     [m]     [m]     [m] ',
c    & '                                   ',
c    & '  [m]     [m]   ',
c    & '  [m^2]   [m^2]   [m^2]   [m^2]   [m^2]    [m]      [m]  '

c---- for English output
      lunit = ft_m
      write(lu,1100)
     & '    [ft]    [ft]    [ft]    [ft]',
     & '                                                       ',
     & '  [ft]    [ft]  ',
     & ' [ft^2]  [ft^2]  [ft^2]  [ft^2]  [ft^2]    [ft]     [ft] '

 1200 format(1x, 
     &    4f8.2, 
     &    2f8.4, f8.4, f7.3, g11.3, 
     &   2f10.6, 
     &    2f8.4, 
     &    5f8.4, 2f10.6)

      gmi = gamSL-1.0
      do i = 1, nbl
        asq = 1.0 + 0.5*gmi*Mach**2*(1.0-uebl(i)**2)
        Me = uebl(i)*Mach / sqrt(asq)

c------ note:
c-        rhbl = rho_e/rho_inf
c-        uebl = u_e/V_inf

        rhbl = asq**(1.0/gmi)
        mubl = asq/Reunit

        Rtheta = rhbl*uebl(i)*thbl(i)/mubl

        beff = bbl(i) + 2.0*pi*dsbl(i)

c       dsa = dsbl(i)*beff
c       tha = thbl(i)*beff
c       tsa = tsbl(i)*beff
c       dca = dcbl(i)*beff

        dsa = dsbl(i)*beff * rhbl*uebl(i)
        tha = thbl(i)*beff * rhbl*uebl(i)**2
        tsa = tsbl(i)*beff * rhbl*uebl(i)**3 * 0.5
        dca = dcbl(i)*beff * rhbl*uebl(i)

        tau = 0.5*rhbl*uebl(i)**2 * cfbl(i) * beff
        dis =     rhbl*uebl(i)**3 * cdbl(i) * beff

        write(lu,1200)
     &    sbl(i)*lunit,
     &    xbl(i)*lunit,
     &    zbl(i)*lunit,
     &    beff*lunit,
     &    uinv(i),
     &    uebl(i),
     &    Me,
     &    hkbl(i),
     &    Rtheta,
     &    0.5*cfbl(i),
     &    cdbl(i),
     &    dsbl(i)*lunit,
     &    thbl(i)*lunit,
     &    dsa*lunit**2,
     &    tha*lunit**2,
     &    tsa*lunit**2,
     &    dca*lunit**2,
     &    phbl(i)*lunit**2,
     &    dis*lunit,
     &    tau*lunit
        if(i.eq.iblte) write(lu,*)

      enddo

      return
      end ! blfwrt


      subroutine blfwrt2(lu,nbl,iblte,Mach,Reunit,
     &                  xbl,zbl,sbl,bbl,
     &                  uinv,uebl,
     &                  dsbl,thbl,tsbl,dcbl,
     &                  ctbl,cfbl,cdbl,hkbl,phbl)
c----------------------------------------------------
c     Writes fuselage BL parameters
c----------------------------------------------------
      implicit real (a-h,l-z)
      integer lu, nbl, iblte

      real xbl(*),zbl(*),sbl(*),bbl(*),
     &     uinv(*),uebl(*),
     &     dsbl(*),thbl(*),tsbl(*),dcbl(*),
     &     ctbl(*),cfbl(*),cdbl(*),hkbl(*),phbl(*)

      real Kdef, Mdef

      include 'constants.inc'



 1100 format(a,a,a,a,a)
      write(lu,1100)
     & '#     x         z         s         b   ',
     & '      Cp       ue/V    rhoe/rinf   Me       Hk     Rtheta    ',
     & '   delta*      theta     theta*    delta**  ',
     & '    Cf/2      CD       Ctau   ',
     & '    m/rV     P/rV^2    K/rV^3  Diss/rV^3'

c----- for SI output
c     lunit = 1.0
c     write(lu,1100)
c    & '#     [m]       [m]       [m]       [m]  ',
c    & '                                                             ',
c    & '    [m]        [m]        [m]        [m]   ',
c    & '                              ',
c    & '   [m^2]     [m^2]     [m^2]     [m^2]  '

c---- for English output
      lunit = ft_m
      write(lu,1100)
     & '#    [ft]      [ft]      [ft]      [ft]  ',
     & '                                                             ',
     & '   [ft]       [ft]       [ft]       [ft]   ',
     & '                              ',
     & '  [ft^2]    [ft^2]    [ft^2]    [ft^2]  '

      write(lu,1100)
     & '#     1         2         3         4    ',
     & '     5         6        7        8        9         10       ',
     & '    11         12         13         14    ',
     & '    15        16        17    ',
     & '    18        19        20        21    '

 1200 format(1x, 
     &    4f10.4, 
     &    f10.4, f10.5 f9.4, f9.4, f8.4, g13.5, 
     &    4f11.6,
     &    3f10.6, 
     &    4f10.5)

      gam = gamSL
      gmi = gamSL-1.0
      do i = 1, nbl
        asq = 1.0 + 0.5*gmi*Mach**2*(1.0-uebl(i)**2)
        Me = uebl(i)*Mach / sqrt(asq)

c------ note:
c-        rhbl = rho_e/rho_inf
c-        uebl = u_e/V_inf

        rhbl = asq**(1.0/gmi)
        mubl = asq/Reunit

        prbl = asq**(gam/gmi)
        cpbl = (prbl-1.0)/0.5

        Rtheta = rhbl*uebl(i)*thbl(i)/mubl

        beff = bbl(i) + 2.0*pi*dsbl(i)

c       dsa = dsbl(i)*beff
c       tha = thbl(i)*beff
c       tsa = tsbl(i)*beff
c       dca = dcbl(i)*beff

        dsa = dsbl(i)*beff * rhbl*uebl(i)
        tha = thbl(i)*beff * rhbl*uebl(i)**2
        tsa = tsbl(i)*beff * rhbl*uebl(i)**3 * 0.5
        dca = dcbl(i)*beff * rhbl*uebl(i)

        tau = 0.5*rhbl*uebl(i)**2 * cfbl(i) * beff
        dis =     rhbl*uebl(i)**3 * cdbl(i) * beff

        cfblinf = cfbl(i)*rhbl*uebl(i)**2
        cdblinf = cdbl(i)*rhbl*uebl(i)**3
        ctblinf = ctbl(i)*rhbl*uebl(i)**2

        Mdef = dsbl(i)*beff*rhbl*uebl(i)
        Pdef = thbl(i)*beff*rhbl*uebl(i)**2
        Kdef = tsbl(i)*beff*rhbl*uebl(i)**3 * 0.5
        Ddef = dcbl(i)*beff*rhbl*uebl(i)
        Diss = phbl(i)

        write(lu,1200)
     &    xbl(i)*lunit,
     &    zbl(i)*lunit,
     &    sbl(i)*lunit,
     &    bbl(i)*lunit,
     &    cpbl,
     &    uebl(i),
     &    rhbl,
     &    Me,
     &    hkbl(i),
     &    Rtheta,
     &    dsbl(i)*lunit,
     &    thbl(i)*lunit,
     &    tsbl(i)*lunit,
     &    dcbl(i)*lunit,
     &    0.5*cfblinf,
     &    cdblinf,
     &    ctblinf,
     &    Mdef*lunit**2,
     &    Pdef*lunit**2,
     &    Kdef*lunit**2,
     &    Diss*lunit**2

      enddo

      return
      end ! blfwrt2




      subroutine trpwrt(lu, nsurf,ifrst,ilast, bref,
     &                  yc, zc, gc, vc, wc, vnc, ycp, zcp )
c----------------------------------------------------
c     Writes Trefftz Plane parameters
c----------------------------------------------------
      implicit real (a-h,l-z)
      integer lu, nsurf, ifrst(nsurf), ilast(nsurf)
      real yc(*), zc(*), gc(*), vc(*), wc(*), vnc(*), ycp(*), zcp(*)
      include 'constants.inc'

 1100 format(1x,a,a,a,a,a)
      write(lu,1100)
     & '#     eta        zeta       eta`       zeta`',
     & '     2Gam/bV       wn/V    '

 1200 format(1x, 4f11.5, 2f12.5 )

      do isurf = 1, nsurf
        do i = ifrst(isurf), ilast(isurf)-1
          write(lu,1200) 
     &     yc(i) *2.0/bref, 
     &     zc(i) *2.0/bref, 
     &     ycp(i)*2.0/bref,
     &     zcp(i)*2.0/bref,
     &     gc(i) *2.0  ,
     &     vnc(i)
        enddo
        write(lu,*)
      enddo

      return
      end ! trpwrt




      subroutine trpwrt2(lu, nsurf,ifrst,ilast, 
     &                  b,bo,bs, co,lambdas,lambdat,
     &                  yc, zc, gc, vc, wc, vnc, ycp, zcp )
c----------------------------------------------------
c     Writes Trefftz Plane parameters
c----------------------------------------------------
      implicit real (a-h,l-z)
      integer lu, nsurf, ifrst(nsurf), ilast(nsurf)
      real yc(*), zc(*), gc(*), vc(*), wc(*), vnc(*), ycp(*), zcp(*)
      include 'constants.inc'

 1100 format(1x,a,a,a,a,a)
      write(lu,1100)
     & '#     eta        zeta       eta`       zeta`',
     & '     2Gam/bV       wn/V    '

 1200 format(1x, 4f11.5, 2f12.5 )

      etao = bo/b
      etas = bs/b

      fac = 2.0/b
      do isurf = 1, nsurf
        do i = ifrst(isurf), ilast(isurf)-1
          eta = yc(i)*2.0/b
          if    (eta .le. etao) then
           cc = co
          elseif(eta .le. etas) then
           cc = co*(1.0 + (lambdas-1.0)*(eta-etao)/(etas-etao))
          else
           cc = co*(lambdas + (lambdat-lambdas)*(eta-etas)/(1.0-etas))
          endif
          clc = 2.0*gc(i)/cc

          write(lu,1200) 
     &     yc(i)*fac, 
     &     zc(i)*fac, 
     &     ycp(i)*fac,
     &     zcp(i)*fac,
     &     2.0*gc(i),
     &     vnc(i),
     &     cc*fac,
     &     clc
        enddo
        write(lu,*)
      enddo

      return
      end ! trpwrt2



