      implicit real(a-h,l-z)

      sweep = 0.0
      mach = 0.
      alpha = 5.0

      
      b = 2.0
      bs = 0.8
      bo = 0.3
      co = 0.3
      lambdas = 0.7
      lambdat = 0.25
      gammas = 0.9
      gammat  = 0.321

c      bs = 0.3
c      lambdas = 1.0

      a0 = 0.
      ao = 0.
      as = 0.
      am = -0.2
      a1 = -0.6

      am = 0.
      a1 = -0.2

      call spanef(sweep,b,bs,bo,co, a1,am,as,ao,a0,
     &            lambdat,lambdas,
     &            alpha,mach, AR,CL,spaneff)

      write(*,*) 'AR =', AR
      write(*,*) 'e  =', spaneff

      call spanefg(sweep,b,bs,bo,co, a1,am,as,ao,a0,
     &             lambdat,lambdas,gammat,gammas,
     &             alpha,mach, CL,spaneff)

      write(*,*) 'e  =', spaneff

      stop
      end


      subroutine spanef(sweep,
     &                  b,bs,bo,co, a1,am,as,ao,a0,
     &                  lambdat,lambdas,
     &                  alpha,mach, AR,CL,spaneff)
      implicit real(a-h,l-z)

      parameter (idim=121)
      real t(idim), tc(idim),
     &     x(idim), xc(idim),
     &     y(idim), yc(idim),
     &     z(idim), zc(idim),
     &     c(idim), cc(idim)

      real yp(idim), ycp(idim),
     &     zp(idim), zcp(idim)

      real nx(idim), ny(idim), nz(idim)
      real aa(idim,idim), res(idim)
      real gamc(idim), gamw(idim), vw(idim), ww(idim), vnw(idim)

      data pi / 3.1415926535897932384626 /

      ii = 40

      uinf = cos(alpha*pi/180.0)
      vinf = 0.
      winf = sin(alpha*pi/180.0)
 
      betm = sqrt(1.0-mach**2)


      cosL = cos(sweep*pi/180)
      tanL = tan(sweep*pi/180)

      etao = bo/b
      etas = bs/b

      t0 = 0.5*pi
      to = acos(etao)
      ts = acos(etas)
      t1 = 0.0

      y0 = 0.
      yo = 0.5*bo
      ys = 0.5*bs
      y1 = 0.5*b


      tm = 0.5*(ts+t1)
      ym = 0.5*b*cos(tm)
      etam = bm/b

c      ym = 0.5*(bs+b)/2.0
c      tm = acos(ym)
c      etam = bm/b


      lambdam = lambdas + (lambdat-lambdas)*(ym-ys)/(y1-ys)

      dz0 = tan(a0*pi/180.0) * co
      dzo = tan(ao*pi/180.0) * co
      dzs = tan(as*pi/180.0) * co*lambdas
      dzm = tan(am*pi/180.0) * co*lambdam
      dz1 = tan(a1*pi/180.0) * co*lambdat 

      io = 1 + int( float(ii)*(to-t0)/(t1-t0) + 0.5 )
      is = 1 + int( float(ii)*(ts-t0)/(t1-t0) + 0.5 )
      im = 1 + int( float(ii)*(tm-t0)/(t1-t0) + 0.5 )

c      write(*,*) y0, yo, ys, ym, y1
c      write(*,*) t0, to, ts, tm, t1
c      write(*,*) 1.0, 1.0, lambdas, lambdam, lambdat
c      write(*,*) 1, io, is, im, ii+1

      i = 1
      t(i) = t0
      y(i) = 0.
      c(i) = co
      x(i) = -0.25*co
c
      do i = 2, io
        frac = float(i-1)/float(io-1)
        t(i) = t0*(1.0-frac) + to*frac
        y(i) = y1*cos(t(i))
        c(i) = co
        x(i) = -0.25*c(i)
c
        tc(i-1) = 0.5*(t(i-1)+t(i))
        yc(i-1) = y1*cos(tc(i-1))
        fracc = (yc(i-1)-y0)/(yo-y0)
        cc(i-1) = co
        xc(i-1) = 0.25*cc(i-1)
        dz = dz0*(1.0-fracc) + dzo*fracc
        nx(i-1) = dz/cc(i-1)
        ny(i-1) = 0.
        nz(i-1) = 1.0

      enddo

      do i = io+1, is
        frac = float(i-io)/float(is-io)
        t(i) = to*(1.0-frac) + ts*frac
        y(i) = y1*cos(t(i))
        c(i) = co*(1.0 + (lambdas-1.0)*(y(i)-yo)/(ys-yo))
        x(i) = (y(i)-yo)*tanL - 0.25*c(i)
        z(i) = 0.
c
        tc(i-1) = 0.5*(t(i-1)+t(i))
        yc(i-1) = y1*cos(tc(i-1))
        fracc = (yc(i-1)-yo)/(ys-yo)
        cc(i-1) = co*(1.0 + (lambdas-1.0)*fracc)
        xc(i-1) = (yc(i-1)-yo)*tanL + 0.25*cc(i-1)
        dz = dzo*(1.0-fracc) + dzs*fracc
        nx(i-1) = dz/cc(i-1)
        ny(i-1) = 0.
        nz(i-1) = 1.0
      enddo

      do i = is+1, im
        frac = float(i-is)/float(im-is)
        t(i) = ts*(1.0-frac) + tm*frac
        y(i) = y1*cos(t(i))
        c(i) = co*(lambdas + (lambdam-lambdas)*(y(i)-ys)/(ym-ys))
        x(i) = (y(i)-yo)*tanL - 0.25*c(i)
        z(i) = 0.
c
        tc(i-1) = 0.5*(t(i-1)+t(i))
        yc(i-1) = y1*cos(tc(i-1))
        fracc = (yc(i-1)-ys)/(ym-ys)
        cc(i-1) = co*(lambdas + (lambdam-lambdas)*fracc)
        xc(i-1) = (yc(i-1)-yo)*tanL + 0.25*cc(i-1)
        dz = dzs*(1.0-fracc) + dzm*fracc
        nx(i-1) = dz/cc(i-1)
        ny(i-1) = 0.
        nz(i-1) = 1.0
      enddo

      do i = im+1, ii+1
        frac = float(i-im)/float(ii+1-im)
        t(i) = tm*(1.0-frac) + t1*frac
        y(i) = y1*cos(t(i))
        c(i) = co*(lambdam + (lambdat-lambdam)*(y(i)-ym)/(y1-ym))
        x(i) = (y(i)-yo)*tanL - 0.25*c(i)
        z(i) = 0.
c
        tc(i-1) = 0.5*(t(i-1)+t(i))
        yc(i-1) = y1*cos(tc(i-1))
        fracc = (yc(i-1)-ym)/(y1-ym)
        cc(i-1) = co*(lambdam + (lambdat-lambdam)*fracc)
        xc(i-1) = (yc(i-1)-yo)*tanL + 0.25*cc(i-1)
        dz = dzm*(1.0-fracc) + dz1*fracc
        nx(i-1) = dz/cc(i-1)
        ny(i-1) = 0.
        nz(i-1) = 1.0
      enddo



      do i = 1, ii
        do j = 1, ii
          call vorvel(xc(i),yc(i),zc(i),.true.,
     &                x(j),y(j),z(j), x(j+1),y(j+1),z(j+1), betm,
     &                u,v,w)
          udotn = u*nx(i) + v*ny(i) + w*nz(i)
          aa(i,j) = udotn

          call vorvel(xc(i),yc(i),zc(i),.true.,
     &                x(j),-y(j),z(j), x(j+1),-y(j+1),z(j+1), betm,
     &                u,v,w)
          udotn = u*nx(i) + v*ny(i) + w*nz(i)
          aa(i,j) = aa(i,j) - udotn
        enddo
        res(i) = uinf*nx(i) + vinf*ny(i) + winf*nz(i)
      enddo

      call gaussn(idim,ii,aa,res,1)

      do i = 1, ii
        gamc(i) = -res(i)
      enddo


      gamw(1) = 0.
      do i = 2, ii
        gamw(i) = gamc(i-1) - gamc(i)
      enddo
      gamw(ii+1) = gamc(ii)



      do i = io, ii
        eta  = yc(i)*2.0/b
        etap = sqrt(eta**2 - etao**2)
        ycp(i) = 0.5*b*etap
        zcp(i) = zc(i)
      enddo
      do i = io, ii+1
        eta  = y(i)*2.0/b
        etap = sqrt(eta**2 - etao**2)
        yp(i) = 0.5*b*etap
        zp(i) = z(i)
      enddo


      area = 0.
      lift = 0.
      drag = 0.
      do i = io, ii
        dy = yp(i+1) - yp(i)
        dz = zp(i+1) - zp(i)
        ds = sqrt(dy**2 + dz**2)

        vsum = 0.
        wsum = 0.
        do j = io, ii+1
          yb = ycp(i) - yp(j)
          zb = zcp(i) - zp(j)
          rsq = yb**2 + zb**2
          vsum = vsum - gamw(j)*zb/rsq
          wsum = wsum + gamw(j)*yb/rsq

          yb = ycp(i) + yp(j)
          zb = zcp(i) + zp(j)
          rsq = yb**2 + zb**2
          vsum = vsum + gamw(j)*zb/rsq
          wsum = wsum - gamw(j)*yb/rsq
        enddo
        vw(i) = vsum/(2.0*pi)
        ww(i) = wsum/(2.0*pi)
c
        vnw(i) = (dy*ww(i) - dz*vw(i))/ds
c
        area = area + 2.0 * cc(i)*dy
        lift = lift + 2.0 * gamc(i)       *dy
        drag = drag -       gamc(i)*vnw(i)*ds
      enddo


      CL  = lift / (0.5*area)
      CDi = drag / (0.5*area)

      AR = b**2 / area
      spaneff = (CL**2/(pi*AR)) / CDi

      do i = 1, ii+1
        write(7,*) y(i), gamw(i)
      enddo

      do i = 1, ii
        clp = 2.0*gamc(i)/cc(i) / cosL**2
        write(8,'(1x,8g14.6)') 
     &    yc(i), xc(i), cc(i), gamc(i), clp, vnw(i)
      enddo

      do i = io, ii
        clp = 2.0*gamc(i)/cc(i) / cosL**2
        write(9,'(1x,8g14.6)') 
     &    ycp(i), xc(i), cc(i), gamc(i), clp, vnw(i)
      enddo

      return
      end ! spanef



      subroutine spanefg(sweep,
     &                  b,bs,bo,co, a1,am,as,ao,a0,
     &                  lambdat,lambdas,gammat,gammas,
     &                  alpha,mach, CLspec, spaneff)
      implicit real(a-h,l-z)

      parameter (idim=121)
      real t(idim), tc(idim),
     &     x(idim), xc(idim),
     &     y(idim), yc(idim),
     &     z(idim), zc(idim),
     &     c(idim), cc(idim)

      real yp(idim), ycp(idim),
     &     zp(idim), zcp(idim)

      real nx(idim), ny(idim), nz(idim)
      real aa(idim,idim), res(idim)
      real gamc(idim), gamw(idim), vw(idim), ww(idim), vnw(idim)

      data pi / 3.1415926535897932384626 /

      ii = 40

      uinf = cos(alpha*pi/180.0)
      vinf = 0.
      winf = sin(alpha*pi/180.0)
 
      betm = sqrt(1.0-mach**2)


      cosL = cos(sweep*pi/180)
      tanL = tan(sweep*pi/180)

      etao = bo/b
      etas = bs/b

      t0 = 0.5*pi
      to = acos(etao)
      ts = acos(etas)
      t1 = 0.0

      y0 = 0.
      yo = 0.5*bo
      ys = 0.5*bs
      y1 = 0.5*b


      tm = 0.5*(ts+t1)
      ym = 0.5*b*cos(tm)
      etam = bm/b

c      ym = 0.5*(bs+b)/2.0
c      tm = acos(ym)
c      etam = bm/b

      lambdam = lambdas + (lambdat-lambdas)*(ym-ys)/(y1-ys)
      gammam  = gammas  + (gammat -gammas )*(ym-ys)/(y1-ys)

      ktip = 16


      dz0 = tan(a0*pi/180.0) * co
      dzo = tan(ao*pi/180.0) * co
      dzs = tan(as*pi/180.0) * co*lambdas
      dzm = tan(am*pi/180.0) * co*lambdam
      dz1 = tan(a1*pi/180.0) * co*lambdat 

      io = 1 + int( float(ii)*(to-t0)/(t1-t0) + 0.5 )
      is = 1 + int( float(ii)*(ts-t0)/(t1-t0) + 0.5 )
      im = 1 + int( float(ii)*(tm-t0)/(t1-t0) + 0.5 )

c      write(*,*) y0, yo, ys, ym, y1
c      write(*,*) t0, to, ts, tm, t1
c      write(*,*) 1.0, 1.0, lambdas, lambdam, lambdat
c      write(*,*) 1, io, is, im, ii+1

      i = 1
      t(i) = t0
      y(i) = 0.
      c(i) = co
      x(i) = -0.25*co
c
      do i = 2, io
        frac = float(i-1)/float(io-1)
        t(i) = t0*(1.0-frac) + to*frac
        y(i) = y1*cos(t(i))
        c(i) = co
        x(i) = -0.25*c(i)
c
        tc(i-1) = 0.5*(t(i-1)+t(i))
        yc(i-1) = y1*cos(tc(i-1))
        fracc = (yc(i-1)-y0)/(yo-y0)
        cc(i-1) = co
        xc(i-1) = 0.25*cc(i-1)
        dz = dz0*(1.0-fracc) + dzo*fracc
        nx(i-1) = dz/cc(i-1)
        ny(i-1) = 0.
        nz(i-1) = 1.0
        gamc(i-1) = 1.0
     &            * sqrt(1.0-cos(tc(i-1))**ktip)
      enddo

      do i = io+1, is
        frac = float(i-io)/float(is-io)
        t(i) = to*(1.0-frac) + ts*frac
        y(i) = y1*cos(t(i))
        c(i) = co*(1.0 + (lambdas-1.0)*(y(i)-yo)/(ys-yo))
        x(i) = (y(i)-yo)*tanL - 0.25*c(i)
        z(i) = 0.
c
        tc(i-1) = 0.5*(t(i-1)+t(i))
        yc(i-1) = y1*cos(tc(i-1))
        fracc = (yc(i-1)-yo)/(ys-yo)
        cc(i-1) = co*(1.0 + (lambdas-1.0)*fracc)
        xc(i-1) = (yc(i-1)-yo)*tanL + 0.25*cc(i-1)
        dz = dzo*(1.0-fracc) + dzs*fracc
        nx(i-1) = dz/cc(i-1)
        ny(i-1) = 0.
        nz(i-1) = 1.0
        gamc(i-1) = (1.0 + (gammas-1.0)*fracc)
     &            * sqrt(1.0-cos(tc(i-1))**ktip)
      enddo

      do i = is+1, im
        frac = float(i-is)/float(im-is)
        t(i) = ts*(1.0-frac) + tm*frac
        y(i) = y1*cos(t(i))
        c(i) = co*(lambdas + (lambdam-lambdas)*(y(i)-ys)/(ym-ys))
        x(i) = (y(i)-yo)*tanL - 0.25*c(i)
        z(i) = 0.
c
        tc(i-1) = 0.5*(t(i-1)+t(i))
        yc(i-1) = y1*cos(tc(i-1))
        fracc = (yc(i-1)-ys)/(ym-ys)
        cc(i-1) = co*(lambdas + (lambdam-lambdas)*fracc)
        xc(i-1) = (yc(i-1)-yo)*tanL + 0.25*cc(i-1)
        dz = dzs*(1.0-fracc) + dzm*fracc
        nx(i-1) = dz/cc(i-1)
        ny(i-1) = 0.
        nz(i-1) = 1.0
        gamc(i-1) = (gammas + (gammam-gammas)*fracc)
     &            * sqrt(1.0-cos(tc(i-1))**ktip)
      enddo

      do i = im+1, ii+1
        frac = float(i-im)/float(ii+1-im)
        t(i) = tm*(1.0-frac) + t1*frac
        y(i) = y1*cos(t(i))
        c(i) = co*(lambdam + (lambdat-lambdam)*(y(i)-ym)/(y1-ym))
        x(i) = (y(i)-yo)*tanL - 0.25*c(i)
        z(i) = 0.
c
        tc(i-1) = 0.5*(t(i-1)+t(i))
        yc(i-1) = y1*cos(tc(i-1))
        fracc = (yc(i-1)-ym)/(y1-ym)
        cc(i-1) = co*(lambdam + (lambdat-lambdam)*fracc)
        xc(i-1) = (yc(i-1)-yo)*tanL + 0.25*cc(i-1)
        dz = dzm*(1.0-fracc) + dz1*fracc
        nx(i-1) = dz/cc(i-1)
        ny(i-1) = 0.
        nz(i-1) = 1.0
        gamc(i-1) = (gammam + (gammat-gammam)*fracc)
     &            * sqrt(1.0-cos(tc(i-1))**ktip)
      enddo

      gamw(1) = 0.
      do i = 2, ii
        gamw(i) = gamc(i-1) - gamc(i)
      enddo
      gamw(ii+1) = gamc(ii)

      do i = io, ii
        eta  = yc(i)*2.0/b
        etap = sqrt(eta**2 - etao**2)
        ycp(i) = 0.5*b*etap
        zcp(i) = zc(i)
      enddo
      do i = io, ii+1
        eta  = y(i)*2.0/b
        etap = sqrt(eta**2 - etao**2)
        yp(i) = 0.5*b*etap
        zp(i) = z(i)
      enddo



      area = 0.
      lift = 0.
      drag = 0.
      do i = io, ii
        dy = yp(i+1) - yp(i)
        dz = zp(i+1) - zp(i)
        ds = sqrt(dy**2 + dz**2)

        vsum = 0.
        wsum = 0.
        do j = io, ii+1
          yb = ycp(i) - yp(j)
          zb = zcp(i) - zp(j)
          rsq = yb**2 + zb**2
          vsum = vsum - gamw(j)*zb/rsq
          wsum = wsum + gamw(j)*yb/rsq

          yb = ycp(i) + yp(j)
          zb = zcp(i) + zp(j)
          rsq = yb**2 + zb**2
          vsum = vsum + gamw(j)*zb/rsq
          wsum = wsum - gamw(j)*yb/rsq
        enddo
        vw(i) = vsum/(2.0*pi)
        ww(i) = wsum/(2.0*pi)
c
        vnw(i) = (dy*ww(i) - dz*vw(i))/ds
c
        area = area + 2.0 * cc(i)*dy
        lift = lift + 2.0 * gamc(i)       *dy
        drag = drag -       gamc(i)*vnw(i)*ds
      enddo


      CL  = lift / (0.5*area)
      CDi = drag / (0.5*area)


      fac = CLspec/CL

      do i = 1, ii
        gamc(i) = gamc(i)*fac
        gamw(i) = gamw(i)*fac
        vw(i)  = vw(i)*fac
        ww(i)  = ww(i)*fac
        vnw(i)  = vnw(i)*fac
      enddo
      CL  = CL*fac
      CDi = CDi*fac**2
      lift = lift*fac
      drag = drag*fac**2

      ar = b**2 / area
      spaneff = (CL**2/(pi*ar)) / CDi

      do i = 1, ii+1
        write(17,*) y(i), gamw(i)
      enddo

      do i = 1, ii
        clp = 2.0*gamc(i)/cc(i) / cosL**2
        write(18,'(1x,8g14.6)') 
     &    yc(i), xc(i), cc(i), gamc(i), clp, vnw(i)
      enddo

      do i = 1, ii
        clp = 2.0*gamc(i)/cc(i) / cosL**2
        write(19,'(1x,8g14.6)') 
     &    ycp(i), xc(i), cc(i), gamc(i), clp, vnw(i)
      enddo

      return
      end ! spanefg




      SUBROUTINE VORVEL(X,Y,Z,LBOUND,X1,Y1,Z1,X2,Y2,Z2,BETM,
     &                   U,V,W )
C----------------------------------------------------------
C     Same as VORVEL1, with somewhat different formulation
C----------------------------------------------------------
      LOGICAL LBOUND
C
      REAL A(3), B(3), AXB(3)
C
      DATA PI4INV  / 0.079577472 /
C
      A(1) = (X1 - X)/BETM
      A(2) =  Y1 - Y
      A(3) =  Z1 - Z
C
      B(1) = (X2 - X)/BETM
      B(2) =  Y2 - Y
      B(3) =  Z2 - Z
C
      ASQ = A(1)**2 + A(2)**2 + A(3)**2
      BSQ = B(1)**2 + B(2)**2 + B(3)**2
C
      AMAG = SQRT(ASQ)
      BMAG = SQRT(BSQ)
C
      U = 0.
      V = 0.
      W = 0.
C
C---- contribution from the transverse bound leg
      IF (LBOUND .AND.  AMAG*BMAG .NE. 0.0) THEN
        AXB(1) = A(2)*B(3) - A(3)*B(2)
        AXB(2) = A(3)*B(1) - A(1)*B(3)
        AXB(3) = A(1)*B(2) - A(2)*B(1)
C
        ADB = A(1)*B(1) + A(2)*B(2) + A(3)*B(3)
C
        DEN = AMAG*BMAG + ADB
C
        T = (1.0/AMAG + 1.0/BMAG) / DEN
C
        U = AXB(1)*T
        V = AXB(2)*T
        W = AXB(3)*T
      ENDIF
C
C---- trailing leg attached to A
      IF (AMAG .NE. 0.0) THEN
        AXISQ = A(3)**2 + A(2)**2
C
        ADI = A(1)
        RSQ = AXISQ
C
        T = - (1.0 - ADI/AMAG) / RSQ
C
        V = V + A(3)*T
        W = W - A(2)*T
      ENDIF
C
C---- trailing leg attached to B
      IF (BMAG .NE. 0.0) THEN
        BXISQ = B(3)**2 + B(2)**2
C
        BDI = B(1)
        RSQ = BXISQ
C
        T =   (1.0 - BDI/BMAG) / RSQ
C
        V = V + B(3)*T
        W = W - B(2)*T
      ENDIF
C
      U = U*PI4INV / BETM
      V = V*PI4INV 
      W = W*PI4INV 
C
      RETURN
      END ! VORVEL




      SUBROUTINE GAUSSN(NSIZ,NN,Z,R,NRHS)
C     *******************************************************
C     *                                                     *
C     *   Solves general NxN system in NN unknowns          *
C     *    with arbitrary number (NRHS) of righthand sides. *
C     *   Assumes system is invertible...                   *
C     *    ...if it isn't, a divide by zero will result.    *
C     *                                                     *
C     *   Z is the coefficient matrix...                    *
C     *     ...destroyed during solution process.           *
C     *   R is the righthand side(s)...                     *
C     *     ...replaced by the solution vector(s).          *
C     *                                                     *
C     *                              Mark Drela  1984       *
C     *******************************************************
C
      DIMENSION Z(NSIZ,NSIZ), R(NSIZ,NRHS)
C
      DO 1 NP=1, NN-1
        NP1 = NP+1
C
C------ find max pivot index NX
        NX = NP
        DO 11 N=NP1, NN
          IF(ABS(Z(N,NP))-ABS(Z(NX,NP))) 11,11,111
  111      NX = N
   11   CONTINUE
C
        PIVOT = 1.0/Z(NX,NP)
C
C------ switch pivots
        Z(NX,NP) = Z(NP,NP)
C
C------ switch rows & normalize pivot row
        DO 12 L=NP1, NN
          TEMP = Z(NX,L)*PIVOT
          Z(NX,L) = Z(NP,L)
          Z(NP,L) = TEMP
   12   CONTINUE
C
        DO 13 L=1, NRHS
          TEMP = R(NX,L)*PIVOT
          R(NX,L) = R(NP,L)
          R(NP,L) = TEMP
   13   CONTINUE
C
C------ forward eliminate everything
        DO 15 K=NP1, NN
          ZTMP = Z(K,NP)
C
C          IF(ZTMP.EQ.0.0) GO TO 15
C
          DO 151 L=NP1, NN
            Z(K,L) = Z(K,L) - ZTMP*Z(NP,L)
  151     CONTINUE
          DO 152 L=1, NRHS
            R(K,L) = R(K,L) - ZTMP*R(NP,L)
  152     CONTINUE
   15   CONTINUE
C
    1 CONTINUE
C
C---- solve for last row
      DO 2 L=1, NRHS
        R(NN,L) = R(NN,L)/Z(NN,NN)
    2 CONTINUE
C
C---- back substitute everything
      DO 3 NP=NN-1, 1, -1
        NP1 = NP+1
        DO 31 L=1, NRHS
          DO 310 K=NP1, NN
            R(NP,L) = R(NP,L) - Z(NP,K)*R(K,L)
  310     CONTINUE
   31   CONTINUE
    3 CONTINUE
C
      RETURN
      END ! GAUSS

