
      implicit real (a-h,k-z)

      parameter (idim=200)
      real s(idim),w(idim),wp(idim),wpp(idim),wppp(idim)
      real epso(idim),epsp(idim),epsm(idim),tau(idim)


      bo = 10.0
      bs = 80.0
      b  = 140.0

      cosl = 1.0

      li = 0.9
      l  = 0.15/li

      ar = 20.0
      n = 3.0
      wcen = 150000.0 * n

      zs = bo


      etao = bo/b
      etas = bs/b
      conorm = 2.0 / (2.0*etao
     &        + (1.0+li)*(etas-etao)
     &     + li*(1.0+l )*(1.0 -etas))

      co = conorm*b/ar
      po = conorm*wcen/b

      hbar = 0.10
      wbar = 0.50
      ns = 0.5*hbar*co*li

      ss = (po*b   / 4.0) * li*(1.0+    l)*(1.0-etas)
      ms = (po*b**2/24.0) * li*(1.0+2.0*l)*(1.0-etas)**2


      db = 0.5*(bs-bo)

      e = 10.0e6 * 144.0
      sigcap = 15.0e3 * 144.0
      tauweb = 10.0e3 * 144.0

      cs = co*li

      tbweb = ss/(cs**2*tauweb) * (0.5/hbar) / cosl**2
      con   = ms/(cs**3*sigcap) * (6.0*hbar/wbar) / cosl**4
      tbcap = 0.5*(hbar - (hbar**3 - con)**(1.0/3.0))
      abcap = 2.0*tbcap*wbar
      abweb = 2.0*tbweb*hbar


      write(*,*) 'tbcap', tbcap

      eiw = e * 2.0*(0.5*abcap)*(0.5*hbar)**2 * cs**4
      eaw = e * (abcap + abweb) * cs**2
      eas = eaw * 0.03
      eas = 50.0*wcen

      ii = 21
      lu = 1

      ml =  ms
      sl = -ss


      ls = sqrt(zs**2 + (0.5*b*(etas-etao))**2)
      t = (ls/zs)*(po*b/12.0)*(etas-etao)*(1.0+2.0*li) - ss*ls/zs
      p = t*0.5*b*(etas-etao)/ls
      v = t*zs/ls


      call strut1(db,zs,ns,po,ml,sl,eas,eiw,
     &            ii,s,w,wp,wpp,wppp,p,v,t)

      write(*,*) 'sigstrut =', p/(eas/e) / 144.0

      do i = 1, ii
        s(i) = s(i) + 0.5*bo
      enddo

      write(lu,*)
     & '#     y           w            M             S           wp'
c       123456789012 123456789012 123456789012 123456789012 123456789012
      do i = 1, ii
        write(lu,2100) s(i), w(i), eiw*wpp(i), -eiw*wppp(i), wp(i)
 2100   format(1x,10g13.5)
      enddo

      aa = 1.0 - (l-1.0)*etas/(1.0-etas)
      bb =       (l-1.0)/(1.0-etas)
c
      ds1 = s(ii)-s(ii-1)
      iiout = int( 0.5*(b-bs)/ds1 + 0.1 ) + ii
      ds = 0.5*(b-bs)/float(iiout-ii)
      do i = ii+1, iiout
        s(i) = s(ii) + ds*float(i-ii)
        eta = 2.0*s(i)/b
        crat = aa + bb*eta
        wpp(i) = wpp(ii) / crat
        wp(i) = wp(ii) + 0.5*b*wpp(ii)/bb
     &        * log((aa+bb*eta)/(aa+bb*etas))
        
c        write(*,*) s(i), eta, crat

        w(i) = w(ii) + wp(ii)*0.5*b*(eta-etas)
     &       + 0.5*b*wpp(ii)/bb
     &        * log(1.0/(aa+bb*etas))*0.5*b*(eta-etas)
     &       + 0.5*b*wpp(ii)/bb**2
     &        * ( (aa+bb*eta )*log(aa+bb*eta )
     &           -(aa+bb*etas)*log(aa+bb*etas) - bb*(eta-etas) )
      enddo

      do i = ii, iiout
        eta = 2.0*s(i)/b
        crat = aa + bb*eta
        mi =  ml*crat**3
        si = -sl*crat**2
        write(lu,2100) s(i), w(i), mi, si, wp(i)
      enddo

      stop
      end



      subroutine strut(l,z,ns,po,ml,sl,ea,ei,
     &                 ii,s,w,wp,wpp,wppp,p,v,t)
      implicit real (a-h,k-z)
      real s(*),w(*),wp(*),wpp(*),wppp(*)
      data eps / 1.0e-8 /

      stsq = z*z + l*l
      stlen = sqrt(stsq)
      kt = ea*z/stsq
      kp = kt*l/stlen
      kv = kt*z/stlen

      pcrit = 20.0*ei/l**2

c---- initial guess for P
      v = 0.2*po*l
      p = v * l/z
      t = sqrt(p*p + v*v)

      p = min( p , 0.5*pcrit )


      write(*,*) 'Pcrit =', pcrit

      wtol = l * eps
      ptol = p * eps
      alim = 1.0*l
      blim = 1.0*l
      plim = 1.0*po*l

      a = 0.14
      b = 0.10
      a = 0.
      b = 0.


      do iter = 1, 200
        k = sqrt(p/ei)
        k_p = 0.5*k/p
c
        skl = sin(k*l)
        ckl = cos(k*l)

        skl_p =  ckl*l*k_p
        ckl_p = -skl*l*k_p

        a11 = -p*skl + kp*(skl-k*l)*ns
        a12 = -p*ckl + kp*(ckl-1.0)*ns
        a21 = -p*ckl - kv*(skl-k*l)/k
        a22 =  p*skl - kv*(ckl-1.0)/k

        a11_p = -skl - p*skl_p + kp*(skl_p-k_p*l)*ns
        a12_p = -ckl - p*ckl_p + kp*(ckl_p      )*ns
        a21_p = -ckl - p*ckl_p - kv*(skl_p-k_p*l)/k
     &                         + kv*(skl-k*l    )/k**2 * k_p
        a22_p =  skl + p*skl_p - kv*(ckl_p      )/k
     &                         + kv*(ckl  -1.0  )/k**2 * k_p

        r1 = a11*a + a12*b + (ei+kp*0.5*l*l*ns)*po/p - ml
        r2 = a21*a + a22*b - (   kv*0.5*l*l/k )*po/p + sl/k

        a13 = a11_p*a + a12_p*b - (ei+kp*0.5*l*l*ns  )*po/p**2
        a23 = a21_p*a + a22_p*b + (   kv*0.5*l*l/k   )*po/p**2
     &                          + (   kv*0.5*l*l/k**2)*po/p * k_p
     &                          - sl/k**2 * k_p

        if(iter.eq.1) then
         r3 = 0.
         a31 = 0.
         a32 = 0.
         a33 = 1.0
        else
         wl   = a*(skl  -k*l  ) + b*(ckl  -1.0) + 0.5*l*l*po/p
         wl_a =    skl  -k*l
         wl_b =                      ckl  -1.0
         wl_p = a*(skl_p-k_p*l) + b* ckl_p      - 0.5*l*l*po/p**2
         r3 = kp*wl - p
         a31 = kp*wl_a
         a32 = kp*wl_b
         a33 = kp*wl_p - 1.0

         v = kv * wl
         t = kt * wl
        endif

        det = a11*(a22*a33 - a23*a32)
     &      + a12*(a23*a31 - a21*a33)
     &      + a13*(a21*a32 - a22*a31)
c
        d1  = r1 *(a22*a33 - a23*a32)
     &      + a12*(a23*r3  - r2 *a33)
     &      + a13*(r2 *a32 - a22*r3 )
c
        d2  = a11*(r2 *a33 - a23*r3 )
     &      + r1 *(a23*a31 - a21*a33)
     &      + a13*(a21*r3  - r2 *a31)
c
        d3  = a11*(a22*r3  - r2 *a32)
     &      + a12*(r2 *a31 - a21*r3 )
     &      + r1 *(a21*a32 - a22*a31)
c
        da = -d1/det
        db = -d2/det
        dp = -d3/det

        rlx = 1.0
c        if(rlx*da .gt. alim) rlx =  alim/da
c        if(rlx*da .lt.-alim) rlx = -alim/da
c        if(rlx*db .gt. blim) rlx =  blim/db
c        if(rlx*db .lt.-blim) rlx = -blim/db
c        if(rlx*dp .gt. plim) rlx =  plim/dp
c        if(rlx*dp .lt.-plim) rlx = -plim/dp

        if(iter.eq.1) then
         write(*,'(a,a,a,a)') 
     & ' rlx     dA           dB          dP          ',
     & '     A            B            P         ',
     & '     R            T           wp'
c       12345 12345678901 12345678901 12345678901 123
c       123456789012 123456789012 123456789012 1 
c       123456789012 123456789012 123456789
        endif
        write(*,'(1x,f6.4,3e12.4,4x,3g13.5,2x,2g13.5,2x,f10.6)')
     &           rlx,da,db,dp, a,b,p, v,t, wl
        if(abs(da) .lt. wtol .and.
     &     abs(da) .lt. wtol .and.
     &     abs(dp) .lt. ptol       ) go to 10

        a = a + rlx*da
        b = b + rlx*db
        p = p + rlx*dp

c       if(iter.eq.1) then
c        wl   = a*(skl  -k*l  ) + b*(ckl  -1.0) + 0.5*l*l*po/p
c        p = kp*wl
c       endif

c
      enddo
 10   continue

      do i = 1, ii
        frac = float(i-1)/float(ii-1)
        s(i) = l*frac
        sinks = sin(k*s(i))
        cosks = cos(k*s(i))
        w(i)    = a*(      sinks-k*s(i)) + b*(      cosks-1.0)
     &   + 0.5*s(i)**2*po/p
        wp(i)   = a*( k   *cosks-k     ) + b*(-k   *sinks    )
     &   +     s(i)   *po/p
        wpp(i)  = a*(-k**2*sinks       ) + b*(-k**2*cosks    )
     &   +             po/p
        wppp(i) = a*(-k**3*cosks       ) + b*( k**3*sinks    )
ccc     wpppp   = a*( k**4*sinks       ) + b*( k**4*cosks    )
      enddo

      wl = w(ii)
      v = kv * wl
      t = kt * wl


      return
      end


      subroutine strut1(l,z,ns,po,ml,sl,ea,ei,
     &                  ii,s,w,wp,wpp,wppp,p,v,t)
      implicit real (a-h,k-z)
      real s(*),w(*),wp(*),wpp(*),wppp(*)
      data eps / 1.0e-8 /

      stsq = z*z + l*l
      stlen = sqrt(stsq)
      kt = ea*z/stsq
      kp = kt*l/stlen
      kv = kt*z/stlen

      pcrit = 20.0*ei/l**2

c---- initial guess for P
c      v = 0.2*po*l
c      p = v * l/z
c      t = sqrt(p*p + v*v)

c      p = min( p , 0.5*pcrit )


      write(*,*) 'Pcrit =', pcrit

      wtol = l * eps
      ptol = p * eps
      alim = 1.0*l
      blim = 1.0*l

      a = 0.14
      b = 0.10
      a = 0.
      b = 0.

      do iter = 1, 200
        k = sqrt(p/ei)
c
        skl = sin(k*l)
        ckl = cos(k*l)

        a11 = -p*skl
        a12 = -p*ckl
        a21 = -p*ckl
        a22 =  p*skl

        r1 = a11*a + a12*b + p*ns - ml   + ei*po/p
        r2 = a21*a + a22*b - v/k  + sl/k

        det = a11*a22 - a12*a21
        d1  = r1 *a22 - a12*r2
        d2  = a11*r2  - r1 *a21
c
        da = -d1/det
        db = -d2/det
        dp = 0.
        
        rlx = 1.0
c        if(rlx*da .gt. alim) rlx =  alim/da
c        if(rlx*da .lt.-alim) rlx = -alim/da
c        if(rlx*db .gt. blim) rlx =  blim/db
c        if(rlx*db .lt.-blim) rlx = -blim/db
c        if(rlx*dp .gt. plim) rlx =  plim/dp
c        if(rlx*dp .lt.-plim) rlx = -plim/dp

        if(iter.eq.1) then
         write(*,'(a,a,a,a)') 
     & ' rlx     dA           dB          dP          ',
     & '     A            B            P         ',
     & '     R            T           wp'
c       12345 12345678901 12345678901 12345678901 123
c       123456789012 123456789012 123456789012 1 
c       123456789012 123456789012 123456789
        endif
        write(*,'(1x,f6.4,3e12.4,4x,3g13.5,2x,2g13.5,2x,f10.6)')
     &           rlx,da,db,dp, a,b,p, v,t, wl
        if(abs(da) .lt. wtol .and.
     &     abs(da) .lt. wtol       ) go to 10

        a = a + rlx*da
        b = b + rlx*db

c       if(iter.eq.1) then
c        wl   = a*(skl  -k*l  ) + b*(ckl  -1.0) + 0.5*l*l*po/p
c        p = kp*wl
c       endif

      enddo
 10   continue

      do i = 1, ii
        frac = float(i-1)/float(ii-1)
        s(i) = l*frac
        sinks = sin(k*s(i))
        cosks = cos(k*s(i))
        w(i)    = a*(      sinks-k*s(i)) + b*(      cosks-1.0)
     &   + 0.5*s(i)**2*po/p
        wp(i)   = a*( k   *cosks-k     ) + b*(-k   *sinks    )
     &   +     s(i)   *po/p
        wpp(i)  = a*(-k**2*sinks       ) + b*(-k**2*cosks    )
     &   +             po/p
        wppp(i) = a*(-k**3*cosks       ) + b*( k**3*sinks    )
ccc     wpppp   = a*( k**4*sinks       ) + b*( k**4*cosks    )
      enddo

      return
      end
