
      implicit real (a-h,k-z)

      parameter (idim=100)
      real s(idim),w(idim),wp(idim),wpp(idim),wppp(idim)

      l = 10.0
      z =  0.5
      ns = 0.0
      po = 75.0

      sl = po*l*0.5
      ml = sl*l*0.35
      ea = sl  * 25000.0
      ei = ml*l*  10.0

      ii = 21
      call strut(l,z,ns,po,ml,sl,ea,ei,
     &           ii,s,w,wp,wpp,wppp,t)
      do i = 1, ii
        write(*,2100) s(i), w(i), ei*wpp(i), -ei*wppp(i), wp(i)
 2100   format(1x,10g13.5)
      enddo
      i = ii
      write(*,2100) s(i), w(i), ml, sl

      ds = s(i)-s(i-1)
      write(*,2100) s(i)+ds, w(i)+wp(i)*ds+wpp(i)*0.5*ds**2,
     &               ml-sl*ds+po*0.5*ds**2, sl-po*ds

      ds = 2.0*(s(i)-s(i-1))
      write(*,2100) s(i)+ds, w(i)+wp(i)*ds+wpp(i)*0.5*ds**2,
     &               ml-sl*ds+po*0.5*ds**2, sl-po*ds

      stop
      end



      subroutine strut(l,z,ns,po,ml,sl,ea,ei,
     &                 ii,s,w,wp,wpp,wppp,t)
      implicit real (a-h,k-z)
      real s(*),w(*),wp(*),wpp(*),wppp(*)

      real aa(3,3), rr(3)

      data eps / 1.0e-6 /

      stsq = z*z + l*l
      stlen = sqrt(stsq)
      kp = ea*z*l/stlen**3
      kv = ea*z*z/stlen**3

c---- initial guess for P
      p = 0.5*po*l * l/z

      wtol = l * eps
      ptol = p * eps

      a = 0.
      b = 0.

      do iter = 1, 200
        k = sqrt(p/ei)
        k_p = 0.5*k/p
c
        skl = sin(k*l)
        ckl = cos(k*l)

        a11 = -p*skl + kp*(skl-k*l)*ns
        a12 = -p*ckl + kp*(ckl-1.0)*ns
        a21 = -p*ckl - kv*(skl-k*l)/k
        a22 =  p*skl - kv*(ckl-1.0)/k

        a11_p = -skl - p*skl_p + kp*(skl_p-k_p*l)*ns
        a12_p = -ckl - p*ckl_p + kp*(ckl_p      )*ns
        a21_p = -ckl - p*ckl_p - kv*(skl_p-k_p*l)/k
     &                         + kv*(skl-k*l    )/k**2 * k_p
        a22_p =  skl + p*skl_p - kv*(ckl_p      )/k
     &                         + kv*(ckl  -1.0  )/k**2 * k_p

        r1 = a11*a + a12*b + (ei+kp*0.5*l*l*ns)*po/p - ml
        r2 = a21*a + a22*b - (   kv*0.5*l*l/k )*po/p + sl/k

        a13 = a11_p*a + a12_p*b - (ei+kp*0.5*l*l*ns  )*po/p**2
        a23 = a21_p*a + a22_p*b + (   kv*0.5*l*l/k   )*po/p**2
     &                          + (   kv*0.5*l*l/k**2)*po/p * k_p

c        if(iter.eq.1) then
c         r3 = 0.
c         a31 = 0.
c         a32 = 0.
c         a33 = 1.0
c        else
         wl   = a*(skl  -k*l  ) + b*(ckl  -1.0) + 0.5*l*l*po/p
         wl_a =    skl  -k*l
         wl_b =                      ckl  -1.0
         wl_p = a*(skl_p-k_p*l) + b* ckl_p      - 0.5*l*l*po/p**2
         r3 = kp*wl - p
         a31 = kp*wl_a
         a32 = kp*wl_b
         a33 = kp*wl_p - 1.0
c        endif


        aa(1,1) = a11
        aa(1,2) = a12
        aa(1,3) = a13
        aa(2,1) = a21
        aa(2,2) = a22
        aa(2,3) = a23
        aa(3,1) = a31
        aa(3,2) = a32
        aa(3,3) = a33
        rr(1) = r1
        rr(2) = r2
        rr(3) = r3

        


        det = a11*(a22*a33 - a23*a32)
     &      + a12*(a23*a31 - a21*a33)
     &      + a13*(a21*a32 - a22*a31)
c
        d1  = r1 *(a22*a33 - a23*a32)
     &      + a12*(a23*r3  - r2 *a33)
     &      + a13*(r2 *a32 - a22*r3 )
c
        d2  = a11*(r2 *a33 - a23*r3 )
     &      + r1 *(a23*a31 - a21*a33)
     &      + a13*(a21*r3  - r2 *a31)
c
        d3  = a11*(a22*r3  - r2 *a32)
     &      + a12*(r2 *a31 - a21*r3 )
     &      + r1 *(a21*a32 - a22*a31)
c
        da = -d1/det
        db = -d2/det
        dp = -d3/det

c       call SOLVIT(3,3,aa,rr)
c       write(*,*) -rr(1), da
c       write(*,*) -rr(2), db
c       write(*,*) -rr(3), dp
c       pause
c

        det = a11*a22 - a12*a21
        d1  = r1 *a22 - a12*r2 
        d2  = a11*r2  - r1 *a21
        d3  = 0.

        da = -d1/det
        db = -d2/det
        dp = -d3/det


c        write(*,'(1x,i4,5e12.4)') iter, da,db,dp
c        if(abs(da) .lt. wtol .and.
c     &     abs(da) .lt. wtol .and.
c     &     abs(dp) .lt. ptol       ) go to 10

        a = a + da
        b = b + db
        p = p + dp
c


        wl = a*(skl  -k*l  ) + b*(ckl  -1.0) + 0.5*l*l*po/p
        pnew = kp*wl


cc        write(*,'(1x,i4,8e12.4)') iter, a,b,p,pnew, wl
        write(*,'(1x,3e12.4,6g13.5)') da,db,dp, a,b,p, wl
        if(abs(da) .lt. wtol .and.
     &     abs(da) .lt. wtol .and.
     &     abs(dp) .lt. ptol       ) go to 10

        p = pnew

        v = kv * wl
        t = ea*(z/stsq) * wl
      enddo
 10   continue

      write(*,*) p/ei, k**2
      pause

      do i = 1, ii
        frac = float(i-1)/float(ii-1)
        s(i) = l*frac
        sinks = sin(k*s(i))
        cosks = cos(k*s(i))
        w(i)    = a*(      sinks-k*s(i)) + b*(      cosks-1.0)
     &   + 0.5*s(i)**2*po/p
        wp(i)   = a*( k   *cosks-k     ) + b*(-k   *sinks    )
     &   +     s(i)   *po/p
        wpp(i)  = a*(-k**2*sinks       ) + b*(-k**2*cosks    )
     &   +             po/p
        wppp(i) = a*(-k**3*cosks       ) + b*( k**3*sinks    )
        wpppp   = a*( k**4*sinks       ) + b*( k**4*cosks    )

cc        write(*,*) s(i), ei*wpppp,p*wpp(i),po, ei*wpppp + p*wpp(i) - po

        write(*,*) ei*a*(k**4*sinks), p*a*(-k**2*sinks)


      enddo

      write(*,*) ei*wpp(ii) ,  ml, p*ns
      write(*,*) ei*wppp(ii), -sl, v

      return
      end




      SUBROUTINE SOLVIT(NSIZ,NN,Z,R)
C............................................
C     General pivoting Gaussian elimination
C     solver for NNxNN system
C............................................
      IMPLICIT REAL (A-H,M,O-Z)
      DIMENSION Z(NSIZ,NSIZ), R(NSIZ)
C
      DO 1 NP=1, NN-1
        NP1 = NP+1
C
C------ find max pivot index NX
        NX = NP
        DO 11 N=NP1, NN
          IF(ABS(Z(N,NP))-ABS(Z(NX,NP))) 11,11,111
  111      NX = N
   11   CONTINUE
C
        PIVOT = 1.0/Z(NX,NP)
C
C------ switch pivots
        Z(NX,NP) = Z(NP,NP)
C
C------ switch rows & normalize pivot row
        DO 12 L=NP1, NN
          TEMP = Z(NX,L)*PIVOT
          Z(NX,L) = Z(NP,L)
          Z(NP,L) = TEMP
   12   CONTINUE
C
        TEMP = R(NX)*PIVOT
        R(NX) = R(NP)
        R(NP) = TEMP
C
C------ forward eliminate everything
        DO 15 K=NP1, NN
          ZTMP = Z(K,NP)
          DO 151 L=NP1, NN
            Z(K,L) = Z(K,L) - ZTMP*Z(NP,L)
  151     CONTINUE
          R(K) = R(K) - ZTMP*R(NP)
   15   CONTINUE
C
    1 CONTINUE
C
C---- solve for last row
      R(NN) = R(NN)/Z(NN,NN)
C
C---- back substitute everything
      DO 2 NP=NN-1, 1, -1
        NP1 = NP+1
        DO 21 L=NP1, NN
          R(NP) = R(NP) - Z(NP,L)*R(L)
   21   CONTINUE
    2 CONTINUE
C
      RETURN
      END ! SOLVIT
