
      subroutine surfdx(b,bs,bo,lambdat,lambdas,sweep,
     &                  dx, macco)
c------------------------------------------------------
c     Calculates area centroid x-offset due to sweep
c     Calculates mean aerodynamic chord/co
c------------------------------------------------------
      implicit real (a-z)

      include 'time.inc'

      data pi / 3.1415926535897932384626 /

c     call tset(time0)

      tanL = tan(sweep*pi/180.0)

      etao = bo/b
      etas = bs/b

c---- 2 Int c dy /(co b)  =  S/(co b)  =  Kc
      Kc = etao
     &   + 0.5*(1.0    +lambdas)*(etas-etao)
     &   + 0.5*(lambdas+lambdat)*(1.0 -etas)

c---- 2 Int c (x-xo) dy /(co b^2) 
      Kcx = (1.0     + 2.0*lambdas)*(etas-etao)**2 / 12.0
     &    + (lambdas + 2.0*lambdat)*(1.0 -etas)**2 / 12.0
     &    + (lambdas +     lambdat)*(1.0 -etas)*(etas-etao) / 4.0

c---- 2 Int c^2 dy / (co^2 b)
      Kcc = etao
     &    + (1.0        + lambdas         + lambdas**2)*(etas-etao)/3.0
     &    + (lambdas**2 + lambdas*lambdat + lambdat**2)*(1.0 -etas)/3.0

      dx    = Kcx/Kc * b*tanL
      macco = Kcc/Kc
   
c     call tadd(time0,t_surfdx)

      return
      end ! surfdx


