
      subroutine surfm(b,bs,bo, sweep,
     &                 lambdat,lambdas,gammat,gammas,
     &                 po,
     &                 AR,N,W,Lhtail,fLo,fLt,
     &                 po)
c------------------------------------------------------------
c     Calculates wing root loading po to balance 
c     net load  N*W - Lhtail
c------------------------------------------------------------
      implicit real (a-z)

      data pi / 3.1415926535897932384626 /

      cosL = cos(sweep*pi/180.0)
      tanL = tan(sweep*pi/180.0)

      etao = bo/b
      etas = bs/b
     
c---- elam = S / (co b)
      elam = etao
     &     + 0.5*(1.0    +lambdas)*(etas-etao)
     &     + 0.5*(lambdas+lambdat)*(1.0 -etas)

      egam = etao
     &     + 0.5*(1.0    +gammas )*(etas-etao)
     &     + 0.5*(gammas +gammat )*(1.0 -etas)

      Ko = 1.0/(AR*elam)
      Kb = egam + fLo*etao + 2.0*fLt*Ko*gammat*lambdat

      po = (N*W - Lhtail)/(Kb*b)

      return
      end ! surfm

