
      subroutine tfani(gee,M0,T0,p0,Mfan,Afan, gam0,cp0,
     &                BPR,pif,pic,pid,pib,
     &                Tt4,Ttf, hfuel,
     &                epolf,epolc,epolt,
     &                TSFC,Fsp,ff,mdot,       ! outputs
     &                Tt0,pt0,cpt0,Rt0,
     &                Tt2,pt2,cpt2,Rt2,
     &                Tt3,pt3,cpt3,Rt3,
     &                    pt4,cpt4,Rt4,
     &                Tt5,pt5,cpt5,Rt5,
     &                Tt7,pt7,cpt7,Rt7,
     &                   u0,
     &                T6,u6,
     &                T8,u8 )

      implicit real (a-z)
      data pi / 3.1415926535897932384626 /

      cpc = cp0
      gamf = gam0
      gamc = gam0

      gmi0 = gam0 - 1.0
      ggmi0 = gam0/gmi0
      gmig0 = gmi0/gam0


      gam2 = cpt2/(cpt2-Rt2)
      gam3 = cpt3/(cpt3-Rt3)
      gam4 = cpt4/(cpt4-Rt4)
      gam5 = cpt5/(cpt5-Rt5)
      gam7 = cpt7/(cpt7-Rt7)


      gamf = 0.5*(gam0+gam2)
      gamc = 0.5*(gam2+gam3)
      gamt = 0.5*(gam4+gam5)


      gmif = gamf - 1.0
      ggmif = gamf/gmif
      gmigf = gmif/gamf

      gmic = gamc - 1.0
      ggmic = gamc/gmic
      gmigc = gmic/gamc

      gmit = gamt - 1.0
      ggmit = gamt/gmit
      gmigt = gmit/gamt



C fan and compressor efficiency
      etaf = (pif**gmigf - 1.0) / (pif**(gmigf/epolf) - 1.0)
      etac = (pic**gmigc - 1.0) / (pic**(gmigc/epolc) - 1.0)

C fan and compressor Tt ratios
      tauf = (pif**gmigf - 1.0)/etaf + 1.0
      tauc = (pic**gmigc - 1.0)/etac + 1.0
c
C speed of sound, freestream total Temperature
      a0 = sqrt(T0*cp0*gmi0)
      Tt0 = T0*(1.0 + 0.5*gmi0*M0**2)

C fuel flow fraction = mdot_fuel / mdot_air, and turbine gas properties
      Tt3 = tauc*Tt0
c      call gasprop(Tt3,Tt4,Ttf,
c     &             cpair,gamair, cpt,gamt, ff)

      ff = (Tt4 - Tt3) / (hfuel/cpb - (Tt4-Tt3))

C------------------
C fan quantities
C
C trat8 = 1 + 0.5 (g-1) M8**2
      trat8 = (1 + 0.5*gmi0*M0**2) * (pid*pif)**gmigf
      M8 = sqrt((trat8 - 1.0)*2.0/gmif)

      T8T0 = (1.0 + 0.5*gmi0*M0**2)*tauf/trat8
      u8u0 = M8/M0 * sqrt(T8T0)

C fan specific thrust = F_fan / mdot_core a
      F8sp = M0*BPR*(u8u0 - 1.0)
      
C-----------------
C turbine quantities
C
C turbine Tt ratio, to match compressor and fan work
      taut = 1.0 - (Tt0/Tt4)/(1.0+ff)
     &       *(      (tauc-1.0)*(cpc/cpt)
     &         + BPR*(tauf-1.0)*(cpf/cpt) )

C turbine efficiency
      etat = (pit**gmigt - 1.0) / (pit**(gmigt/epolt) - 1.0)

C turbine pressure ratio
      pit = (1.0 - (1.0-taut)/etat)**ggmit

C trat6 = 1 + 0.5 (g-1) M6**2
      trat6 = (1.0 + 0.5*gmi0*M0**2) * (pid*pic*pib*pit)**gmigt
      M6 = sqrt((trat6 - 1.0)*2.0/gmit)

      T6T0 = Tt4/T0*taut/trat6
      u6u0 = M6/M0 * sqrt(T6T0)

C core specific thrust = F_core / mdot_core a
      F6sp = M0*((1.0+ff)*u6u0 - 1.0)

C-------------------
C overall engine quantities
C
C overall specific thrust  =  F / mdot_fan a
      Fsp = (F6sp + F8sp)/(1.0+BPR)

C overall specific impulse and fuel consumption
      Isp = Fsp/ff*a0*(1.0+BPR)/gee
      TSFC = 1.0/Isp

C mass-averaged velocity (momentum/mass in mixed-out exhaust)
C u9u0 = (u6u0 + BPR*u8u0) / (1.0 + BPR)

C mass-averaged temperature (static enthalpy/mass in mixed-out exhaust)
C T9T0 = (T6T0*trat6 + BPR*T8T0*trat8) / (1.0+BPR)  -  0.5*u9u0**2 * M0**2

C rho u / rho_t 
C rufac0 = (1.0 + 0.5*gmi*M0**2)**(1.0/gmi + 0.5)
C FspM = Fsp * rufac0

      return
      end ! tfan
