
      subroutine tfweight(iengwgt,Gearf,OPR,BPR,mdotc,dfan,rSnace,
     &                    dlcomp,neng,feadd,fpylon,
     &                    Weng,Wnac,Webare,Snace1)
c==================
c inputs needed:
c   OPR, BPR, mdotc, dfan, rSnace, dlcomp, neng, feadd, fpylon
c outputs:
c   Weng
c==================
      implicit real (a-h,l-z)
      include 'constants.inc'

c- - - - - - - - - - - - - - - - - - - - - - - - - - - 
      if(iengwgt .gt. 2) then
c------ Giulia Pantalone's weight model (iengwgt = 3 or 4)
        if(abs(Gearf-1.0) .lt. 0.001) then
c------- ungeared fan
         if(iengwgt .eq. 3) then
c------- basic technology
           call ddct(mdotc/0.4535,OPR,BPR,Wcore,Wfan,Wcomb,Wnozz,Wnace)
         else
c------- advanced technology
           call ddat(mdotc/0.4535,OPR,BPR,Wcore,Wfan,Wcomb,Wnozz,Wnace)
         endif

c- - - - - - - - - - - - - - - - - - - - - - - - - - - 
        else
c------- geared fan
         if(iengwgt .eq. 3) then
c------- basic technology
           call gct(mdotc/0.4535,OPR,BPR,Wcore,Wfan,Wcomb,Wnozz,Wnace)
         else
c------- advanced technology
           call gat(mdotc/0.4535,OPR,BPR,Wcore,Wfan,Wcomb,Wnozz,Wnace)
         endif
        endif
c---- total engine weight
       Weng1 = (Wcore + Wfan + Wcomb + Wnace + Wnozz)/lb_N
       Wpylon = Weng1*fpylon
       We1 = (Wcore + Wcomb + Wfan)/lb_N
       Weng = (Weng1 + Wpylon)*neng
       Webare = We1*neng
       Wnac = neng*Wnace/lb_N 

c       write(*,*) 'Weng = ',Weng
c       write(*,*) 'Wnace = ',Wnac
c       write(*,*) 'Webare = ',Webare
c       write(*,*) 'Wpylon = ',Wpylon
c       write(*,*) 'Wnozz = ',Wnozz

      else
c----- Use Drela's or Fitzgerald's engine model
c- - - - - - - - - - - - - - - - - - - - - - - - - - - 
       if(iengwgt .eq. 0) then
c-----  Drela's original weight model
        We1 = (mdotc/45.35)
     &     *(  1684.5
     &       +   17.7*(OPR/30.0)
     &       + 1662.2*(BPR/ 5.0)**1.2 ) / lb_N

c- - - - - - - - - - - - - - - - - - - - - - - - - - - 
       else
        if(abs(Gearf-1.0) .lt. 0.001) then
c------ Nate Fitzgerald's weight model, ungeared fan
         if(iengwgt .eq. 1) then
c------- basic technology
          acon = 18.09   *BPR**2 + 476.9  *BPR + 701.3
          bcon = 0.001077*BPR**2 - 0.03716*BPR + 1.190
          ccon =                 - 0.01058*BPR + 0.3259
         else
c------- advanced technology
          acon = 15.38   *BPR**2 + 401.1  *BPR + 631.5
          bcon = 0.001057*BPR**2 - 0.03693*BPR + 1.171
          ccon =                 - 0.01022*BPR + 0.2321
         endif

c- - - - - - - - - - - - - - - - - - - - - - - - - - - 
        else
c------ Nate Fitzgerald's weight model, geared fan
         if(iengwgt .eq. 1) then
c------- basic technology
          acon = -0.6590   *BPR**2 + 292.8   *BPR + 1915.0
          bcon = 0.00006784*BPR**2 - 0.006488*BPR + 1.061
          ccon =                   - 0.001969*BPR + 0.07107
         else
c------- advanced technology
          acon = -0.6204   *BPR**2 + 237.3   *BPR + 1702.0
          bcon = 0.00005845*BPR**2 - 0.005866*BPR + 1.045
          ccon =                   - 0.001918*BPR + 0.06765
         endif
        endif

        We1 = (acon/lb_N) * (mdotc/45.35)**bcon * (OPR/40.0)**ccon 
       endif
c- - - - - - - - - - - - - - - - - - - - - - - - - - - 

c---- bare engine weight
       Webare = We1 * neng
c---- nacelle weight model from NASA CR 151970
       Snace1 = rSnace * 0.25*pi*dfan**2
       Ainlet = 0.4*Snace1
       Acowl  = 0.2*Snace1
       Aexh   = 0.4*Snace1
       Acore  = pi*dlcomp*(3.0*dlcomp)
       Wnace1 = 4.45*(Ainlet/0.3048**2) * (2.5+0.0238*dfan/0.0254)
     &        + 4.45*(Acowl /0.3048**2) *  1.9
     &        + 4.45*(Aexh  /0.3048**2) * (2.5+0.0363*dfan/0.0254)
     &        + 4.45*(Acore /0.3048**2) *  1.9
       Wnac = Wnace1 * neng
c- - - - - - - - - - - - - - - - - - - - - - - - - - - 

c---- engine accessories + fuel system
       Weadd = Webare*feadd

c---- engine pylons
       Wpylon = (Webare + Weadd + Wnac)*fpylon

c---- total engine weight
       Weng = Webare + Weadd + Wnac + Wpylon
c       write(*,*) 'Weng = ',Weng
c       write(*,*) 'Wnace = ',Wnac
c       write(*,*) 'Webare = ',Webare
c       write(*,*) 'Wpylon = ',Wpylon
c       write(*,*) 'Weadd = ',Weadd
      endif

      
      return
      end ! tfweight



      subroutine ddct(mdotc,OPR,BPR,Wcore,Wfan,Wcomb,Wnozz,Wnace)
c==========================================================
c     Calculates engine component weights for Direct-drive
c     turbofan with current technology 
c==========================================================
      implicit real (a-h,m,o-z)
c     this file provides coefficients for the LS models
      include 'dir_cur.inc'
c     this file provides data for GP model for the core weight: 
c       alfac, OPRc, BPRc, M25c, sfc, Pc
      include 'crddc.inc'
      real xstar(3),Xc(2000,3)
      real Xf(20),Xb(10),Xnc(20),Xnz(35)

      mdoti = mdotc*(1+BPR) ! inlet mass flow
      xstar(1) = OPR
      xstar(2) = BPR
      xstar(3) = mdotc

c-----------------------------------------------------------
c     Populate X vectors
      call cubprm(OPR,BPR,mdoti,Xf)
      call qdprm(OPR,BPR,mdotc,Xb)
      call qrtprm(OPR,BPR,mdotc,Xnz)
      call cubprm(OPR,BPR,mdotc,Xnc)

c-----------------------------------------------------------
c     Core weight  
      do i=1,2000
        Xc(i,1) = OPRc(i)
        Xc(i,2) = BPRc(i)
        Xc(i,3) = M25c(i)
      enddo

      call gppre(Xc,alfac,xstar,2000,3,Pc,sfc,Wcore)
c-----------------------------------------------------------
c     Fan weight - cubic f(OPR,BPR,mdoti)
      Wfan = 0
      do i=1,20
        Wfan = Wfan + Xf(i)*Afan(i)
      enddo
c-----------------------------------------------------------
c     Combustor weight - quadratic f(OPR,BPR,mdotc)
      Wcomb = 0
      do i=1,10
        Wcomb = Wcomb + Xb(i)*Acomb(i)
      enddo
c-----------------------------------------------------------
c     Nozzle weight - quartic f(OPR,BPR,mdotc)
      Wnozz = 0
      do i=1,35
        Wnozz = Wnozz + Xnz(i)*Anozz(i)
      enddo
c-----------------------------------------------------------
c     Nacelle weight - cubic f(OPR,BPR,mdotc)
      Wnace = 0
      do i=1,20
        Wnace = Wnace + Xnc(i)*Anace(i)
      enddo

      return
      end ! ddct


      subroutine ddat(mdotc,OPR,BPR,Wcore,Wfan,Wcomb,Wnozz,Wnace)
c==========================================================
c     Calculates engine component weights for Direct-drive
c     turbofan with advanced technology 
c==========================================================
      implicit real (a-h,m,o-z)
c     this file provides coefficients for the LS models
      include 'dir_adv.inc'
c     this file provides data for GP model for the core weight: 
c       alfac, OPRc, BPRc, M25c, sfc, Pc
      include 'crdda.inc'
      
      real xstar(3),Xc(2000,3)
      real Xf(20),Xb(10),Xnc(20),Xnz(35)

      mdoti = mdotc*(1+BPR) ! inlet mass flow
      xstar(1) = OPR
      xstar(2) = BPR
      xstar(3) = mdotc
c-----------------------------------------------------------
c     Populate X vectors
      call cubprm(OPR,BPR,mdoti,Xf)
      call qdprm(OPR,BPR,mdotc,Xb)
      call qrtprm(OPR,BPR,mdotc,Xnz)
      call cubprm(OPR,BPR,mdotc,Xnc)

c-----------------------------------------------------------
c     Core weight  
      do i=1,2000
        Xc(i,1) = OPRc(i)
        Xc(i,2) = BPRc(i)
        Xc(i,3) = M25c(i)
      enddo

      call gppre(Xc,alfac,xstar,2000,3,Pc,sfc,Wcore)
c-----------------------------------------------------------
c     Fan weight - cubic f(OPR,BPR,mdoti)
      Wfan = 0
      do i=1,20
        Wfan = Wfan + Xf(i)*Afan(i)
      enddo
c-----------------------------------------------------------
c     Combustor weight - quadratic f(OPR,BPR,mdotc)
      Wcomb = 0
      do i=1,10
        Wcomb = Wcomb + Xb(i)*Acomb(i)
      enddo
c-----------------------------------------------------------
c     Nozzle weight - quartic f(OPR,BPR,mdotc)
      Wnozz = 0
      do i=1,35
        Wnozz = Wnozz + Xnz(i)*Anozz(i)
      enddo
c-----------------------------------------------------------
c     Nacelle weight - cubic f(OPR,BPR,mdotc)
      Wnace = 0
      do i=1,20
        Wnace = Wnace + Xnc(i)*Anace(i)
      enddo

      return
      end ! ddat


      subroutine gct(mdotc,OPR,BPR,Wcore,Wfan,Wcomb,Wnozz,Wnace)
c==========================================================
c     Calculates engine component weights for geared
c     turbofan with current technology 
c==========================================================
      implicit real (a-h,m,o-z)
c     this file provides coefficients for the LS models
      include 'g_cur.inc'
c     these files provide data for GP model for the core and nozzlec      weights respectively: 
c       alfac, OPRc, BPRc, M25c, sfc, Pc
c       alfan, OPRn, BPRn, M25n, sfn, Pn
      include 'nzgc.inc'
      include 'crgc.inc'
      
      real xstar(3),Xc(2000,3),Xnz(2000,3)
      real Xf(20),Xb(20),Xnc(20)

      mdoti = mdotc*(1+BPR) ! inlet mass flow
      xstar(1) = OPR
      xstar(2) = BPR
      xstar(3) = mdotc
c-----------------------------------------------------------
c     Populate X vectors
      call cubprm(OPR,BPR,mdoti,Xf)
      call cubprm(OPR,BPR,mdotc,Xb)
      call cubprm(OPR,BPR,mdotc,Xnc)

c-----------------------------------------------------------
c     Core weight  
      do i=1,2000
        Xc(i,1) = OPRc(i)
        Xc(i,2) = BPRc(i)
        Xc(i,3) = M25c(i)
      enddo

      call gppre(Xc,alfac,xstar,2000,3,Pc,sfc,Wcore)
c-----------------------------------------------------------
c     Nozzle weight  
      do i=1,2000
        Xnz(i,1) = OPRn(i)
        Xnz(i,2) = BPRn(i)
        Xnz(i,3) = M25n(i)
      enddo

      call gppre(Xnz,alfan,xstar,2000,3,Pn,sfn,Wnozz)
c-----------------------------------------------------------
c     Fan weight - cubic f(OPR,BPR,mdoti)
      Wfan = 0
      do i=1,20
        Wfan = Wfan + Xf(i)*Afan(i)
      enddo
c-----------------------------------------------------------
c     Combustor weight - cubic f(OPR,BPR,mdotc)
      Wcomb = 0
      do i=1,20
        Wcomb = Wcomb + Xb(i)*Acomb(i)
      enddo
c-----------------------------------------------------------
c     Nacelle weight - cubic f(OPR,BPR,mdotc)
      Wnace = 0
      do i=1,20
        Wnace = Wnace + Xnc(i)*Anace(i)
      enddo
      
      return
      end ! gct


      subroutine gat(mdotc,OPR,BPR,Wcore,Wfan,Wcomb,Wnozz,Wnace)
c==========================================================
c     Calculates engine component weights for geared
c     turbofan with advanced technology 
c==========================================================
      implicit real (a-h,m,o-z)
c     this file provides coefficients for the LS models
      include 'g_adv.inc'
c     these files provide data for GP model for the core and nozzlec      weights respectively: 
c       alfac, OPRc, BPRc, M25c, sfc, Pc
c       alfan, OPRn, BPRn, M25n, sfn, Pn
      include 'nzga.inc'
      include 'crga.inc'
      
      real xstar(3),Xc(2000,3),Xnz(2000,3)
      real Xf(20),Xb(20),Xnc(20)
      
      mdoti = mdotc*(1+BPR) ! inlet mass flow
      xstar(1) = OPR
      xstar(2) = BPR
      xstar(3) = mdotc
c-----------------------------------------------------------
c     Populate X vectors
      call cubprm(OPR,BPR,mdoti,Xf)
      call cubprm(OPR,BPR,mdotc,Xb)
      call cubprm(OPR,BPR,mdotc,Xnc)

c-----------------------------------------------------------
c     Core weight  
      do i=1,2000
        Xc(i,1) = OPRc(i)
        Xc(i,2) = BPRc(i)
        Xc(i,3) = M25c(i)
      enddo

      call gppre(Xc,alfac,xstar,2000,3,Pc,sfc,Wcore)
c-----------------------------------------------------------
c     Nozzle weight  
      do i=1,2000
        Xnz(i,1) = OPRn(i)
        Xnz(i,2) = BPRn(i)
        Xnz(i,3) = M25n(i)
      enddo

      call gppre(Xnz,alfan,xstar,2000,3,Pn,sfn,Wnozz)
c-----------------------------------------------------------
c     Fan weight - cubic f(OPR,BPR,mdoti)
      Wfan = 0
      do i=1,20
        Wfan = Wfan + Xf(i)*Afan(i)
      enddo
c-----------------------------------------------------------
c     Combustor weight - cubic f(OPR,BPR,mdotc)
      Wcomb = 0
      do i=1,20
        Wcomb = Wcomb + Xb(i)*Acomb(i)
      enddo
c-----------------------------------------------------------
c     Nacelle weight - cubic f(OPR,BPR,mdotc)
      Wnace = 0
      do i=1,20
        Wnace = Wnace + Xnc(i)*Anace(i)
      enddo
      
      return
      end ! gat

      subroutine qdprm(x1,x2,x3,X)      
c==========================================================
c     Populates vector for quadratic fit
c==========================================================
      implicit real (a-h,m,o-z)
      real X(10)
      
      X(1) = 1
      X(2) = x1
      X(3) = x2
      X(4) = x3
      X(5) = x1**2
      X(6) = x2**2
      X(7) = x3**2
      X(8) = x1*x2
      X(9) = x2*x3
      X(10) = x1*x3

      return
      end ! qdprm

      subroutine cubprm(x1,x2,x3,X)      
c==========================================================
c     Populates vector for cubic fit
c==========================================================
      implicit real (a-h,m,o-z)
      real X(20)
      
      X(1) = 1
      X(2) = x1
      X(3) = x2
      X(4) = x3
      X(5) = x1**2
      X(6) = x2**2
      X(7) = x3**2
      X(8) = x1*x2
      X(9) = x2*x3
      X(10) = x1*x3
      X(11) = x1**3
      X(12) = x2**3
      X(13) = x3**3
      X(14) = x1**2*x2
      X(15) = x1**2*x3
      X(16) = x2**2*x1
      X(17) = x2**2*x3
      X(18) = x3**2*x1
      X(19) = x3**2*x2
      X(20) = x1*x2*x3

      return
      end ! cubprm

      subroutine qrtprm(x1,x2,x3,X)      
c==========================================================
c     Populates vector for quartic fit
c==========================================================
      implicit real (a-h,m,o-z)
      real X(35)
      
      X(1) = 1
      X(2) = x1
      X(3) = x2
      X(4) = x3
      X(5) = x1**2
      X(6) = x2**2
      X(7) = x3**2
      X(8) = x1*x2
      X(9) = x2*x3
      X(10) = x1*x3
      X(11) = x1**3
      X(12) = x2**3
      X(13) = x3**3
      X(14) = x1**2*x2
      X(15) = x1**2*x3
      X(16) = x2**2*x1
      X(17) = x2**2*x3
      X(18) = x3**2*x1
      X(19) = x3**2*x2
      X(20) = x1*x2*x3
      X(21) = x1**4
      X(22) = x2**4
      X(23) = x3**4
      X(24) = x1**3*x2
      X(25) = x1**3*x3
      X(26) = x2**3*x1
      X(27) = x2**3*x3
      X(28) = x3**3*x1
      X(29) = x3**3*x2
      X(30) = x1**2*x2**2
      X(31) = x2**2*x3**2
      X(32) = x1**2*x3**2
      X(33) = x1**2*x2*x3
      X(34) = x2**2*x1*x3
      X(35) = x3**2*x1*x2

      return
      end ! qrtprm
