
      subroutine trefftz1(nsurf, npout, npinn, npimg,
     &                   Sref, bref,
     &                   b,bs,bo,bop, zcent,
     &                   po,gammat,gammas, fLo,ktip,
     &                   Lspec,CLsurfsp,
     &                 CLsurf,CL,CD,spanef,
     &                 idim,ifrst,ilast,
     &                 yc,zc,gc,vc,wc,vnc, ycp,zcp)

      implicit real(a-h,l-z)

      integer nsurf, npout(nsurf), npinn(nsurf), npimg(nsurf)
      real b(nsurf), bs(nsurf), bo(nsurf), bop(nsurf)
      real zcent(nsurf)
      real po(nsurf)
      real gammat(nsurf), gammas(nsurf)
      integer ktip
      real CLsurfsp(nsurf), CLsurf(nsurf)
      real CL, CD
      logical Lspec

      real yc(idim), ycp(idim),
     &     zc(idim), zcp(idim)
      real gc(idim), vc(idim), wc(idim), vnc(idim)
      integer ifrst(nsurf), ilast(nsurf)


      parameter (jdim=360)
      real t(jdim), 
     &     y(jdim), yp(jdim),
     &     z(jdim), zp(jdim)
      real gw(jdim)

      common /com_lu/ ilu

      data pi / 3.1415926535897932384626 /

c---- center resolution increase factor (0..1)
c     data bunch / 0.75 /
      data bunch / 0.5 /
cc    data bunch / 0. /

      isum = 0
      do isurf = 1, nsurf
        isum = isum + npout(isurf) + npinn(isurf) + npimg(isurf) + 1
      enddo

      if(isum .gt. idim) then
       write(*,*)'TREFFTZ: Passed array overflow. Increase idim to',isum
       stop
      endif

      if(isum .gt. jdim) then
       write(*,*) 'TREFFTZ: Local array overflow. Increase jdim to',isum
       stop
      endif


      i = 0
      do 100 isurf = 1, nsurf

c---- eta at center, side-of-body, wing break, tip
      e0 = 0.0
      eo = bo(isurf)/b(isurf)
      es = bs(isurf)/b(isurf)
      e1 = 1.0

      eop = bop(isurf)/b(isurf)

      t0 = 1.0
      to = acos(eo)/(0.5*pi)
      ts = acos(es)/(0.5*pi)
      t1 = 0.0

      if(bunch .gt. 0.0) then
       to = (1.0+bunch - sqrt((1.0+bunch)**2 - 4.0*bunch*to))*0.5/bunch
       ts = (1.0+bunch - sqrt((1.0+bunch)**2 - 4.0*bunch*ts))*0.5/bunch
      endif

      y0 = 0.
      yo = 0.5*bo(isurf)
      ys = 0.5*bs(isurf)
      y1 = 0.5*b(isurf)

      yop = 0.5*bop(isurf)

      z0 = zcent(isurf)
      zo = zcent(isurf)
      zs = zcent(isurf)
      z1 = zcent(isurf)

      g0 = po(isurf)
      go = po(isurf)
      gs = po(isurf)*gammas(isurf)
      g1 = po(isurf)*gammat(isurf)


c      k0 = 1
c      ko = 1 + int( float(n(isurf))*(to-t0)/(t1-t0) + 0.5 )
c      ks = 1 + int( float(n(isurf))*(ts-t0)/(t1-t0) + 0.5 )
c      k1 = 1 + n(isurf)

      k0 = 1
      ko = 1 + npimg(isurf)
      ks = 1 + npimg(isurf) + npinn(isurf)
      k1 = 1 + npimg(isurf) + npinn(isurf) + npout(isurf)

c      write(*,*) y0, yo, ys, y1
c      write(*,*) t0, to, ts, t1
c      write(*,*) 1, ko, ks, n(isurf)+1

      i = i+1
      ifrst(isurf) = i
      t(i) = t0
      y(i) = y0
      z(i) = z0

      yp(i) = y0
      zp(i) = z0

c---- set points over fuselage
      do k = k0+1, ko
        i = i+1

        fk = float(k-k0)/float(ko-k0)
        t(i) = t0*(1.0-fk) + to*fk
        tc = 0.5*(t(i-1)+t(i))

        e  = cos(0.5*pi*(t(i) + bunch*t(i)*(1.0-t(i))))
        ec = cos(0.5*pi*(tc   + bunch*tc  *(1.0-tc  )))
        if(eo-e0 .eq. 0.0) then
         fi = 1.0
         fc = 0.5
        else
         fi = (e -e0)/(eo-e0)
         fc = (ec-e0)/(eo-e0)
        endif

        y(i) = y0*(1.0-fi) + yo*fi
        z(i) = z0*(1.0-fi) + zo*fi

        yc(i-1) =  y0*(1.0-fc) + yo*fc
        zc(i-1) =  z0*(1.0-fc) + zo*fc
        gc(i-1) = (g0*(1.0-fc) + go*fc) * sqrt(1.0-ec**ktip)

        yexp = (eo/eop)**2

        yp(i) = yop * (y(i)/yo)**yexp
        zp(i) = z(i)


        ycp(i-1) = yop * (yc(i-1)/yo)**yexp
        zcp(i-1) = zc(i-1)
      enddo

      do k = ko+1, ks
        i = i+1

        fk = float(k-ko)/float(ks-ko)
        t(i) = to*(1.0-fk) + ts*fk
        tc = 0.5*(t(i-1)+t(i))

        e  = cos(0.5*pi*(t(i) + bunch*t(i)*(1.0-t(i))))
        ec = cos(0.5*pi*(tc   + bunch*tc  *(1.0-tc  )))
        if(es-eo .eq. 0.0) then
         fi = 1.0
         fc = 0.5
        else
         fi = (e -eo)/(es-eo)
         fc = (ec-eo)/(es-eo)
        endif

        y(i) = yo*(1.0-fi) + ys*fi
        z(i) = zo*(1.0-fi) + zs*fi

        yc(i-1) =  yo*(1.0-fc) + ys*fc
        zc(i-1) =  zo*(1.0-fc) + zs*fc
        gc(i-1) = (go*(1.0-fc) + gs*fc) * sqrt(1.0-ec**ktip)

        yp(i) = sqrt(y(i)**2 - yo**2 + yop**2)
        zp(i) = z(i)

        ycp(i-1) = sqrt(yc(i-1)**2 - yo**2 + yop**2)
        zcp(i-1) = zc(i-1)
      enddo

      do k = ks+1, k1
        i = i+1

        fk = float(k-ks)/float(k1-ks)
        t(i) = ts*(1.0-fk) + t1*fk
        tc = 0.5*(t(i-1)+t(i))

        e  = cos(0.5*pi*(t(i) + bunch*t(i)*(1.0-t(i))))
        ec = cos(0.5*pi*(tc   + bunch*tc  *(1.0-tc  )))
        if(e1-es .eq. 0.0) then
         fi = 1.0
         fc = 0.5
        else
         fi = (e -es)/(e1-es)
         fc = (ec-es)/(e1-es)
        endif
        y(i) = ys*(1.0-fi) + y1*fi
        z(i) = zs*(1.0-fi) + z1*fi

        yc(i-1) =  ys*(1.0-fc) + y1*fc
        zc(i-1) =  zs*(1.0-fc) + z1*fc
        gc(i-1) = (gs*(1.0-fc) + g1*fc) * sqrt(1.0-ec**ktip)

        yp(i) = sqrt(y(i)**2 - yo**2 + yop**2)
        zp(i) = z(i)

        ycp(i-1) = sqrt(yc(i-1)**2 - yo**2 + yop**2)
        zcp(i-1) = zc(i-1)
      enddo
      ilast(isurf) = i

c---- dummy control point between surfaces
      yc(i) = 0.
      zc(i) = 0.
      gc(i) = 0.

 100  continue

      ii = ilast(nsurf)

      do isurf = 1, nsurf
        i = ifrst(isurf)
        gw(i) = 0.
        do i = ifrst(isurf)+1, ilast(isurf)-1
          gw(i) = gc(i-1) - gc(i)
        enddo
        i = ilast(isurf)
        gw(i) = gc(i-1)
      enddo


      if(Lspec) then
c----- scale circulations to get specified lift for each surface
       do isurf = 1, nsurf
         cltest = 0.
         do i = ifrst(isurf), ilast(isurf)-1
           dy = yp(i+1) - yp(i)
           cltest = cltest + 2.0*gc(i)*dy * bref/(0.5*Sref)
         enddo

         gfac = CLsurfsp(isurf)/cltest
cc         write(*,*) isurf, gfac

         do i = ifrst(isurf), ilast(isurf)
           gc(i) = gc(i)*gfac
           gw(i) = gw(i)*gfac
         enddo
       enddo
      endif
      

      CL = 0.
      CD = 0.
      do 400 isurf = 1, nsurf

      CLsurf(isurf) = 0.

      do i = ifrst(isurf), ilast(isurf)-1
        dy = yp(i+1) - yp(i)
        dz = zp(i+1) - zp(i)
        ds = sqrt(dy**2 + dz**2)

        vsum = 0.
        wsum = 0.
        do j = 1, ii
c-------- velocities of wake vortex, at control point
          yb = ycp(i) - yp(j)
          zb = zcp(i) - zp(j)
          rsq = yb**2 + zb**2
          vsum = vsum - gw(j) * zb/rsq
          wsum = wsum + gw(j) * yb/rsq

c-------- velocities of wake vortex image, at control point
          yb = ycp(i) + yp(j)
          zb = zcp(i) - zp(j)
          rsq = yb**2 + zb**2
          vsum = vsum + gw(j) * zb/rsq
          wsum = wsum - gw(j) * yb/rsq
        enddo
        vc(i) = vsum*bref/(2.0*pi)
        wc(i) = wsum*bref/(2.0*pi)

        vnc(i) = (dy*wc(i) - dz*vc(i))/ds

        dCL = 2.0*gc(i)       *dy * bref/(0.5*Sref)
        dCD =    -gc(i)*vnc(i)*ds * bref/(0.5*Sref)

        CL = CL + dCL
        CD = CD + dCD

        CLsurf(isurf) = CLsurf(isurf) + dCL
      enddo

 400  continue

      AR = bref**2/Sref
      CDell = CL**2 / (pi*AR)

      spanef = CDell / CD

      return
      end ! trefftz1



      subroutine trefftz(nsurf, n, Sref, bref, Minf,
     &                   b,bs,bo,bop, zcent,
     &                   fduo,fdus,fdu1,
     &                   poload,gammat,gammas, fLo,ktip,
     &                   Lspec,CLsurfsp,
     &                 CLsurf,CL,CD,spanef,
     &                 idim,ifrst,ilast,
     &                 yc,zc,gc,vc,wc,vnc, ycp,zcp)

      implicit real(a-h,l-z)

      integer nsurf, n(nsurf), ktip
      real b(nsurf), bs(nsurf), bo(nsurf), bop(nsurf)
      real zcent(nsurf)
      real poload(nsurf)
      real gammat(nsurf), gammas(nsurf)
      real CLsurfsp(nsurf), CLsurf(nsurf)
      real CL, CD
      logical Lspec

      real yc(idim), ycp(idim),
     &     zc(idim), zcp(idim)
      real uc(idim)
      real gc(idim), vc(idim), wc(idim), vnc(idim)
      integer ifrst(nsurf), ilast(nsurf)


      parameter (jdim=500)
      real tg(jdim)
      real t(jdim), tp(jdim), sp(jdim),
     &     r(jdim), rp(jdim),
     &     y(jdim), yp(jdim),
     &     z(jdim), zp(jdim),
     &     u(jdim),
     &     m(jdim),
     &     g(jdim)
      real gw(jdim)

      data pi / 3.1415926535897932384626 /

c---- center resolution increase factor (0..1)
c     data bunch / 0.75 /
      data bunch / 0.75 /
c     data bunch / 0. /

      isum = 0
      do isurf = 1, nsurf
        isum = isum + n(isurf)+1
      enddo

      if(isum .gt. idim) then
       write(*,*)'TREFFTZ: Passed array overflow. Increase idim to',isum
       stop
      endif

      if(isum .gt. jdim) then
       write(*,*) 'TREFFTZ: Local array overflow. Increase jdim to',isum
       stop
      endif

      i = 0
      do 100 isurf = 1, nsurf

      e0 = 0.0
      eo = bo(isurf)/b(isurf)
      es = bs(isurf)/b(isurf)
      e1 = 1.0

      eop = bop(isurf)/b(isurf)

      t0 = 1.0
      to = acos(eo)/(0.5*pi)
      ts = acos(es)/(0.5*pi)
      t1 = 0.0

      if(bunch .gt. 0.0) then
       to = (1.0+bunch - sqrt((1.0+bunch)**2-4.0*bunch*to))*0.5/bunch
       ts = (1.0+bunch - sqrt((1.0+bunch)**2-4.0*bunch*ts))*0.5/bunch
      endif

      yo = 0.5*bo(isurf)
      ys = 0.5*bs(isurf)
      y1 = 0.5*b(isurf)

      zo = zcent(isurf)
      zs = zcent(isurf)
      z1 = zcent(isurf)

      yop = 0.5*bop(1) * yo/sqrt(yo**2 + zo**2)
      zop = 0.5*bop(1) * zo/sqrt(yo**2 + zo**2)

      po = poload(isurf)
      ps = poload(isurf)*gammas(isurf)
      p1 = poload(isurf)*gammat(isurf)

      if(isurf.eq.1) then
       uo = 1.0 + fduo
       us = 1.0 + fdus
       u1 = 1.0 + fdu1
       mo = 1.0 + fduo*(1.0-Minf**2)
       ms = 1.0 + fdus*(1.0-Minf**2)
       m1 = 1.0 + fdu1*(1.0-Minf**2)
      else
       uo = 1.0
       us = 1.0
       u1 = 1.0
       mo = 1.0
       ms = 1.0
       m1 = 1.0
      endif

      ko = 1
      ks = 1 + int( float(n(isurf))*(ts-to)/(t1-to) + 0.5 )
      k1 = 1 + n(isurf)

c      write(*,*) yo, ys, y1
c      write(*,*) to, ts, t1
c      write(*,*) ko, ks, n(isurf)+1

      i = i+1
      ifrst(isurf) = i
      tg(i) = to

      y(i) = yo
      z(i) = zo
      r(i) = sqrt(y(i)**2 + z(i)**2)
      t(i) = atan2(z(i),y(i))
      u(i) = uo
      m(i) = mo

      if(isurf.eq.1) then
       yp(i) = yop
       zp(i) = zop
       rp(i) = sqrt(yp(i)**2 + zp(i)**2)
       tp(i) = atan2(zp(i),yp(i))
      else
       yp(i) = y(i)
       zp(i) = z(i)
      endif

      do k = ko+1, k1
        i = i+1
        if(k.le.ks) then
c------- inner panel
         fk = float(k-ko)/float(ks-ko)
         tg(i) = to*(1.0-fk) + ts*fk
         e = cos(0.5*pi*(tg(i) + bunch*tg(i)*(1.0-tg(i))))
         fi = (e-eo)/(es-eo)
         y(i) = yo*(1.0-fi) + ys*fi
         z(i) = zo*(1.0-fi) + zs*fi
         u(i) = uo*(1.0-fi) + us*fi
         m(i) = mo*(1.0-fi) + ms*fi
         g(i) =(po*(1.0-fi) + ps*fi) * sqrt(1.0-e**ktip) / m(i)
        else
c------- outer panel
         fk = float(k-ks)/float(k1-ks)
         tg(i) = ts*(1.0-fk) + t1*fk
         e = cos(0.5*pi*(tg(i) + bunch*tg(i)*(1.0-tg(i))))
         fi = (e-es)/(e1-es)
         y(i) = ys*(1.0-fi) + y1*fi
         z(i) = zs*(1.0-fi) + z1*fi
         u(i) = us*(1.0-fi) + u1*fi
         m(i) = ms*(1.0-fi) + m1*fi
         g(i) =(ps*(1.0-fi) + p1*fi) * sqrt(1.0-e**ktip) / m(i)
        endif

        r(i) = sqrt(y(i)**2 + z(i)**2)
        t(i) = atan2(z(i),y(i))

        if(isurf.eq.1) then
         mavg = 0.5*(m(i)+m(i-1))
         rpsq = rp(i-1)**2 + (r(i)**2 - r(i-1)**2)*mavg
         rp(i) = sqrt(rpsq)
         tp(i) = t(i)
         yp(i) = rp(i) * cos(tp(i))
         zp(i) = rp(i) * sin(tp(i))
        else
         yp(i) = y(i)
         zp(i) = z(i)
        endif
      enddo
      ilast(isurf) = i

      i = ifrst(isurf)
      sp(i) = 0.
      do i = ifrst(isurf), ilast(isurf)-1
        sp(i+1) = sp(i) + sqrt((yp(i+1)-yp(i))**2 + (zp(i+1)-zp(i))**2)
      enddo
      spn = sp(ilast(isurf))

      do k = ko, k1-1
        i = k-ko + ifrst(isurf)

        tc = 0.5*(tg(i)+tg(i+1))
        ec = cos(0.5*pi*(tc + bunch*tc*(1.0-tc)))

        mavg = 0.5*(m(i)+m(i+1))

        if(k.lt.ks) then
         fc = (ec-eo)/(es-eo)
         gc(i) = (po*(1.0-fc) + ps*fc) * sqrt(1.0-ec**ktip) / mavg
        else
         fc = (ec-es)/(e1-es)
         gc(i) = (ps*(1.0-fc) + p1*fc) * sqrt(1.0-ec**ktip) / mavg
        endif

        epi = acos(sp(i)  /spn)
        epp = acos(sp(i+1)/spn)
        ec = 0.5*(epi+epp)
        sc = spn*cos(ec)
        fc = (sc-sp(i))/(sp(i+1)-sp(i))
        ycp(i) = yp(i)*(1.0-fc) + yp(i+1)*fc
        zcp(i) = zp(i)*(1.0-fc) + zp(i+1)*fc
      enddo

c---- dummy control point between surfaces
      yc(i) = 0.
      zc(i) = 0.
      gc(i) = 0.

 100  continue

      ii = ilast(nsurf)

      do isurf = 1, nsurf
        i = ifrst(isurf)
        gw(i) = 0.
        do i = ifrst(isurf)+1, ilast(isurf)-1
          gw(i) = gc(i-1) - gc(i)
        enddo
        i = ilast(isurf)
        gw(i) = gc(i-1)
      enddo


c 99   format(1x,89g13.5)
c      do isurf = 1, nsurf
c      do i = ifrst(isurf), ilast(isurf)
c        write(1,99) y(i), z(i), yp(i), zp(i), 
c     &        rp(i), tp(i), sp(i), m(i), g(i)
c      enddo
c      do i = ifrst(isurf), ilast(isurf)-1
c        write(2,99) ycp(i), zcp(i), gc(i)
c      enddo
c      if(isurf.lt.nsurf) then
c       write(1,'(a)')
c       write(1,'(a)')
c       write(2,'(a)')
c       write(2,'(a)')
c      endif
c      enddo

      if(Lspec) then
       do isurf = 1, nsurf
         cltest = 0.
         do i = ifrst(isurf), ilast(isurf)-1
           dy = yp(i+1) - yp(i)
           cltest = cltest + 2.0*gc(i)*dy * bref/(0.5*Sref)
         enddo

         fac = CLsurfsp(isurf)/cltest

c         write(*,*) isurf, fac
         do i = ifrst(isurf), ilast(isurf)
           gc(i) = gc(i)*fac
           gw(i) = gw(i)*fac
         enddo

       enddo
      endif
      


      CL = 0.
      CD = 0.
      do 400 isurf = 1, nsurf

      CLsurf(isurf) = 0.

      do i = ifrst(isurf), ilast(isurf)-1
        dy = yp(i+1) - yp(i)
        dz = zp(i+1) - zp(i)
        ds = sqrt(dy**2 + dz**2)

        vsum = 0.
        wsum = 0.
        do j = 1, ii
          yb = ycp(i) - yp(j)
          zb = zcp(i) - zp(j)
          rsq = yb**2 + zb**2
          vsum = vsum - gw(j)*bref * zb/rsq
          wsum = wsum + gw(j)*bref * yb/rsq

          yb = ycp(i) + yp(j)
          zb = zcp(i) - zp(j)
          rsq = yb**2 + zb**2
          vsum = vsum + gw(j)*bref * zb/rsq
          wsum = wsum - gw(j)*bref * yb/rsq
        enddo
        vc(i) = vsum/(2.0*pi)
        wc(i) = wsum/(2.0*pi)
c
        vnc(i) = (dy*wc(i) - dz*vc(i))/ds
c
        dCL = 2.0*gc(i)       *dy * bref/(0.5*Sref)
        dCD =    -gc(i)*vnc(i)*ds * bref/(0.5*Sref)

        CL = CL + dCL
        CD = CD + dCD

        CLsurf(isurf) = CLsurf(isurf) + dCL
      enddo

 400  continue

      AR = bref**2/Sref
      CDell = CL**2 / (pi*AR)

      spanef = CDell / CD

c      do isurf = 1, nsurf
c        do i = ifrst(isurf), ilast(isurf)
c          write(7,*) y(i), z(i), yp(i), zp(i), gw(i)
c        enddo
c        write(7,*)
c      enddo

      return
      end ! trefftz
