
      
      subroutine cla(bw,bow,sweepw,xw,zw,ARw,
     &               bh,boh,sweeph,xh,zh,ARh,
     &               Mach, CLaw, CLah )
      implicit real (a-h,l-z)
      logical lbound

      data pi / 3.1415926535897932384626 /


      tanLw = tan(sweepw*pi/180.0)
      tanLh = tan(sweeph*pi/180.0)

      bsq = 1.0 - Mach**2
      beta = sqrt(bsq)

      CLaw  = 2.0*pi / ( sqrt(bsq + tanLw**2) + 2.0/ARw )
      CLah0 = 2.0*pi / ( sqrt(bsq + tanLh**2) + 2.0/ARh )

      cw = bw/ARw


      lbound = .true.


      x = xh
      y = 0.
      z = zh

      x1 = xw
      y1 = 0.
      z1 = zw

      x2 = xw + 0.5*(bw-bow) * tanLw
      y2 =      0.5*(bw-bow)
      z2 = zw

      call VORVEL(x,y,z,lbound,x1,y1,z1,x2,y2,z2,beta,
     &            u,v,w )

      uvor = 2.0*u
      vvor = 0.
      wvor = 2.0*w

      uh_a = 0.5*cw*uvor*CLaw
      ah_a = 0.5*cw*wvor*CLaw

      CLah = CLah0 * (1.0 + ah_a + 2.0*uh_a)

      return
      end ! clhsen



      subroutine clhsen1(b ,bs ,bo ,co ,cs ,ct ,sweepw,dihedw,Xaxw,
     &                  bh,bsh,boh,coh,csh,cth,sweeph,dihedh,Xaxh)
      

      implicit real (a-h,l-z)

      parameter (idim = 8)
      real xv(idim),
     &     yv(idim),
     &     zv(idim),
     &     tv(idim),
     &     cv(idim)
      real xc(idim),
     &     yc(idim),
     &     zc(idim),
     &     tc(idim),
     &     cc(idim)
      real ncx(idim),
     &     ncy(idim),
     &     ncz(idim)
      integer ivc1(idim), 
     &        ivc2(idim)
      real asys(idim,idim), rsys(idim,3)

      integer nw, nh

      integer nv, nc
      logical lbound


      data pi / 3.1415926535897932384626 /
      data qopi / 0.0795774715459476678844 /


      nw = 7
      nh = 3

      tanLw = tan(sweepw*pi/180.0)
      tanLh = tan(sweeph*pi/180.0)
      tanDw = tan(dihedw*pi/180.0)
      tanDh = tan(dihedh*pi/180.0)

      PGlam = sqrt(1.0-Mach**2)


      yo = 0.5*bo
      ys = 0.5*bs
      yt = 0.5*b

      yoh = 0.5*boh
      ysh = 0.5*bsh
      yth = 0.5*bh

      iv = 1
      ic = 1
      call surfvl(nw,xwbox,zwbox,yo,ys,yt,co,cs,ct,
     &            Xax,tanLw,tanDw,
     &            tv(iv),xv(iv),yv(iv),zv(iv),cv(iv),
     &            tc(ic),xc(ic),yc(ic),zc(ic),cc(ic),
     &            ncx(ic),ncy(ic),ncz(ic),
     &            ivc1(ic),ivc2(ic))

      iv = iv + nw
      ic = ic + nw - 1
      call surfvl(nh,xhbox,zhbox,yoh,ysh,yth,coh,csh,cth,
     &            Xaxh,tanLh,tanDh,
     &            tv(iv),xv(iv),yv(iv),zv(iv),cv(iv),
     &            tc(ic),xc(ic),yc(ic),zc(ic),cc(ic),
     &            ncx(ic),ncy(ic),ncz(ic),
     &            ivc1(ic),ivc2(ic))

      nv = iv + nh - 1
      nc = ic + nh - 2

      do ic = 1, nc
        rsys(ic,1) = -ncx(ic)
        rsys(ic,2) = -ncy(ic)
        rsys(ic,3) = -ncz(ic)
        do jc = 1, nc
          asys(ic,jc) = 0.
        enddo
      enddo

      lbound = .true.
      do jc = 1, nc
        do ic = 1, nc
          iv1 = ivc1(ic)
          iv2 = ivc2(ic)
          call VORVEL(xc(ic),yc(ic),zc(ic),lbound,
     &                xv(iv1),yv(iv1),zv(iv1),
     &                xv(iv2),yv(iv2),zv(iv2),
     &                PGlam,
     &                u,v,w )
          vdotn = u*ncx(ic)
     &          + v*ncy(ic)
     &          + w*ncz(ic)
          asys(ic,jc) = asys(ic,jc) + vdotn
        enddo
      enddo

      call gaussn(idim,nc,asys,rsys,3)

c@@@@@@@@@@@@@@@@@@@@@@@      

      return
      end ! clhsen1




      subroutine surfvl(n, x0,z0, yo,ys,yt, co,cs,ct, Xax, tanL,tanD,
     &            tv,xv,yv,zv,cv,
     &            tc,xc,yc,zc,cc,
     &            ncx,ncy,ncz, ivc1,ivc2)
      integer n

      real tv(*),xv(*),yv(*),zv(*),cv(*),
     &     tc(*),xc(*),yc(*),zc(*),cc(*)
      real ncx(*),ncy(*),ncz(*)
      integer ivc1(*), ivc2(*)

      data pi / 3.1415926535897932384626 /


      iv = 0
      ic = 0

      do 10 k = 0, nw
        frac = float(k)/float(nw)

        iv = iv + 1
        tv(iv) = 0.5*pi*(1.0-frac)
        yv(iv) = yt*cos(tv(iv))

        if    (yv(iv) .lt. yo) then
         cv(iv) = co
         xv(iv) = x0 + cv(iv)*(0.25-Xax)
         zv(iv) = z0
        elseif(yv(iv) .lt. ys) then
         cv(iv) = co + (cs-co)*(yv(iv)-yo)/(ys-yo)
         xv(iv) = x0 + tanL*(yv(iv)-yo) + cv(iv)*(0.25-Xax)
         zv(iv) = z0 + tanD*(yv(iv)-yo)
        else
         cv(iv) = cs + (ct-cs)*(yv(iv)-ys)/(yt-ys)
         xv(iv) = x0 + tanL*(yv(iv)-yo) + cv(iv)*(0.25-Xax)
         zv(iv) = z0 + tanD*(yv(iv)-yo)
        endif

        if(k .gt. 0) then
         ic = ic + 1
         iv1 = iv-1
         iv2 = iv
    
         ivc1(ic) = iv1
         ivc2(ic) = iv2
    
         dyv = yv(iv2) - yv(iv1)
         dzv = zv(iv2) - zv(iv1)
    
         tc(ic) = 0.5*(tv(iv1)+tv(iv2))
         yc(ic) = yt*cos(tc(ic))
    
         frac = (yc(ic)-yv(iv1))/dyv
         cc(ic) = cv(iv1)*(1.0-frac) + cv(iv2)*frac
         xc(ic) = xv(iv1)*(1.0-frac) + xv(iv2)*frac + 0.5*cc(ic)
         zc(ic) = zv(iv1)*(1.0-frac) + zv(iv2)*frac
    
         ncx(ic) = 0.
         ncy(ic) = -dzv/sqrt(dyv**2 + dzv**2)
         ncz(ic) =  dyv/sqrt(dyv**2 + dzv**2)
        endif
 10   continue

      return
      end ! surfvl





      SUBROUTINE VORVEL(X,Y,Z,LBOUND,X1,Y1,Z1,X2,Y2,Z2,BETA,
     &                   U,V,W )
C----------------------------------------------------------
C     Same as VORVEL1, with somewhat different formulation
C----------------------------------------------------------
      LOGICAL LBOUND
C
      REAL A(3), B(3), AXB(3)
C
      DATA PI4INV  / 0.0795774715459476678844 /
C
      A(1) = (X1 - X)/BETA
      A(2) =  Y1 - Y
      A(3) =  Z1 - Z
C
      B(1) = (X2 - X)/BETA
      B(2) =  Y2 - Y
      B(3) =  Z2 - Z
C
      ASQ = A(1)**2 + A(2)**2 + A(3)**2
      BSQ = B(1)**2 + B(2)**2 + B(3)**2
C
      AMAG = SQRT(ASQ)
      BMAG = SQRT(BSQ)
C
      U = 0.
      V = 0.
      W = 0.
C
C---- contribution from the transverse bound leg
      IF (LBOUND .AND.  AMAG*BMAG .NE. 0.0) THEN
        AXB(1) = A(2)*B(3) - A(3)*B(2)
        AXB(2) = A(3)*B(1) - A(1)*B(3)
        AXB(3) = A(1)*B(2) - A(2)*B(1)
C
        ADB = A(1)*B(1) + A(2)*B(2) + A(3)*B(3)
C
        DEN = AMAG*BMAG + ADB
C
        T = (1.0/AMAG + 1.0/BMAG) / DEN
C
        U = AXB(1)*T
        V = AXB(2)*T
        W = AXB(3)*T
      ENDIF
C
C---- trailing leg attached to A
      IF (AMAG .NE. 0.0) THEN
        AXISQ = A(3)**2 + A(2)**2
C
        ADI = A(1)
        RSQ = AXISQ
C
        T = - (1.0 - ADI/AMAG) / RSQ
C
        V = V + A(3)*T
        W = W - A(2)*T
      ENDIF
C
C---- trailing leg attached to B
      IF (BMAG .NE. 0.0) THEN
        BXISQ = B(3)**2 + B(2)**2
C
        BDI = B(1)
        RSQ = BXISQ
C
        T =   (1.0 - BDI/BMAG) / RSQ
C
        V = V + B(3)*T
        W = W - B(2)*T
      ENDIF
C
      U = U*PI4INV / BETA
      V = V*PI4INV 
      W = W*PI4INV 
C
      RETURN
      END ! VORVEL



      SUBROUTINE VORVELC(X,Y,Z,LBOUND,X1,Y1,Z1,X2,Y2,Z2,BETA,
     &                   U,V,W, RCORE)
C----------------------------------------------------------
C     Same as VORVEL, with finite core radius
C----------------------------------------------------------
      LOGICAL LBOUND
C
      REAL A(3), B(3), AXB(3)
C
      DATA PI4INV  / 0.0795774715459476678844 /
C
      A(1) = (X1 - X)/BETA
      A(2) =  Y1 - Y
      A(3) =  Z1 - Z
C
      B(1) = (X2 - X)/BETA
      B(2) =  Y2 - Y
      B(3) =  Z2 - Z
C
      ASQ = A(1)**2 + A(2)**2 + A(3)**2
      BSQ = B(1)**2 + B(2)**2 + B(3)**2
C
      AMAG = SQRT(ASQ)
      BMAG = SQRT(BSQ)
C
      U = 0.
      V = 0.
      W = 0.
C
C---- contribution from the transverse bound leg
      IF (LBOUND  .AND.  AMAG*BMAG .NE. 0.0) THEN
        AXB(1) = A(2)*B(3) - A(3)*B(2)
        AXB(2) = A(3)*B(1) - A(1)*B(3)
        AXB(3) = A(1)*B(2) - A(2)*B(1)
        AXBSQ = AXB(1)**2 + AXB(2)**2 + AXB(3)**2
C
        ADB = A(1)*B(1) + A(2)*B(2) + A(3)*B(3)
        ALSQ = ASQ + BSQ - 2.0*ADB
C
ccc     RSQ = AXBSQ / ALSQ
C
        AB = AMAG*BMAG
c        T = (AMAG+BMAG)*(1.0 - ADB/AB) / (AXBSQ + ALSQ*RCORE**2)
        T = (  (BSQ-ADB)/SQRT(BSQ+RCORE**2)
     &       + (ASQ-ADB)/SQRT(ASQ+RCORE**2) ) / (AXBSQ + ALSQ*RCORE**2)
C
        U = AXB(1)*T
        V = AXB(2)*T
        W = AXB(3)*T
      ENDIF
C
C---- trailing leg attached to A
      IF (AMAG .NE. 0.0) THEN
        AXISQ = A(3)**2 + A(2)**2
C
        ADI = A(1)
        RSQ = AXISQ
C
        T = - (1.0 - ADI/AMAG) / (RSQ + RCORE**2)
C
        V = V + A(3)*T
        W = W - A(2)*T
      ENDIF
C
C---- trailing leg attached to B
      IF (BMAG .NE. 0.0) THEN
        BXISQ = B(3)**2 + B(2)**2
C
        BDI = B(1)
        RSQ = BXISQ
C
        T =   (1.0 - BDI/BMAG) / (RSQ + RCORE**2)
C
        V = V + B(3)*T
        W = W - B(2)*T
      ENDIF
C
      U = U*PI4INV / BETA
      V = V*PI4INV 
      W = W*PI4INV 
C
      RETURN
      END ! VORVELC
