     
      subroutine cla(bw,bow,sweepw,xw,zw,ARw,
     &               bh,boh,sweeph,xh,zh,ARh,
     &               Mach, CLaw, CLah )
      implicit real (a-h,l-z)
      logical lbound

      data pi / 3.1415926535897932384626 /

c      write(*,*) bw,bow,sweepw,xw,zw,ARw,
c     &               bh,boh,sweeph,xh,zh,ARh,
c     &               Mach


      tanLw = tan(sweepw*pi/180.0)
      tanLh = tan(sweeph*pi/180.0)

      bsq = 1.0 - Mach**2
      beta = sqrt(bsq)

      CLaw  = 2.0*pi / ( sqrt(bsq + tanLw**2) + 2.0/ARw )
      CLah0 = 2.0*pi / ( sqrt(bsq + tanLh**2) + 2.0/ARh )

      cw = bw/ARw


      lbound = .true.


      x = xh
      y = 0.
      z = zh

      y1 = 0.
      x1 = xw
      z1 = zw

      y2 = 0.5*(bw-bow) * 0.7
      x2 = xw + y2 * tanLw
      z2 = zw

      call VORVEL(x,y,z,lbound,x1,y1,z1,x2,y2,z2,beta,
     &            u,v,w )

      uvor = 2.0*u
      vvor = 0.
      wvor = 2.0*w

      uh_a = 0.5*cw*uvor*CLaw
      ah_a = 0.5*cw*wvor*CLaw

      write(*,*) ah_a, 2.0*uh_a

      CLah = CLah0 * (1.0 + ah_a)

      return
      end ! cla



      SUBROUTINE VORVEL(X,Y,Z,LBOUND,X1,Y1,Z1,X2,Y2,Z2,BETA,
     &                   U,V,W )
C----------------------------------------------------------
C     Same as VORVEL1, with somewhat different formulation
C----------------------------------------------------------
      LOGICAL LBOUND
C
      REAL A(3), B(3), AXB(3)
C
      DATA PI4INV  / 0.0795774715459476678844 /
C
      A(1) = (X1 - X)/BETA
      A(2) =  Y1 - Y
      A(3) =  Z1 - Z
C
      B(1) = (X2 - X)/BETA
      B(2) =  Y2 - Y
      B(3) =  Z2 - Z
C
      ASQ = A(1)**2 + A(2)**2 + A(3)**2
      BSQ = B(1)**2 + B(2)**2 + B(3)**2
C
      AMAG = SQRT(ASQ)
      BMAG = SQRT(BSQ)
C
      U = 0.
      V = 0.
      W = 0.
C
C---- contribution from the transverse bound leg
      IF (LBOUND .AND.  AMAG*BMAG .NE. 0.0) THEN
        AXB(1) = A(2)*B(3) - A(3)*B(2)
        AXB(2) = A(3)*B(1) - A(1)*B(3)
        AXB(3) = A(1)*B(2) - A(2)*B(1)
C
        ADB = A(1)*B(1) + A(2)*B(2) + A(3)*B(3)
C
        DEN = AMAG*BMAG + ADB
C
        T = (1.0/AMAG + 1.0/BMAG) / DEN
C
        U = AXB(1)*T
        V = AXB(2)*T
        W = AXB(3)*T
      ENDIF
C
C---- trailing leg attached to A
      IF (AMAG .NE. 0.0) THEN
        AXISQ = A(3)**2 + A(2)**2
C
        ADI = A(1)
        RSQ = AXISQ
C
        T = - (1.0 - ADI/AMAG) / RSQ
C
        V = V + A(3)*T
        W = W - A(2)*T
      ENDIF
C
C---- trailing leg attached to B
      IF (BMAG .NE. 0.0) THEN
        BXISQ = B(3)**2 + B(2)**2
C
        BDI = B(1)
        RSQ = BXISQ
C
        T =   (1.0 - BDI/BMAG) / RSQ
C
        V = V + B(3)*T
        W = W - B(2)*T
      ENDIF
C
      U = U*PI4INV / BETA
      V = V*PI4INV 
      W = W*PI4INV 
C
      RETURN
      END ! VORVEL
