
      subroutine wingpo(b,bs,bo,
     &                  lambdat,lambdas,gammat,gammas,
     &                  AR,N,W,Lhtail,fLo,fLt,
     &                  po)
c------------------------------------------------------------
c     Calculates wing root loading po to balance 
c     net load  N*W - Lhtail
c------------------------------------------------------------
      implicit real (a-z)

      etao = bo/b
      etas = bs/b
     
      Kc = etao
     &   + 0.5*(1.0    +lambdas)*(etas-etao)
     &   + 0.5*(lambdas+lambdat)*(1.0 -etas)

      Ko = 1.0/(AR*Kc)

      Kp = etao
     &   + 0.5*(1.0    +gammas )*(etas-etao)
     &   + 0.5*(gammas +gammat )*(1.0 -etas)
     &   + fLo*etao + 2.0*fLt*Ko*gammat*lambdat

      po = (N*W - Lhtail)/(Kp*b)

      return
      end ! wingpo


      subroutine wingcl(b,bs,bo,
     &                  lambdat,lambdas,gammat,gammas,
     &                  sweep,AR,CL,CLhtail,fLo,fLt,
     &                  duo,dus,dut,
     &                  clo,cls,clt)
c------------------------------------------------------------
c     Calculates section cl at  eta = etao,etas,1
c------------------------------------------------------------
      implicit real (a-z)
      data pi / 3.1415926535897932384626 /

      cosL = cos(sweep*pi/180.0)

      etao = bo/b
      etas = bs/b
     
      Kc = etao
     &   + 0.5*(1.0    +lambdas)*(etas-etao)
     &   + 0.5*(lambdas+lambdat)*(1.0 -etas)

      Ko = 1.0/(AR*Kc)

      Kp = etao
     &   + 0.5*(1.0    +gammas )*(etas-etao)
     &   + 0.5*(gammas +gammat )*(1.0 -etas)
     &   + fLo*etao + 2.0*fLt*Ko*gammat*lambdat

      cl1 = (CL-CLhtail)/cosL**2 * (Kc/Kp)

      clo = cl1                / (1.0+duo)**2
      cls = cl1*gammas/lambdas / (1.0+dus)**2
      clt = cl1*gammat/lambdat / (1.0+dut)**2

      return
      end ! wingcl

