
      subroutine wingsc(W,CL,qinf,AR,etasi,bo,lambdat,lambdas,
     &                  S,b,bs,co)
c-------------------------------------------------------
c     Sets wing area, span, root chord 
c     to be consistent with q,CL,weight,AR
c-------------------------------------------------------
      implicit real (a-z)

      S = W/(qinf*CL)
      b = sqrt(S*AR)

      bs = max( b*etasi , bo )

      etao = bo/b
      etas = bs/b

      Kc = etao
     &   + 0.5*(1.0    +lambdas)*(etas-etao)
     &   + 0.5*(lambdas+lambdat)*(1.0 -etas)

      co = S/(Kc*b)

      return
      end ! wingsc



      subroutine wingAc(W,CL,qinf,AR,etasi,bo,lambdat,lambdas,
     &                  S,b,bs,co)
c-------------------------------------------------------
c     Sets wing area, AR, root chord 
c     to be consistent with q,CL,weight,span
c-------------------------------------------------------
      implicit real (a-z)

      S = W/(qinf*CL)

      etao = bo/b
      etas = bs/b

      Kc = etao
     &   + 0.5*(1.0    +lambdas)*(etas-etao)
     &   + 0.5*(lambdas+lambdat)*(1.0 -etas)

      co = S/(Kc*b)

      AR = b**2 / S

      return
      end ! wingAc


